<?php
/**
 * File: $Id: install.php,v 1.43 2005/05/12 17:35:45 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @Author: Half-Dead
 *
 * License Type   : LGPL: See /manual/LICENSES/LGPL.txt
 *
 */

include_once('include/functions.php');

/**
 * Description
 * @param type $var description
 * @return type description
 */
function welcome()
{
    global $sys_request;

    $lang ='english';
    if ( $_COOKIE['lang'] ) {
        $lang = $_COOKIE['lang'];
    }
    echo "
        <div align='center'>
        <h4>".sprintf(_INSTALL_W_WELCOME, 'Ciamos '.$sys_version)."</h4>";
    readfile(WIZ_PATH.'/language/'.$lang.'/main.html');
    echo " </div>
        <br />
        <table align='center' width='100%'>
            <tr>
                <td align='center'>"._INSTALL_W_CHOOSELANG."<br />
                    <form action='install.php' method='post'>
                        <select class='select' name='lang'>";

    include_once("../class/syslists.php");
    $langarr = SysLists::getDirListAsArray("./language/");
    foreach ( $langarr as $lang ) {
        echo "          <option value='".$lang."'>".$lang."</option>";
    }
    echo "
                        </select>
                        <input type='hidden' name='op' value='setupcheck' />
                        <input type='submit' class='button' value='"._NEXT."' />
                    </form>
                </td>
            </tr>
        </table>";
}

/**
 * Description
 * @param type $var description
 * @return type description
 */
function setupCheck()
{
    global $sys_request;

    $checks = array();
    @chmod("../mainfile.php", 0666);

    /**
     * Check mainfile.php exists and is writable
     */
    if ( @is_writable("../mainfile.php") ) {
        $checks[] = _INSTALL_ST_MAINFILE_OK;
    } else {
        $checks[] = _INSTALL_ST_MAINFILE_BAD;
    }
    /**
     * Check mysql exists and is version 3.23.0 or higher
     */
    if ( !function_exists('mysql_get_client_info') ) {
        $checks[] = sprintf(_INSTALL_ST_MYSQL_BAD2);
    } else {
        if ( checkVersion('4.0.0', mysql_get_client_info()) )  {
            $checks[] = sprintf(_INSTALL_ST_MYSQL_OK, mysql_get_client_info());
        } else {
            $checks[] = printf(_INSTALL_ST_MYSQL_BAD, mysql_get_client_info());
        }
    }
    /**
     * Check if register globals are on or off (either is OK)
     */
    if ( ini_get('register_globals') ) {
        $checks[] =  _INSTALL_ST_GLOBALS_OK;
    } else {
        $checks[] =  _INSTALL_ST_GLOBALS_BAD;
    }
    /**
     * Check if PHP is version 4.1.0 or higher
     */
    if ( checkVersion('4.1.0', phpversion()) ) {
        $checks[] = sprintf(_INSTALL_ST_PHP_OK, phpversion());
    } else {
        $checks[] = printf(_INSTALL_ST_PHP_BAD, phpversion());
    }

    /**
     * Check location of 'modules folder'
     */
    if ( $dir = @opendir(SYS_ROOT_PATH) ) {
        $folders[] = SYS_ROOT_PATH;
        while ( ($file = readdir($dir)) !== false ) {
            if ( is_dir(SYS_ROOT_PATH."/".$file) && $file != "." && $file != ".." ) {
                $folders = array_merge((array)$folders, (array)$file);
            }
        }
        closedir($dir);
    }
    $sysfolders = array ('.', '_install', 'admin', 'blocks', 'cache', 'class', 'images',
    'include', 'language', 'manual', 'sql', 'themes');
    $modfolders = array_values(array_diff($folders, $sysfolders));
    foreach ( $modfolders as $modfolder ) {
        if ( file_exists(SYS_ROOT_PATH."/".$modfolder."/system/version.php") ) {
            $sysmodfolder[] = $modfolder;
        }
    }
    switch ( count($sysmodfolder) ) {
        case 0:
        $checks[] = printf(_INSTALL_ST_MFOLDER_BAD1);
        break;

        case 1:
        $checks[] = sprintf(_INSTALL_ST_MFOLDER_OK, $modfolder);
        break;

        default:
        $checks[] = printf(_INSTALL_ST_MFOLDER_BAD2);
    }
    echo "
        <div align='left'><h3>"._INSTALL_ST_TESTS."</h3></div><div align='left'>";
    foreach ( $checks as $value ) {
        echo "$value<br />";
    }
    echo "</div>
        <div align='right'><a href='./include/php_info.php' target='_blank'>"._INSTALL_PHPINFO."</a> <img src='images/info.gif' alt='PHP INFO' align='middle'  /></div>
        <form action='./install.php' method='post'>
            <input type='hidden' name='op' value='dbform'>
            <input type='text' name='modfolder' value='$sysmodfolder[0]'>
            <div align='center'>"._INSTALL_ST_NEXT."
                <input type='submit' class='button' name='submit' value='"._NEXT."'>
            </div>
        </form>";
}

/**
 * Description
 * @param type $var description
 * @return type description
 */
function dbdata()
{
    global $sys_request;

    if ( isset($sys_request['root_path']) ) {
        $root_path    = $sys_request['root_path'];
    } else {
        $root_path    = SYS_ROOT_PATH;
    }
    if ( isset($sys_request['SYS_ROOT_URL']) ) {
        $SYS_ROOT_URL = $sys_request['SYS_ROOT_URL'];
    } else {
        $SYS_ROOT_URL = SYS_ROOT_URL;
    }
    if( !isset($sys_request['modfolder'])
           || empty($sys_request['modfolder'])
           || !is_dir('../'.$sys_request['modfolder']) ) {
        $error[] = sprintf(_INSTALL_DF_PLEASE_ENTER, "<b>"._INSTALL_DF_FOLDER."</b>");
    } else
    if ( isset($sys_request['modfolder']) ) {
        $modfolder   = $sys_request['modfolder'];
    } else {
        $modfolder    = "modules";
    }
    if ( isset($sys_request['dbhost']) ) {
        $dbhost       = $sys_request['dbhost'];
    } else {
        $dbhost       = "localhost";
    }
    if ( isset($sys_request['dbpass']) ) {
        $dbpass       = $sys_request['dbpass'];
    } else {
        $dbpass       = "";
    }
    if ( isset($sys_request['dbname']) ) {
        $dbname       = $sys_request['dbname'];
    } else {
        $dbname       = "";
    }
    if ( isset($sys_request['prefix']) ) {
        $prefix       = $sys_request['prefix'];
    } else {
        $prefix       = "ciamos";
    }
    if ( isset($sys_request['dbuname']) ) {
        $dbuname      = $sys_request['dbuname'];
    } else {
        $dbuname      = "root";
    }
    if ( isset($sys_request['database']) ) {
        $database     = $sys_request['database'];
    } else {
        $database     = "mysql";
    }
    if ( isset($sys_request['db_pconnect']) ) {
        $db_pconnect  = $sys_request['db_pconnect'];
    } else {
        $db_pconnect  = false;
    }

    if ( !empty($error) ) {
        echo "  <div align='center'><h5>"._INSTALL_DF_ERRORS."</h5>";
        foreach ( $error as $err ) {
            echo "<span style='color:#ff0000;'>".$err."</span></div>";
        }

        $msg    = "&nbsp;";
        $op     = "setupcheck";
        $submit = _GOBACK;

    echo "<form action='./install.php' method='post'>
        <div align='center'>".$msg."
        <input type='hidden' name='op' value='".$op."'>
        <input type='submit' class='button' name='submit' value='".$submit."'>
        </div>
        </form>";
    } else {

    include_once("../class/module.textsanitizer.php");

    $myts = new MyTextSanitizer;

    $root_path      = $myts->makeTboxData4PreviewInForm($root_path);
    $SYS_ROOT_URL   = $myts->makeTboxData4PreviewInForm($SYS_ROOT_URL);
    $modfolder      = $myts->makeTboxData4PreviewInForm($modfolder);
    $dbhost         = $myts->makeTboxData4PreviewInForm($dbhost);
    $dbpass         = $myts->makeTboxData4PreviewInForm($dbpass);
    $dbname         = $myts->makeTboxData4PreviewInForm($dbname);
    $prefix         = $myts->makeTboxData4PreviewInForm($prefix);
    $dbuname        = $myts->makeTboxData4PreviewInForm($dbuname);
    $database       = $myts->makeTboxData4PreviewInForm($database);
    $db_pconnect    = intval($db_pconnect);

    include_once("../class/sysformloader.php");
    include_once("./include/dbform.php");
    }
}

/**
* Description
* @param type $var description
* @return type description
*/
function confirmDb()
{
    global $sys_request;

    include_once("../class/module.textsanitizer.php");

    $myts = new MyTextSanitizer;

    $error = array();

    if ( empty($sys_request['dbhost']) ) {
        $error[] = sprintf(_INSTALL_DF_PLEASE_ENTER, "<b>"._INSTALL_DF_HOST."</b>");
    }

    if ( empty($sys_request['dbname']) ) {
        $error[] = sprintf(_INSTALL_DF_PLEASE_ENTER, "<b>"._INSTALL_DF_DBNAME."</b>");
    }

    if ( empty($sys_request['prefix']) ) {
        $error[] = sprintf(_INSTALL_DF_PLEASE_ENTER, "<b>"._INSTALL_DF_PREFIX."</b>");
    }

    if ( empty($sys_request['root_path']) || @!is_dir($sys_request['root_path']) ) {
        $error[] = sprintf(_INSTALL_DF_PLEASE_ENTER, "<b>"._INSTALL_DF_PATH."</b>");
    }

    if ( !preg_match("/^http[s]?:\/\/+.{6}/i", $sys_request['SYS_ROOT_URL']) ) {
        $error[] = sprintf(_INSTALL_DF_PLEASE_ENTER, "<b>"._INSTALL_DF_URL."</b>");
    }

    echo "<form action='./install.php' method='post'>";

    if ( !empty($error) ) {
        echo "  <div align='center'><h5>"._INSTALL_DF_ERRORS."</h5>";
        foreach ( $error as $err ) {
            echo "<span style='color:#ff0000;'>".$err."</span></div>";
        }

        $msg    = "&nbsp;";
        $op     = "dbform";
        $submit = _GOBACK;

    } else {
        if ( @!is_dir($sys_request['root_path']) ) {
            $msg    = _INSTALL_DF_BADROOT;
            $op     = "dbform";
            $submit = _GOBACK;

        } elseif( testDb() == 0 ) {
            $msg    = _INSTALL_DF_BADDB;
            $op     = "dbform";
            $submit = _GOBACK;

        } else {
            $msg    = _INSTALL_DF_OK;
            $op     = "writemainfile";
            $submit = _NEXT;
        }
    }

    echo "
        <div align='center'>".$msg."
        <input type='hidden' name='op' value='$op'>
        <input type='submit' class='button' name='submit' value='".$submit."'>
        <input type='hidden' name='modfolder'    value='".$myts->makeTboxData4PreviewInForm($sys_request['modfolder'])."' />
        <input type='hidden' name='database'     value='".$myts->makeTboxData4PreviewInForm($sys_request['database'])."' />
        <input type='hidden' name='dbhost'       value='".$myts->makeTboxData4PreviewInForm($sys_request['dbhost'])."' />
        <input type='hidden' name='dbuname'      value='".$myts->makeTboxData4PreviewInForm($sys_request['dbuname'])."' />
        <input type='hidden' name='dbpass'       value='".$myts->makeTboxData4PreviewInForm($sys_request['dbpass'])."' />
        <input type='hidden' name='dbname'       value='".$myts->makeTboxData4PreviewInForm($sys_request['dbname'])."' />
        <input type='hidden' name='prefix'       value='".$myts->makeTboxData4PreviewInForm($sys_request['prefix'])."' />
        <input type='hidden' name='db_pconnect'  value='".intval($sys_request['db_pconnect'])."' />
        <input type='hidden' name='root_path'    value='".$myts->makeTboxData4PreviewInForm($sys_request['root_path'])."' />
        <input type='hidden' name='SYS_ROOT_URL' value='".$myts->makeTboxData4PreviewInForm($sys_request['SYS_ROOT_URL'])."' />
        </div>
        </form>";
}


/**
 * @return boolean
 * @desc Check that database is accessible
 */
function testDb()
{
    global $sys_request;

    $return = false;
    if ( !empty($sys_request['prefix']) && !empty($sys_request['dbname']) ) {
        include_once(SYS_ROOT_PATH."/class/database/".$sys_request['database'].".php");
        $db = new Database();
        $db->setPrefix($sys_request['prefix']);
        @$db->connect($sys_request['dbhost'], $sys_request['dbuname'], $sys_request['dbpass']);
        if ( @$db->select_db($sys_request['dbname']) ) {
            $return = true;
        } elseif( @$db->query("CREATE DATABASE ".$sys_request['dbname']."")) {
            $return = true;
        }
    }
    return $return;
}


/**
 * @return void
 * @desc Enter description here...
 */
function writeMainfile()
{
    global $sys_request;

    include_once("../class/module.textsanitizer.php");

    $myts = new MyTextSanitizer();

    $base_url = $sys_request['SYS_ROOT_URL'];
    $base_url = str_replace('\\', '/', $base_url);
    if ( substr($base_url, -1) == '/') {
        $base_url = substr($base_url, 0, -1);
    }

    $base_path = $sys_request['root_path'];
    $base_path = str_replace('\\', '/', $base_path);
    if ( substr($base_path, -1) == '/') {
        $base_path = substr($base_path, 0, -1);
    }

    if ( !empty($_COOKIE['lang']) ) {
        $language = $_COOKIE['lang'];
    } else {
        $language = 'english';
    }

    include_once('include/mainfile.inc.php');

    if ( !$file = fopen('../mainfile.php', 'w') ) {
        echo _INSTALL_MF_FAILOPEN;
        wizFooter();
        exit();
    }

    if ( fwrite($file, $content) == -1 ) {
        echo _INSTALL_MF_FAILWRITE;
        fclose($file);
        wizFooter();
        exit();
    }

    echo "
        <form action='./install.php' method='post'>
        <input type='hidden' name='op' value='adminsetup'>
        <div align='center'>
        "._INSTALL_MF_WRITEOK."
        <input type='submit' class='button' name='submit' value='"._NEXT."'>
        </div>
        </form>";
}


/**
 * @return void
 * @desc Enter description here...
*/
function adminSetup()
{
    global $sys_request;

    include_once("../class/module.textsanitizer.php");
    $myts = new MyTextSanitizer();
    echo "
        <div align='center'>
            <h4>"._INSTALL_AD_MSG."</h4>
        </div>
        <br />
        <form action='./install.php' method='post'>
        <table align='center'>
            <tr>
                <td>"._INSTALL_AD_UNAME."</td>
                <td>
                    <input type='text' class='text' name='uname'
                        value='".$myts->makeTboxData4PreviewInForm($sys_request['uname'])."'>
                </td>
            </tr>
            <tr>
                <td>"._INSTALL_AD_EMAIL."</td>
                <td>
                    <input type='text' class='text' name='email'
                        value='".$myts->makeTboxData4PreviewInForm($sys_request['email'])."'>
                </td>
            </tr>
            <tr>
                <td>"._INSTALL_AD_PASS."</td>
                <td>
                    <input type='password' class='text' name='password'
                        value='".$myts->makeTboxData4PreviewInForm($sys_request['password'])."'>
                </td>
            </tr>
            <tr>
                <td colspan='2' align='center'>
                    <input type='submit' class='button' name='submit'
                        value='"._NEXT."'>
                    <input type='hidden' name='op' value='install_tables'>
                <td>
            </tr>
        </table>
        </form>";
}


/**
 * @return boolean
 * @desc Validate Admin password, e-mail etc.
 */
function adminCheck()
{
    global $sys_request, $sysConfig;

    $return = true;
    if ( !checkEmail($sys_request['email']) ) {
        $errors[] = _INSTALL_AD_BADEMAIL;
    }

    if ( strlen($sys_request['password']) < $sysConfig['minpass'] ) {
        $errors[] = sprintf(_INSTALL_AD_BADPASS, $sysConfig['minpass']);
    }

    if ( empty($sys_request['uname'])
            || preg_match("/[^a-z0-9_-]/i", $sys_request['uname']) ) {
        $errors[] = _INSTALL_AD_BADUNAME;
    }

    if ( is_array($errors) ) {
        foreach ( $errors as $val ) {
            echo "<br /><b>$val</b>";
        }
        $return = false;
    }
    return $return;
}


/**
 * @return unknown
 * @desc Enter description here...
 */
function installTables()
{
    global $sys_request, $db, $myts, $sysConfig;

    include_once("../include/sql_parse.php");

    $sql_file = $sysConfig['database'].'.sql';

    $sql = join('', file('./sql/'.$sql_file));
    $sql = removeSqlRemarks($sql);
    $sql = splitSqlFile($sql, ';');

    foreach ( $sql as $value ) {
        if ( $result = prefixQuery($value, $db->prefix) ) {
            if ( !$db->query($result[0]) ) {
                uninstallTables();
                return false;
            }
        }
    }

    $regdate  = time();
    $uname    = $myts->makeTboxData4Save($sys_request['uname']);
    $email    = $myts->makeTboxData4Save($sys_request['email']);
    $password = md5($myts->makeTboxData4Save($sys_request['password']));
    $actkey   = substr(md5(makepass()), 0, 8);

    $sql = "
        UPDATE ".$db->prefix("users")."
            SET uname        ='$uname',
                email        ='$email',
                url          ='".SYS_ROOT_URL."/',
                user_regdate ='$regdate',
                pass         ='$password',
                actkey       ='$actkey',
                theme        ='".$sysConfig['default_theme']."',
                last_login   =$regdate
            WHERE uid = 1";

    if ( !$db->query($sql) ) {
        echo "Failed to create admin account, please login with the default values: Admin/admin";
        return false;
    }
    return true;
}


/**
 * @return void
 * @desc Uninstalls database tables in table_list.txt
 */
function uninstallTables()
{
    global $db;

    $tables = file("./cfg/table_list.txt");
    $size   = count($tables);

    for ( $i = 0; $i < $size; $i++ ) {
        $table = trim($tables[$i]);
        if ( !empty($table) ) {
            $db->query("DROP TABLE IF EXISTS ".$db->prefix($table)."");
        }
    }
}


/**
 * @return boolean
 * @param string $file
 * @param string $value
 * @param string $type
 * @desc Enter description here...
 */
function doChmod($file, $value, $type='chmod')
{
    switch ( $type ) {
        case 'ftp':
        break;

        default:
        @chmod($file, $value);
    }
    $return = true;
    if ( ( $value == 0666 || $value == 0777 ) && !is_writable($file) ) {
        $return = false;
    }
    return $return;
}


/**
 * @return void
 * @desc Enter description here...
 */
function finishInstall()
{
    echo "  <div align='center'>
                    <h4>"._INSTALL_F_CONGRAT."</h4>
                </div>
                <div align='center'>
                    ".sprintf(_INSTALL_F_VISIT, SYS_ROOT_URL)."
                </div>";
    include_once("./cfg/chmod_list.php");
    include_once(SYS_ROOT_PATH."/class/syslists.php");
    $chmod_files = array();
    $size = count($_chmod);
    for ( $i = 0; $i < $size; $i++ ) {
        if ( !@doChmod(SYS_ROOT_PATH.'/'.$_chmod[$i]['base'], $_chmod[$i]['baseval']) ) {
            $result .= '
                <ul>
                    <li><span style="color:#ff0000;">'.$_chmod[$i]['base'].'</span></li>
                </ul>
                <div>: 0'.decoct($_chmod[$i]['baseval']).'</div>';
            $chmod_files[SYS_ROOT_PATH.'/'.$_chmod[$i]['base']] = $_chmod[$i]['baseval'];
        }
        if ( $_chmod[$i]['extval'] ) {
            $images = SysLists::getImgListAsArray(SYS_ROOT_PATH.'/'.$_chmod[$i]['base'].'/');
            foreach ($images as $image) {
                if ( !doChmod(SYS_ROOT_PATH.'/'.$_chmod[$i]['base'].'/'.$image, $_chmod[$i]['extval']) ) {
                    $result .= '<ul><li><span style="color:#ff0000;">'.$_chmod[$i]['base'].'/'.$image.'</span></li></ul><div>: 0'.decoct($_chmod[$i]['extval']).'</div>';
                    $chmod_files[SYS_ROOT_PATH.'/'.$_chmod[$i]['base'].'/'.$image] = $_chmod[$i]['extval'];
                }
            }
        }
    }

    if ( !empty($chmod_files) ) {
        echo "<div><strong><"._INSTALL_F_CHMOD."></strong></div>
                <div>$result<br /><br /></div>
                <div><form action='include/chmod_save.php' method='post'>
                        "._INSTALL_F_CHMODMSG.":<br /><br />
                        <input type='hidden' name='files'
                            value='".urlencode(serialize($chmod_files))."'>
                            Windows: <input type='radio' class='radio' name='os' value='W'>
                            Unix:<input type='radio' class='radio' name='os' value='U' checked>
                        <input type='submit' class='button' name='submit' value='"._DOWNLOAD."'>
                </form></div>";
    }
}

/**
 * Description
 * @param type $var description
 * @return type description
 */
switch( $sys_request['op'] ) {

    case "setupcheck":
        setcookie("lang", $sys_request['lang'], time()+1800, "/");
        wizHeader('', 2);
        setupCheck();
        break;

    case "dbform":
        wizHeader('', 3);
        dbdata();
        break;

    case "dbconfirm":
        wizHeader('', 4);
        confirmDb();
        break;

    case "writemainfile":
        wizHeader('', 5);
        writeMainfile();
        break;

    case "adminsetup":
        wizHeader('', 6);
        adminSetup();
        break;

    case "install_tables":
        include_once("../mainfile.php");
        wizHeader('', 7);
        if ( !adminCheck() ) {
            adminSetup();
        } elseif ( !installTables() ) {
            echo "<br /><div align='center'><h4>"._INSTALL_DB_DBERROR."</h4>";
            printf(_INSTALL_DB_TRYAGAIN, "install.php");
            echo "</div><br /><br />";
        } else {
            finishInstall();
        }
        break;

    default:
        wizHeader('', 1);
        welcome();
        break;
}
wizFooter();
ob_end_flush();
?>
