<?php
/**
 * File: $Id: upgrade.php,v 1.25 2005/05/12 17:35:45 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author Half-Dead
 * @license LGPL: See /manual/LICENSES/LGPL.txt
 */

/**
 * @desc Set variable $test = true to print output and not execute changes.
 */
$test = false;

ob_start();
include_once('include/functions.php');

if ( empty($_POST['action']) ) {
    /**
     * Show Upgrade Select box
     */
    wizHeader(_UPDATE, 1);
    include_once('../class/syslists.php');
    $upgrade_options = SysLists::getDirListAsArray('upgrade/');

    echo "<div align='center'><br />".
        _INSTALL_U_CHOOSE."<br />
        <form method='post' action='upgrade.php'>
        <select class='select' name='action'>";
    foreach ( $upgrade_options as $key ) {
        echo "<option value='$key'>$key</option>";
    }
    echo "</select>
        <input type='submit' class='button' name='submit' value='"._SUBMIT."'>
        </form>
        ("._INSTALL_U_NOTE.")
        <br /><br />
        </div>";
} elseif ( $_POST['action'] != 'complete' ) {

    /**
     * Run upgrade package
     */
    include_once(SYS_ROOT_PATH.'/mainfile.php');

    /**
     * Ensure common.php is loaded even if mainfile is from another package
     */
    if ( defined(SYS_MAINFILE_INCLUDED) || defined(XOOPS_MAINFILE_INCLUDED) ) {
        include_once(SYS_ROOT_PATH.'/include/common.php');
    }

    $package = $_POST['action'];
    define("_UPGRADE_PATH", SYS_ROOT_PATH."/_install/upgrade/".$_POST['action']);
    define("_UPGRADE_URL", SYS_ROOT_URL."/_install/upgrade/".$_POST['action']);

    /**
     * Include language files
     */
    $language = 'english';
    if ( !empty($sysConfig['language']) ) {
        $language = $sysConfig['language'];
    }
    if ( file_exists(_UPGRADE_PATH.'/language/'.$language.'/main.php') ) {
        include_once(_UPGRADE_PATH.'/language/'.$language.'/main.php');
    } elseif ( file_exists(_UPGRADE_PATH.'/language/english/main.php') ) {
        include_once(_UPGRADE_PATH.'/language/english/main.php');
    }

    /**
     * Display upgrade package Readme.txt
     */
    wizHeader(_UPGRADE_TITLE, 2);
    echo "<div style='text-align:center; font-weight:bold;'>"._UPGRADE_TITLE."</div><hr />";
    if ( file_exists(_UPGRADE_PATH.'/language/'.$language.'/readme.txt') ) {
         echo "<div align='center'>"
            .sprintf(_INSTALL_U_README, _UPGRADE_URL.'/language/'.$language.'/readme.txt').
            "</div><br /><br />";
    } elseif ( file_exists(_UPGRADE_PATH.'/language/english/readme.txt') ) {
        echo "<div align='center'>"
            .sprintf(_INSTALL_U_README, _UPGRADE_URL.'/language/english/readme.txt').
            "</div><br /><br />";
    }


    if ( empty($_POST['upgrade']) ) {
        if ( file_exists(_UPGRADE_PATH.'/language/'.$sysConfig['language'].'/main.html') ) {
            readfile(_UPGRADE_PATH.'/language/'.$sysConfig['language'].'/main.html');
        } elseif ( file_exists(_UPGRADE_PATH.'/language/english/main.html') ) {
            readfile(_UPGRADE_PATH.'/language/english/main.html');
        }

        ?>
        <div align="center">
        <form method="post" action="upgrade.php">
        <input type="hidden" name="action" value="<?php echo $package;?>">
        <input type="hidden" name="upgrade" value="1">
        <input type="submit" class="button" name="submit" value="Continue">
        </form>
        </div>
        <?php

    } else {
        /**
         * Process the upgrade
         */
        error_reporting(2039);
        $upgrade = array();
        include_once(_UPGRADE_PATH.'/version.php');

        /**
         * Backup mainfile from current install
         */
        echo "<p style='font-weight:bold; color:blue;'>"._UPGRADE_MAINFILE."</p>";
        if ( $upgrade['mainfile'] ) {
            if ( $test ) {
                echo _UPGRADE_MFILEBACK."<br />";
            } else {
                @chmod(SYS_ROOT_PATH."/mainfile.php", 0777);
                @copy(SYS_ROOT_PATH."/mainfile.php", SYS_ROOT_PATH."/mainfile.back.php");
            }
            require_once(SYS_ROOT_PATH."/_install/include/mainfile.inc.php");
            /**
             * For security check that version of mainfile & Ciamos match
             */
            if ( $mainfile_version == $upgrade['to'] ) {
                echo _UPGRADE_TOVERSION." : ".$upgrade['to']."<br />";

                /**
                 * Include standard Ciamos mainfile.php
                 * set values from sys_request
                 * and write to mainfile.php
                 */
                if ( $test ) {
                    echo _UPGRADE_MFILETEST;
                    $mainfilename = SYS_ROOT_PATH.'/mainfile.test.php';
                } else {
                    $mainfilename = SYS_ROOT_PATH.'/mainfile.php';
                }
                if ( !$file = fopen($mainfilename, 'w') ) {
                    echo _INSTALL_MF_FAILOPEN;
                    wizFooter();
                    exit();
                }
                if ( fwrite($file, $content) == -1 ) {
                    echo _INSTALL_MF_FAILWRITE;
                    fclose($file);
                    wizFooter();
                    exit();
                }
                @chmod($mainfilename, 0655);

            } else {
                echo _UPGRADE_VERSIONERR."<br />";
                echo "Mainfile version : ".$mainfile_version."<br />";
                echo "Upgrade to : ".$upgrade['to']."<br />";
                wizFooter();
                exit();
            }
            echo "<p style='color:blue;'>- "._UPGRADE_COMPLETE."</p><hr />";
        } else {
            echo "<p style='color:blue;'>- "._UPGRADE_NOTREQD."</p><hr />";
        }

        /**
         * Execute SQL changes
         */
        echo "<p style='font-weight:bold; color:blue;'>"._UPGRADE_DB."</p>";
        if ( $upgrade['sql'] ) {
            $sql = array();
            require_once(_UPGRADE_PATH.'/sql.php');

            foreach ( $sql_update as $sql ) {
                if ( $test ) {
                    echo $sql; echo "<br />";
                } else {
                    $db->query($sql) or print("<li>".$db->error()."</li><br />");$error=true;
                }
            }
            echo "<p style='color:blue;'>- "._UPGRADE_COMPLETE."</p><hr />";
        } else {
            echo "<p style='color:blue;'>- "._UPGRADE_NOTREQD."</p><hr />";
        }

        /**
         * Now update the modules
         */
        echo "<p style='font-weight:bold; color:blue;'>"._UPGRADE_MODULES."</p>";
        if ( $upgrade['sql'] ) {
            include_once(SYS_ROOT_PATH."/class/sysmodule.php");
            $modules =& SysModule::getInstalledModules();
            $mod_update = array();
            require_once(_UPGRADE_PATH.'/modules.php');
            foreach ( $modules as $module ) {
                if ( in_array($module->name, (array)$mod_update) ) {
                    if ( $test ) {
                        echo $module->name."<br />";
                    } else {
                        @$module->update();
                    }
                }
            }
            echo "<p style='color:blue;'>- "._UPGRADE_COMPLETE."</p><hr />";
        } else {
            echo "<p style='color:blue;'>- "._UPGRADE_NOTREQD."</p><hr />";
        }

        /**
         * Delete unwanted files
         */
        echo "<p style='font-weight:bold; color:blue;'>"._UPGRADE_DELFILES."</p>";
        if ( $upgrade['delete'] ) {
            $delete[] = array();
            require_once(_UPGRADE_PATH.'/delete.php');
            foreach ( $delete as $file ) {
                if ( file_exists($file) ) {
                    if ( $test ) {
                        echo _DELETE." : ".$file;
                    } else {
                        @chmod($file, 0777);
                        @unlink($file);
                    }
                } else {
                    echo _UPGRADE_NOFILE." : $file<br />";
                }
            }
            echo "<p style='color:blue;'>- "._UPGRADE_COMPLETE."</p><hr />";
        } else {
            echo "<p style='color:blue;'>- "._UPGRADE_NOTREQD."</p><hr />";
        }
    }
    /**
     * Finished - show completion message
     */
        ?>
        <div align="center">
        <form method="post" action="upgrade.php">
        <input type="hidden" name="action" value="complete">
        <input type="hidden" name="upgrade" value="1">
        <input type="submit" class="button" name="submit" value="Continue">
        </form>
        </div>
        <?php
} else {
    include_once(SYS_ROOT_PATH.'/mainfile.php');
    redirectHeader(SYS_MOD_URL.'/news/', 2, _INSTALL_F_CONGRAT);
}

wizFooter();
ob_end_flush();
?>