<?php
/**
 * File: $Id: datatree.php,v 1.38 2005/05/14 18:15:26 greyhead Exp $
 * Ciamos - Content Management System
 * This class is a replacement for the old tree and topic way...
 *
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_xxx
 * @link link to information for the subpackage
 * @author Florian Solcher (alphalogic) (@link http://www.alphalogic.org)
 *
 */

Class DataTree
{
    var $table;
    var $pid_field  = 'topic_pid';
    var $cid_field  = 'topic_id';
    var $img_url    = 'topic_imgurl';
    var $type;
    var $id_cache   = array();

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function DataTree ($mid = '', $load = true, $type = 'viewer')
    {
        global $db;

        $this->table = $db->prefix('topics');
        $this->type  = $type;
        if ( $load ) {
            $this->load($mid);
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function load($mid='')
    {
        global $topic_cache, $sysUser;
        /**
         * NB $topic_cache is set when common.php is loaded
         */

        /**
         * Turn the db content into an array
         */
        if ( $sysUser ) {
            $groups = $sysUser->groups();
        } else {
            $groups = SysGroup::getByType('Anonymous');
        }
        $init_array = array();
        foreach ( $topic_cache->listItems() as $array ) {
            $add = false;
            if ( in_array(1, $groups) ) {
                $add = true;
            } else {
                foreach ( $groups as $value ) {
                    if ( count(array_diff($groups, explode('|', $array['topic_'.$this->type]))) != count ($groups)) {
                        $add = true;
                    }
                }
            }
            if ( $mid ) {
                if ( !in_array($mid, explode('|', $array['topic_modules'])) ) {
                    $add = false;
                }
            }
            if ( $add ) {
                $this->id_cache[$array[$this->cid_field]] = $array;
            }
        }
    }

     /**
     * @return unknown
     * @desc Enter description here...
     */
    function makeTopic($data)
    {
        global $db;

        if ( count($this->id_cache) == 0 ) {
            $this->load();
        }
        if ( $data[$this->pid_field] != 0 && is_numeric($data[$this->pid_field]) ) {
            //topic is a child so lets check if the user has admin rights on the parent
            if( !$this->accessTopic($data[$this->pid_field]) ) {
                //no admin rights
                return false;
            }
        } elseif ($data[$this->pid_field] == 0) {
            // continue
        }
        $sql = '
           INSERT
               INTO '.$this->table.'
               SET ';
        //admin rights are given makeTopic allowed
        $i = 0;
        foreach ( $data as $fieldname => $content ) {
            //pid and title other content is set via modifyTopic
            $sql .= $fieldname." = '".$content."'";
            if ( ++$i < count($data) ) {
                $sql .=', ';
            }
        }
        if ( $db->query($sql) ) {
            return true;
        } else {
            return false;
        }
    }
    /**
     * @return unknown
     * @desc Enter description here...
     */
    function modifyTopic($data) {
        /*soon*/
    }
    /**
     * @return unknown
     * @desc Enter description here...
     */
    function deleteNode($id)
    {
        global $db, $sysmodule;

        if ( count($this->id_cache)>0 && is_numeric($id) ) {
            if ( $this->accessTopic($id) ) {
                //now we need to build a query
                $sqls   = array();
                $pid    = $this->getParentId($id);
                $sqls[] = '
                    DELETE 
                        FROM '.$this->table.' 
                        WHERE '.$this->cid_field.' = '.$id;
                $sqls[] = '
                    UPDATE '.$this->table.' 
                        SET '.$this->pid_field.'   = '.$pid.' 
                        WHERE '.$this->pid_field.' = '.$id;
                foreach ( $sqls as $sql ) {
                    if ( !$db->query($sql) ) {
                        return false;
                    }
                }
                //we need the dirs and the mids
                $mids   = SysModule::getHasTopicsModulesList();
                $dirs   = SysModule::getHasTopicsModulesList(true);
                //handle description
                $desc   = false;
                $descs  = array();
                foreach ( $mids as $name => $mid ) {
                    if ( $desc != $this->getTopicDescriptionFilename($id, $mid) &&
                           $this->getTopicDescriptionFilename($id, $mid)) {
                        $desc       = $this->getTopicDescriptionFilename($id, $mid);
                        $descs[]    = $desc;
                    }
                }
                foreach ( $descs as $desc ) {
                    unlink($desc);
                }
                //handle images
                $image  = false;
                $images = array();
                foreach ( $mids as $name => $mid ) {
                    if ( $image != $this->getTopicImageFilename($this->id_cache[$id]['topic_imgurl'], $mid)
                            && $this->getTopicImageFilename($this->id_cache[$id]['topic_imgurl'], $mid)) {
                        $image      = $this->getTopicImageFilename($this->id_cache[$id]['topic_imgurl'], $mid);
                        $images[]   = $image;
                    }
                }
                foreach ( $images as $image ) {
                    unlink($image);
                }
                //handle modules' content
                $topic_del_parent = array();
                $topic_move_child = array();
                foreach ( $dirs as $dirname => $name ) {
                    include_once(SYS_ROOT_PATH.'/modules/'.$dirname.'/include/topics.inc.php');
                }
                if ( $pid == 0 ) {
                    foreach ($topic_del_parent as $sql) {
                        $db->query($sql);
                    }
                } else {
                    foreach ($topic_move-child as $sql) {
                        $db->query($sql);
                    }
                }
            } else {
                //topic does not exits or there is no admin acess right
                return false;
            }
        } elseif (count($this->id_cache)==0 && is_numeric($id)) {
            //topic tree not loaded
            $this->load();
            $this->deleteNode($id);
        } else {
            //no id given
            return false;
        }
        return true;
    }

    /**
     * Returns an array of all topic IDs
     *
     * @return array
     */
    function getAllIDs()
    {
        $return = array();
        foreach ( $this->id_cache as $key => $value ) {
            $return[] = $key;
        }
        return $return;
    }

    /**
     * returns an array of first child objects for a given id($sel_id)
     *
     * @param type $var description
     * @return type description
     */
    function getFirstChild($pid, $order='')
    {
        $arr = array();
        foreach ( $this->id_cache as $key => $array ) {
            if ( $array[$this->pid_field] == $pid ) {
                $arr[] = $array;
            }
        }
        return $arr;
    }

    /**
     * returns an array of all FIRST child ids of a given id($sel_id)
     *
     * @param type $var description
     * @return type description
     */
    function getFirstChildId($pid)
    {
        $arr = array();
        foreach ( $this->id_cache as $cid => $array ) {
            if ( $array[$this->pid_field] == $pid ) {
                $arr[] = $cid;
            }
        }
        return $arr;
    }

    /**
     * returns an array of ALL child ids for a given id($sel_id)
     *
     * @param type $var description
     * @return type description
     */
    function getAllChildId($pid, $order='', $idarray = array())
    {
        $my_array = $this->getFirstChildId($pid);
        foreach ( $my_array as $cid ) {
            $idarray[] = $cid;
            $idarray   = $this->getAllChildId($cid, '',$idarray);
        }
        return $idarray;
    }

    /**
     * returns an array of ALL child ids for a given id($sel_id)
     *
     * @param type $var description
     * @return type description
     */
    function getAllChildsArray($pid, $order='', $idarray = array())
    {
        $my_array = $this->getFirstChildId($pid);
        foreach ( $my_array as $cid ) {
            $idarray[] = $content;
            $idarray   = $this->getAllChildId($cid, '',$idarray);
        }
        return $idarray;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getAllParentsForArray($id, $ret=array())
    {
        $parentid = $this->id_cache[$id][$this->pid_field];
        $ret[] = $this->id_cache[$id];
        if ( !$parentid ) {
            $return = $ret;
        } else {
            $return = $this->getAllParentsForArray($parentid, $ret);
        }
        return $return;
    }
    
    /**
     * Gets info for all parents of $id (but not $id)
     *
     * @param integer $id
     * @param array $return recursive data collector
     * @return array of info arrays for parent topics
     */
    function getOnlyParentsForArray($id, $return=array())
    {
        $parentid = $this->id_cache[$id][$this->pid_field];
        if ( $parentid ) {
            $return[] = $this->id_cache[$parentid];
            $return = $this->getOnlyParentsForArray($parentid, $return);
        }
        return $return;
    }


    /**
     * Enter description here...
     *
     * @param integer $id topic id
     * @return array of info for this topic and all its parents
     */
    function getAllParentsArray($id)
    {
        return array_reverse($this->getAllParentsForArray($id));
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getParentArray($pid=0)
    {
        $return = array();
        foreach ( $this->id_cache as $cid => $array ) {
            if ( $array[$this->pid_field] == $pid ) {
                $return[] = $array;
            }
        }
        return $return;
    }


    /**
     * Get the id of this topic's parent
     *
     * @param integer $id
     * @return array
     */
    function getParentId($id)
    {
        foreach ( $this->id_cache as $cid => $array ) {
            if ( $array[$this->cid_field] == $id ) {
                return $array[$this->pid_field];
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getSingleItem($cid)
    {
        if ( is_array($this->id_cache[$cid]) ) {
            return $this->id_cache[$cid];
        } else {
            return false;
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getTopicImage($imgurl='', $mid='')
    {
        global $sysModule;

        if ( $imgurl == '' ) {
            $imgurl = $this->topic_imgurl;
        }
        if ($mid == '') {
            $mid =$sysModule->mid();
        }
        if ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$mid.'.'.$imgurl) ) {
            return SYS_MOD_URL.'/system/cache/topics/'.$mid.'.'.$imgurl;
        } elseif ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$imgurl) ) {
            return  SYS_MOD_URL.'/system/cache/topics/'.$imgurl;
        } else {
            return false;
        }

    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getTopicImageFilename($imgurl='', $mid='')
    {
        global $sysModule;

        if ( !$imgurl ) {
            $imgurl = $this->topic_imgurl;
        }
        if ( !$mid ) {
            $mid =$sysModule->mid();
        }
        if ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$mid.'.'.$imgurl) ) {
            return SYS_MOD_PATH.'/system/cache/topics/'.$mid.'.'.$imgurl;
        } elseif ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$imgurl) ) {
            return  SYS_MOD_PATH.'/system/cache/topics/'.$imgurl;
        } else {
            return false;
        }

    }

    /**
     * Used to get the name of a
     * topic through its id
     *
     * @param type $var description
     * @return type description
     */
    function getTopicIdName($topic_id=0)
    {
        global $db, $myts;

        $sql = "
            SELECT topic_title 
                FROM ".$db->prefix("topics")." 
                WHERE topic_id = $topic_id";
        $result = $db->query($sql);
        list($return) = $db->fetch_row($result);

        return $return;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getTopicDescription($id='', $mid='')
    {
        global $sysModule;

        if ( $id == '' ) {
            $id = $this->topic_id;
        }
        if ($mid == '' && $sysModule->mid() != 1 ) {
            $mid =$sysModule->mid();
        }
        $filepath = SYS_MOD_PATH.'/system/cache/topics/';
        if ( is_file($filepath.$mid.'.'.$id.'.desc.php')) {
            $filename = $filepath.$mid.'.'.$id.'.desc.php';
            $handle   = fopen($filename, 'r');
            $return = stripslashes(fread($handle, filesize($filename)) );
        } elseif ( is_file($filepath.$id.'.desc.php')) {
            $filename =  $filepath.$id.'.desc.php';
            $handle   = fopen($filename, 'r');
            $return = stripslashes(fread($handle, filesize($filename)));
        } else {
            $return = _DESCRIPTION_NO;
        }
        return $return;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getTopicDescriptionFilename($id='', $mid='')
    {
        global $sysModule;

        if ( $id == '' ) {
            $id = $this->topic_id;
        }
        if ($mid == '' && $sysModule->mid() != 1 ) {
            $mid =$sysModule->mid();
        }
        $filepath = SYS_MOD_PATH.'/system/cache/topics/';
        if ( is_file($filepath.$mid.'.'.$id.'.desc.php')) {
            $filename = $filepath.$mid.'.'.$id.'.desc.php';
            return  $filename;
        } elseif ( is_file($filepath.$id.'.desc.php')) {
            $filename =  $filepath.$id.'.desc.php';
            return  $filename;
        } else {
            return false;
        }
    }


    /**
     * Check if topic exists
     *
     * @param integer $id
     * @return boolean
     */
    function accessTopic($id)
    {
        return array_key_exists($id, $this->id_cache);
    }

    /**
     * Updates topic access for modules admins & viewers
     *
     * @param array/string $modules module ids
     * @param array/string $viewer user ids
     * @param array/string $admins admin user ids
     */
    function setAccess($modules, $viewer, $admins)
    {
        if ( is_array($viewer) ) {
            foreach ($viewer as $key => $value) {
                $db_viewer .= intval($value);
                if ( count($viewer) != $key + 1 ) {
                    $db_viewer .=  '|';
                }
            }
            $this->topic_viewer  = $db_viewer;
        } elseif ( is_string($viewer) ) {
            $this->topic_viewer  = $viewer;
        } elseif ( !$viewer ) {
            $this->topic_viewer  = "";
        }
        if ( is_array($modules) ) {
            foreach ( $modules as $key => $value ) {
                $db_modules .= intval($value);
                if ( count($modules) != $key + 1 ) {
                    $db_modules .=  '|';
                }
            }
            $this->topic_modules = $db_modules;
        } elseif ( is_string($modules) ) {
            $this->topic_modules  = $modules;
        } elseif ( !$modules ) {
            $this->topic_modules  = "";
        }
        if ( is_array($admins) ) {
            foreach ($admins as $key => $value) {
                $db_admins .= intval($value);
                if ( count($admins) != $key + 1 ) {
                    $db_admins .=  '|';
                }
            }
            $this->topic_admins  = $db_admins;
        } elseif ( is_string($admins) ) {
            $this->topic_admins  = $admins;
        } elseif ( !$admins ) {
            $this->topic_admins  = "";
        }
    }

    /**
     * Set the image url of the current topic
     *
     * @param string $value
     */
    function setTopicImgurl($value)
    {
        $this->topic_imgurl = $value;
    }

    /**
     * Set the parent id of the current topic
     *
     * @param integer $value
     */
    function setTopicPid($value)
    {
        $this->topic_pid = $value;
    }

    /**
     * Set the id of the current topic
     *
     * @param integer $value
     */
    function setTopicId($value)
    {
        $this->topic_id = $value;
    }

    /**
     * Set the title of the current topic
     *
     * @param string $value
     */
    function setTopicTitle($value)
    {
        $this->topic_title = $value;
    }

    /**
     * @return unknown
     * @param unknown $mid
     * @desc Enter description here...
     */
    function store($mid='')
    {
        global $myts, $db;

        $title  = "";
        $imgurl = "";

        if ( isset($this->topic_title) && $this->topic_title != "" ) {
            $title = $myts->makeTboxData4Save($this->topic_title);
        }

        if ( isset($this->topic_imgurl) && $this->topic_imgurl != "" ) {
            $imgurl = $myts->makeTboxData4Save($this->topic_imgurl);
        }

        if ( !isset($this->topic_pid) || !is_numeric($this->topic_pid) ) {
            $this->topic_pid = 0;
        }

        if ( empty($this->topic_id) ) {
            $this->topic_id = $db->genId($this->table."_topic_id_seq");
            $sql = "
                INSERT
                    INTO ".$this->table."
                    SET topic_id        = ".$this->topic_id.",
                        topic_pid       = ".$this->topic_pid.",
                        topic_imgurl    = '".$imgurl."',
                        topic_title     = '".$title."',
                        topic_admins    = '".$this->topic_admins."',
                        topic_viewer    = '".$this->topic_viewer."',
                        topic_modules   = '".$this->topic_modules."'";
        } else {
            $sql = "
                UPDATE ".$this->table."
                    SET topic_pid       = ".$this->topic_pid.",
                        topic_imgurl    = '".$imgurl."',
                        topic_title     = '".$title."',
                        topic_admins    = '".$this->topic_admins."',
                        topic_viewer    = '".$this->topic_viewer."',
                        topic_modules   = '".$this->topic_modules."' 
                    WHERE topic_id = ".$this->topic_id;
        }
        if ( !$result = $db->query($sql) ) {
            ErrorHandler::show('0022');
        }
        if ( empty($this->topic_id) ) {
            $this->topic_id = $db->insert_id();
        }
        return true;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function contentQuery(
            $table,
            $requestedValues = '*',
            $where ='',
            $order='',
            $cidfield='cid',
            $limit='')
    {
        global $db;

        if ( count ($this->id_cache) == 0 ) {
            return array();
        }
        foreach ( $this->id_cache as $id => $val ) {
            $topicid[] = $id;
        }
        if ( $where != '' ) {
            $where =  ' WHERE '.$where.' AND ';
        } else {
            $where =  ' WHERE ';
        }
        $where .= "(".$cidfield."='".implode("' OR ".$cidfield."='", $topicid )."')";
        if ( $order != '' ) {
            $order =  ' ORDER BY '.$order.' ';
        } else {
            $order = '';
        }
        $sql = "
            SELECT ".$requestedValues."
                FROM ".$db->prefix($table).
                $where.
                $order." 
                LIMIT ". $limit;
        $array = array();
        $res = $db->query($sql);
        while ($res_arr = $db->fetch_array($res)) {
            $array [] = $res_arr;
        }
        return $array;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function contentQueryWUser(
            $table,
            $cidfield,
            $uidfield,
            $requestedValue = '*',
            $where='',
            $order,
            $limit='',
            $cid='')
    {
        global $db;

        if ( count ($this->id_cache) == 0 ) {
            return array();
        }
        foreach ( $this->id_cache as $id => $val ) {
            $topicid[] = $id;
        }
        $ex_requestedValue = explode(',', $requestedValue);
        $item = array();
        foreach ( $ex_requestedValue as $value ) {
            $item[] = 'c_table.'.trim($value);
        }
        $requestedValueT = $requestedValue;
        $requestedValue = implode(',', $item);
        $requestedValue .= ', u_table.*';
        if ( $where!='' ) {
            //format where string - missing
        }
        if ( $order!='' ) {
            //format order by string - missing
        }
        if ( $order != '' ) {
            $order = ' ORDER BY '.$order;
        }
        if ( $where != '') {
            $where = ' WHERE '.$where.' AND ';
        }
        if ( $cid=='' ) {
            $where .= "(c_table.".$cidfield."='".implode("' OR c_table.".$cidfield."='", $topicid )."') AND c_table.".$uidfield." = u_table.uid" ;
        } else {
            $where .= "c_table.".$cidfield."='".$cid."' ";
        }
        $limits = explode("LIMIT", $limit);
        if ( !isset($limits[1]) ) {
            $limit = " LIMIT ".$limit;
        }
        $from = "FROM ".$db->prefix($table)." as c_table, ".$db->prefix("users")." as u_table ";
        // $sql  = "SELECT ".$requestedValueT." ".$from.$where.$order.$limit;
        // "WHERE c_table.published > 0 AND c_table.".$cidfield."='".$topicid."' AND c_table.".$uidfield."='u_table.uid'
        $sql = "SELECT ".$requestedValueT." ".$from.$where.$order.$limit;

        $array = array();
        $res = $db->query($sql);
        while ( $res_arr = @$db->fetch_array($res) ) {
            $array[] = $res_arr;
        }
        return $array;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getChildTreeArray($pid=0, $order='', $parray = array(), $r_prefix='')
    {
        global $db;

        $array = $this->getFirstChild($pid);
        $count  = count($array);
        if ( $count == 0 ) {
            return $parray;
        }
        foreach ( $array as $item ) {
            $item['prefix'] = $r_prefix.'.';
            array_push($parray, $item);
            $parray = $this->getChildTreeArray($item[$this->cid_field], $order, $parray, $item['prefix']);
        }
        return $parray;
    }

    /**
     *  makes a nicely ordered selection box
     *
     * @param string  $order     Specify the sort order
     * @param string  $preset_id Specify a pre-selected item
     * @param boolean $none      Set to 1/true to add a option with value 0
     * @param string  $sel_name  The 'name 'for the selection box
     * @param string  $onchange  Action for the 'onchange' event
     * @param boolean $top_only  Show top level items only
     * @param integer $size      Set the size of the select box
     * @param boolean $multiple  Allow multiple selections
     * @return string Html to create a Topic Select box
     */
    function makeMySelBox($order='', $preset_id=0, $none=false, $sel_name='', 
        $onchange='', $top_only=false, $size=1, $multiple=false)
    {
        global $myts;

        $return = "";
        if ( $sel_name == '' ) {
            $sel_name = $this->cid_field;
        }
        $return .=  "<select class='select' name='$sel_name' size='$size'";
        if ( $multiple ) {
            $return .= "multiple='multiple'";
        }
        if ( $onchange ) {
            $return .=  " onchange='$onchange'";
        }
        $return .=  ">";
        /**
         * Get array of Main Topics
         */
        $array = $this->getParentArray();
        if ( $order != '' ) {
            $sql .= ' ORDER BY '.$order.'';
        }
        if ( $none ) {
            $return .=  "<option value='0'>----</option>";
        }
        foreach ( $array as $item ) {
            if ( $item['topic_id'] == $preset_id ) {
                $sel = " selected='selected'";
            }
            $return .=  "<option value='".$item['topic_id']."'$sel>".$item['topic_title']."</option>";
            if ( !$top_only ) {
                $sel = '';
                $arr = $this->getChildTreeArray($item['topic_id'], $order);
                foreach ( $arr as $option ) {
                    $option['prefix'] = str_replace('.', '--', $option['prefix']);
                    $catpath = $option['prefix'].' '.$myts->makeTboxData4Show($option['topic_title']);
                    if ( $option[$this->cid_field] == $preset_id ) {
                        $sel = " selected='selected'";
                    }
                    $return .= "<option value='".$option[$this->cid_field]."'$sel>$catpath</option>";
                    $sel = '';
                }
            }
        }
        $return .=  "</select>";
        return $return;
    }
}
?>
