<?php
/**
 * File: $Id: sysblock.php,v 1.24 2005/05/16 08:57:00 alphalogic Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_SYSBLOCK_INCLUDED") ) {
    return;
}
define("CIAMOS_SYSBLOCK_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/sysobject.php");
include_once(SYS_ROOT_PATH."/class/sysmodule.php");
include_once(SYS_ROOT_PATH."/class/sysgroup.php");

if ( !is_array($blockCache) ) {
    $blockCache = array();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
class SysBlock extends SysObject
{

    /**
     * @return SysBlock
     * @param unknown $id
     * @desc Enter description here...
     */
    function SysBlock($id = NULL)
    {

        $this->SysObject();
        $this->initVar("bid", "int", NULL, false);
        $this->initVar("mid", "int", 0, false);
        $this->initVar("func_num", "int", 0, false);
        $this->initVar("options", "textbox", NULL, false, 255, false);
        $this->initVar("name", "textbox", NULL, true, 150, false);
        $this->initVar("position", "int", 0, false);
        $this->initVar("title", "textbox", NULL, false, 150, false);
        $this->initVar("content", "textarea", NULL, false);
        $this->initVar("side", "int", 0, false);
        $this->initVar("weight", "int", 0, false);
        $this->initVar("visible", "int", 0, false);
        $this->initVar("TYPE", "other", NULL, false);
        $this->initVar("c_type", "other", NULL, false);
        $this->initVar("isactive", "int", NULL, false);
        $this->initVar("dirname", "textbox", NULL, false, 50);
        $this->initVar("func_file", "textbox", NULL, false, 50);
        $this->initVar("show_func", "textbox", NULL, false, 50);
        $this->initVar("edit_func", "textbox", NULL, false, 50);
        $this->initVar("design", "textbox", NULL, false, 20);
        $this->initVar("vis_mod", "textbox", NULL, false, 100);

        if ( !empty($id) ) {
            if ( is_array($id) ) {
                $this->set($id);
            } else {
                $this->load(intval($id));
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function load($id)
    {
        /*
        global $db;
        $sql = "
        SELECT *
        FROM ".$db->prefix("newblocks")."
        WHERE bid = ".intval($id)."";
        $arr = $db->fetch_array($db->query($sql));
        $this->set($arr);
         */
        global $block_cache;

        $this->set($block_cache->getItem(false, $id));
    }

    /**
     * @return unknown
     * @param unknown $type
     * @param unknown $title
     * @param unknown $content
     * @desc Enter description here...
     */
    function showBlock($type, $title, $content, $force=false)
    {
        global $blockCache, $sysModule, $blockLayout;

        if ( $this->getVar('vis_mod') != 'ALL' && !$force ) {
            if ( $sysModule ) {
                if ( !in_array($sysModule->mid(), explode('|', $this->getVar('vis_mod'))) ) return false;
            } else {
                if ( !in_array('sys', explode('|', $this->getVar('vis_mod'))) ) return false;
            }
        }
        if ( $this->getVar('design') != '' ) {
            $design = $this->getVar('design');
        } else {
            $design = 'standard';
        }
        // $design = $this->getVar('design');
        if ( $design == 'standard' ) {
            switch ($type) {
                
                case SYS_SIDEBLOCK_LEFT:
                $what     = $blockLayout['sideblockleft'];
                break;
                
                case SYS_SIDEBLOCK_RIGHT:
                $what     = $blockLayout['sideblockright'];
                break;
                
                case SYS_CENTERBLOCK_LEFT:
                $what     = $blockLayout['centerblockleft'];
                break;
                
                case SYS_CENTERBLOCK_RIGHT:
                $what     = $blockLayout['centerblockright'];
                break;
                
                case SYS_CENTERBLOCK_CENTER:
                $what     = $blockLayout['centerblockcenter'];
                break;
                
                case BLOCK_ABSOLUTETOP:
                $what     = $blockLayout['absolutetop'];
                break;
                
                case BLOCK_ABSOLUTEBOTTOM:
                $what     = $blockLayout['absolutebottom'];
                break;
            }
            $filename = SYS_THEME_PATH.'/blocks/standard/'.$what;
        } else {
            $filename = SYS_THEME_PATH.'/blocks/custom/'.$design;
        }
        $block_template = new SysTemplate($filename);
        $block_template -> setOutPutVar('title', $title);
        $block_template -> setOutPutVar('content', $content);
        $block_template -> setOutPutVar('theme', SYS_THEME_URL);
        return $block_template -> render();
        /*
        if ( !is_array($blockCache['blockdesign']) ) {
            $blockCache['blockdesign'] = array();
        }
        if ( !array_key_exists($what, $blockCache['blockdesign']) ) {
            $handle   = fopen($filename, 'r');
            $blockCache['blockdesign'][$what] = @fread($handle, filesize($filename));
        }
        $mydesign = $blockCache['blockdesign'][$what];
        if ( str_replace('{$title}', $title, $mydesign) ) {
            $ret = str_replace('{$title}', $title, $mydesign);
            $ret = str_replace('{$content}', $content, $ret);
            $ret = str_replace('{$theme}', SYS_THEME_URL, $ret);
            return $ret;
        }
        */
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function storeBlock()
    {
        global $db;

        if ( !$this->isCleaned() ) {
            if ( !$this->cleanVars() ) {
                return false;
            }
        }

        foreach ( $this->cleanVars as $k=>$v ) {
            $$k = $v;
        }

        if ( !$design ) {
            $design = 'standard';
        }
        if ( empty($bid) ) {
            $bid = $db->genId($db->prefix("blocks")."_bid_seq");
            $sql = "
                INSERT
                    INTO ".$db->prefix("newblocks")."
                    SET
                        bid       = '$bid',
                        mid       = '$mid',
                        func_num  = '$func_num',
                        options   = '$options',
                        name      = '$name',
                        position  = '$position',
                        title     = '$title',
                        content   = '$content',
                        side      = '$side',
                        weight    = '".intval($weight)."',
                        visible   = '".intval($visible)."',
                        TYPE      = '$type',
                        c_type    = '$c_type',
                        isactive  = 1,
                        dirname   = '$dirname',
                        func_file = '$func_file',
                        show_func = '$show_func',
                        edit_func = '$edit_func',
                        design    = '$design'";
        } else {
            $mods = SysModule :: getAllModulesList();
            $all =true;
            foreach ( $mods as $id => $name ) {
                if( !in_array($id, explode('|', $vis_mod))) {
                    $all =False;
                }
            }
            $sysadded = in_array('sys',  explode('|', $vis_mod));
            $all = $all && $sysadded;
            $sql = "
                UPDATE ".$db->prefix("newblocks")."
                    SET options='".$options."'";

            // a custom block needs its own name
            if ( $type == "C" ) {
                $sql .= ", name='".$name."'";
            }
            $sql .= ", position='".$position."', title='".$title."', content='".$content."', side='".$side."', weight='".intval($weight)."', visible='".intval($visible)."', c_type='".$c_type."', design='".$design."'";
            if ( $all ) {
                $sql .= ", vis_mod='ALL'";
            } else {
                $sql .= ", vis_mod='".$vis_mod."'";
            }
            $sql .= " WHERE bid='".intval($bid)."'";
        }
        if ( !$db->query($sql) ) {
            $this->setErrors("Could not save block data into database");
            return false;
        }
        if ( empty($bid) ) {
            $bid = $db->insert_id();
        }
        return $bid;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function delete()
    {
        global $db;

        $sql = "
            DELETE
                FROM ".$db->prefix("newblocks")."
                WHERE bid=".$this->getVar("bid")."";
        if ( !$db->query($sql) ) {
            return false;
        }
        $sql = "
            DELETE
                FROM ".$db->prefix("groups_blocks_link")."
                WHERE block_id=".$this->getVar("bid")."";
        $db->query($sql);

        return true;
    }

    /**
     * do stripslashes/htmlspecialchars according to the needed output
     *
     * @param $format      output use: S for Show and E for Edit
     * @param $c_type    type of block content
     * @returns string
     */
    function getContent($format = "S", $c_type = "T")
    {
        global $myts;

        switch ( $format ) {

            case "S":
            /**
             * check the type of content
             * H : custom HTML block
             * P : custom PHP block
             * S : use text sanitizer (smilies enabled)
             * T : use text sanitizer (smilies disabled)
             */
            switch ( $c_type ) {

                case "P":
                ob_start();
                print eval($this->getVar("content", "N"));
                $content = ob_get_contents();
                ob_end_clean();
                break;

                case "S":
                $content = $myts->makeTareaData4Show($this->getVar("content", "N"), 1, 1);
                break;

                case "H":
                default:
                $myts->setType('admin');
                $content = $myts->makeTareaData4Show($this->getVar("content", "N"));
                break;
            }
            $content = str_replace("{X_SITEURL}", SYS_ROOT_URL."/", $content);
            break;

            case "E":
            $content = $this->getVar("content", "E");
        }

        return $content;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function &buildBlock()
    {
        global $sysConfig;

        $block = array();
        // M for module block, S for system block C for Custom
        if ( $this->getVar("TYPE") != "C" ) {
            // get block display function
            $show_func = $this->getVar('show_func');
                        if ( !$show_func ) {
                return false;
            }
            // must get lang files b4 execution of the function
            if ( @file_exists(SYS_MOD_PATH."/".$this->getVar('dirname')."/blocks/".$this->getVar('func_file')) ) {
                if ( @file_exists(SYS_MOD_PATH."/".$this->getVar('dirname')."/language/".$sysConfig['language']."/global.php") ) {
                    include_once(SYS_MOD_PATH."/".$this->getVar('dirname')."/language/".$sysConfig['language']."/global.php");
                } elseif ( @file_exists(SYS_MOD_PATH."/".$this->getVar('dirname')."/language/english/global.php") ) {
                    include_once(SYS_MOD_PATH."/".$this->getVar('dirname')."/language/english/global.php");
                }
                // get the file where the function is defined
                include_once(SYS_MOD_PATH."/".$this->getVar('dirname')."/blocks/".$this->getVar('func_file'));
                $options = explode("|", $this->getVar("options"));
                if ( function_exists($show_func) ) {
                    // execute the function
                    $block = $show_func($options, SysModule :: getByDirname($this->getVar('dirname')));
                    if ( !$block ) {
                        return false;
                    }
                } else {
                    return false;
                }
                // align content if there is additional content in db
                $block['content'] = $this->buildContent($this->getVar("position"), $block['content'], $this->getContent("S",$this->getVar("c_type")));

                // replace title if there is additional title in db
                $block['title'] = $this->buildTitle($block['title'], $this->getVar("title"));
            } else {
                return false;
            }
        } else {
            // it is a custom block, so just return the contents
            // and title in db
            $block['title']   = $this->getVar("title");
            $block['content'] = $this->getContent("S", $this->getVar("c_type"));
        }
        return $block;
    }

    /**
     * Aligns the content of a block
     * If position is 0, content in DB is positioned
     * before the original content
     * If position is 1, content in DB is positioned
     * after the original content
     */
    function buildContent($position, $content="", $contentdb="")
    {
        if ( $position == 0 ) {
            $ret = $contentdb.$content;
        } elseif ( $position == 1 ) {
            $ret = $content.$contentdb;
        }
        return $ret;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function buildTitle($originaltitle, $newtitle="")
    {
        if ( $newtitle != "" ) {
            $ret = $newtitle;
        } else {
            $ret = $originaltitle;
        }
        return $ret;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function isCustom()
    {
        if ( $this->getVar("TYPE") == "C" ) {
            return true;
        }
        return false;
    }

    /**
     * gets html form for editing block options
     *
     * @param type $var description
     * @return type description
     */
    function getOptions()
    {
        global $sysConfig;

        if ( $this->getVar("TYPE") != "C" ) {
            $edit_func = $this->getVar('edit_func');
            if ( !$edit_func ) {
                return false;
            }
            if ( @file_exists(SYS_MOD_PATH."/".$this->getVar('dirname')."/blocks/".$this->getVar('func_file')) ) {
                if ( @file_exists(SYS_MOD_PATH."/".$this->getVar('dirname')."/language/".$sysConfig['language']."/global.php") ) {
                    include_once(SYS_MOD_PATH."/".$this->getVar('dirname')."/language/".$sysConfig['language']."/global.php");
                } elseif ( @file_exists(SYS_MOD_PATH."/".$this->getVar('dirname')."/language/english/global.php") ) {
                    include_once(SYS_MOD_PATH."/".$this->getVar('dirname')."/language/english/global.php");
                }
                include_once(SYS_MOD_PATH.'/'.$this->getVar('dirname').'/blocks/'.$this->getVar('func_file'));
                $options = explode("|", $this->getVar("options"));
                $edit_form = $edit_func($options, SysModule :: getByDirname($this->getVar('dirname')));
                if ( !$edit_form ) {
                    return false;
                }
                return $edit_form;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    /**
     * get all the blocks that match the supplied parameters
     * @param $side
     *         0: sideblock - left
     *         1: sideblock - right
     *         2: sideblock - left and right
     *         3: centerblock - left
     *         4: centerblock - right
     *         5: centerblock - center
     *         6: centerblock - left, right, center
     * @param $groupid   groupid (can be an array)
     * @param $visible   0: not visible 1: visible
     * @param $orderby   order of the blocks
     * @returns array of block objects
     */
    function &getAllBlocksByGroup(
        $groupid,
        $asobject=true,
        $side=NULL,
        $visible=NULL,
        $orderby="b.weight,b.bid",
        $isactive=1)
    {
        global $db;

        $ret = array();

        if ( !$asobject ) {
            $sql = "SELECT b.bid ";
        } else {
            $sql = "SELECT b.* ";
        }

        $sql .= "
                FROM ".$db->prefix("newblocks")." b
                LEFT JOIN ".$db->prefix("groups_blocks_link")." l
                    ON l.block_id=b.bid";

        if ( is_array($groupid) ) {
            $sql .= " WHERE (l.groupid=".$groupid[0]."";
            $size = count($groupid);
            if ( $size  > 1 ) {
                for ( $i = 1; $i < $size; $i++ ) {
                    $sql .= " OR l.groupid=".$groupid[$i]."";
                }
            }
            $sql .= ")";
        } else {
            $sql .= " WHERE l.groupid=".$groupid."";
        }

        $sql .= " AND b.isactive=".$isactive;

        if ( isset($side) ) {
            // get both sides in sidebox? (some themes need this)
            if ( $side == 2 ) {
                $side = "(b.side=0 OR b.side=1)";
            } elseif ( $side == 6 ) {
                $side = "(b.side=3 OR b.side=4 OR b.side=5)";
            } else {
                $side = "b.side=".$side;
            }

            $sql .= " AND ".$side;
        }

        if ( isset($visible) ) {
            $sql .= " AND b.visible=$visible";
        }

        $sql   .= " ORDER BY $orderby";
        $result = $db->query($sql);
        $added  = array();

        while ( $myrow = $db->fetch_array($result) ) {
            if ( !in_array($myrow['bid'], $added) ) {
                if (!$asobject) {
                    $ret[] = $myrow['bid'];
                } else {
                    $ret[] = new SysBlock($myrow);
                }
                array_push($added, $myrow['bid']);
            }
        }
        return $ret;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function &getAllBlocks(
        $rettype = "object",
        $side = NULL,
        $visible = NULL,
        $orderby = "side,weight,bid",
        $isactive = true)
    {
        global $db;

        $ret = array();
        $where_query = " WHERE isactive=".$isactive;

        if ( isset($side) ) {
            // get both sides in sidebox? (some themes need this)
            if ( $side == 2 ) {
                $side = "(side=0 OR side=1)";
            } elseif ( $side == 6 ) {
                $side = "(side=3 OR side=4 OR side=5)";
            } else {
                $side = "side=".$side;
            }
            $where_query .= " AND ".$side;
        }

        if ( isset($visible) ) {
            $where_query .= " AND visible=$visible";
        }

        $where_query .= " ORDER BY $orderby";

        switch($rettype) {

            case "object":
            $sql = "
                SELECT *
                    FROM ".$db->prefix("newblocks").
            $where_query;
            $result = $db->query($sql);
            while ( $myrow = $db->fetch_array($result) ) {
                $ret[] = new SysBlock($myrow);
            }
            break;

            case "list":
            $sql = "
                SELECT *
                    FROM ".$db->prefix("newblocks").
            $where_query;
            $result = $db->query($sql);
            while ( $myrow = $db->fetch_array($result) ) {
                $block = new SysBlock($myrow);
                $name = ($block->getVar("type") != "C") ? $block->getVar("name") : $block->getVar("title");
                $ret[$block->getVar("bid")] = $name;
            }
            break;

            case "id":
            $sql = "
                SELECT bid
                    FROM ".$db->prefix("newblocks").
            $where_query;
            $result = $db->query($sql);
            while ( $myrow = $db->fetch_array($result) ) {
                $ret[] = $myrow['bid'];
            }
            break;
        }
        return $ret;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function &getByModule($moduleid, $asobject=true)
    {
        global $db;
        if ( $asobject == true ) {
            $sql = "
                SELECT *
                    FROM ".$db->prefix("newblocks")."
                    WHERE mid=".$moduleid."";
        } else {
            $sql = "
                SELECT bid
                    FROM ".$db->prefix("newblocks")."
                    WHERE mid=".$moduleid."";
        }
        $result = $db->query($sql);
        $ret    = array();
        while( $myrow = $db->fetch_array($result) ) {
            if ( $asobject ) {
                $ret[] = new SysBlock($myrow);
            } else {
                $ret[] = $myrow['bid'];
            }
        }
        return $ret;
    }
}

?>
