<?php
/**
 * File: $Id: formcheckbox.php,v 1.3 2005/04/20 09:08:55 greyhead Exp $

 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_FORMCHECKBOX_INCLUDED") ) {
    return;
}
define("CIAMOS_FORMCHECKBOX_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/sysform/formelement.php");

class SysFormCheckBox extends SysFormElement
{
    var $options = array();

    // pre-selected values in array
    var $value = array();

    function SysFormCheckBox($caption, $name, $value="", $options='')
    {
        $this->setCaption($caption);
        $this->setName($name);
        if ( $value != "" ) {
            if ( is_array($value) ) {
                foreach ( $value as $v ) {
                    $this->value[] = $v;
                }
            } else {
                $this->value[] = $value;
            }
        }
        if ( $options ) {
            if ( is_array($options) ) {
                $this->addOptionArray($options);
            } else {
                $this->addOption($options);
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getValue()
    {
        return $this->value;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function addOption($value, $name="")
    {
        if ( $name != "" ) {
            $this->options[$value] = $name;
        } else {
            $this->options[$value] = $value;
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function addOptionArray($arr)
    {
        if ( is_array($arr) ) {
            foreach ( $arr as $k=>$v ) {
                $this->addOption($k, $v);
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getOptions()
    {
        return $this->options;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function render()
    {
        $return = "";
        if ( !$this->getOptions() ) {
            $return .= "<input type='checkbox' class='checkbox' name='".$this->getName()."' id='".$this->getName()."' value='".$value."'";
            $count = count($this->getValue());
            if ( $count > 0 && in_array(true, $this->getValue()) ) {
                $return .= " checked='checked'";
            }
            $return .= $this->getExtra()." />$name";
        } else {
            if ( count($this->getOptions()) > 1 && substr($this->getName(), -2, 2) != "[]" ) {
                $newname = $this->getName()."[]";
                $this->setName($newname);
            }
            foreach ( $this->getOptions() as $value => $name ) {
                $return .= "<input type='checkbox' class='checkbox' name='".$this->getName()."' id='".$this->getName()."' value='".$value."'";
                $count = count($this->getValue());
                if ( $count > 0 && in_array($value, $this->getValue()) ) {
                    $return .= " checked='checked'";
                }
                $return .= $this->getExtra()." />$name";
            }
        }
        return $return;
    }
}
?>
