<?php
/**
 * File: $Id: formelementtable.php,v 1.5 2005/04/26 14:40:41 r3g-ik Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_FORMELEMENTTABLE_INCLUDED") ) {
    return;
}
define("CIAMOS_FORMELEMENTTABLE_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/sysform/formelement.php");

/**
 * Enter description here...
 * NB use an index of '0' or '-1' to set the title row.
 */
class SysFormElementTable extends SysFormElement
{
    var $elements = array();
    var $delimiter;
    var $row_array = array();

    /**
     * Enter description here...
     *
     * @param unknown $caption
     * @param unknown $delimiter
     * @param array $extra an array of arrays
     * @return SysFormElementTray
     */
    function SysFormElementTable($caption, $row_array, $no_caption=false)
    {
        $this->setCaption($caption);
        $this->setRowArray($row_array);
        $this->setTable($no_caption);
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function addElement($ele)
    {
        if ( is_array($ele) ) {
            foreach ( $ele as $element ) {
                $this->elements[] = $element;
            }
        } else {
            $this->elements[] = $ele;
        }
    }

    /**
     * Enter description here...
     *
     * @param array $row_array
     */
    function setRowArray($row_array)
    {
        $this->row_array = $row_array;
    }

    function getRowArray()
    {
        return $this->row_array;
    }
    /**
     * @return void
     * @param array $elements
     * @desc Adds an array of elements to the tray
     */
    function addElementArray($elements)
    {
        foreach ( $elements as $element ) {
            $this->elements[] = $element;
        }
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getElements()
    {
        return $this->elements;
    }

    /**
     * Enter description here...
     *
     */
    function clearElements()
    {
        $this->elements = array();
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function render()
    {
        $bg = array(0 => 'bg3', 1 => 'bg1');
        $ret   = "<table width='100%'>";
        $rows = 0;
        foreach( $this->getRowArray() as $key => $elements) {
            if ( $rows == 0 ) {
                $bg_color = 'bg2';
            } else {
                $bg_color = $bg[$rows%2];
            }
			$ret   .= "<tr class='$bg_color'><td style='padding:4px;'>";
            $this->addElement($elements);
            $count = 0;
            foreach ( $this->getElements() as $ele ) {
                if ( $count > 0 ) {
                    $ret .= "</td><td>";
                }
                $ret .= $ele->render();
                $count++;
            }
            $this->clearElements();
			$ret .= '</td></tr>';
            $rows++;
        }
        $ret .= '</table>';
        return $ret;
    }
}
?>
