<?php
/**
 * File: $Id: formelementtray.php,v 1.3 2005/01/27 11:24:11 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */
if ( defined("CIAMOS_FORMELEMENTTRAY_INCLUDED") ) {
    return;
}
define("CIAMOS_FORMELEMENTTRAY_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/sysform/formelement.php");

/**
 * Enter description here...
 *
 */
class SysFormElementTray extends SysFormElement
{
    var $elements = array();
    var $delimiter;

    /**
     * Enter description here...
     *
     * @param unknown $caption
     * @param unknown $delimiter
     * @param mixed $extra an element or an array of elements 
     * @return SysFormElementTray
     */
    function SysFormElementTray($caption, $delimiter="&nbsp;", $extra='')
    {
        $this->setCaption($caption);
        $this->delimiter = $delimiter;
        if ( $extra != '') {
            if ( is_array($extra) ) {
                $this-> addElementArray($extra);
            } else {
                $this->addElement($extra);
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function addElement($ele)
    {
        $this->elements[] = $ele;
    }

    /**
     * @return void
     * @param array $elements
     * @desc Adds an array of elements to the tray
     */
    function addElementArray($elements)
    {
        foreach ( $elements as $element ) {
            $this->elements[] = $element;
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getElements()
    {
        return $this->elements;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getDelimiter()
    {
        return $this->delimiter;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function render()
    {
        $count = 0;
        $ret   = "";

        foreach ( $this->getElements() as $ele ) {
            if ( $count > 0 ) {
                $ret .= $this->getDelimiter();
            }
            $ret .= $ele->getCaption()."&nbsp;".$ele->render();
            $count++;
        }
        return $ret;
    }
}
?>
