<?php
/**
 * File: $Id: formradio.php,v 1.2 2005/01/27 11:24:11 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_FORMRADIO_INCLUDED") ) {
    return;
}
define("CIAMOS_FORMRADIO_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/sysform/formelement.php");

class SysFormRadio extends SysFormElement
{
    var $options = array();
    // pre-selected value
    var $value;
    var $delimiter;

    function SysFormRadio($caption, $name, $value=NULL, $extra='', $delimiter='&nbsp;')
    {
        $this->setCaption($caption);
        $this->setName($name);
        $this->value = $value;
        $this->delimiter = $delimiter;
        if ( is_array($extra) ) {
            $this->addOptionArray($extra);
        }
    }

    /**
     * Description
     *
     * @return type description
     */
    function getValue()
    {
        return $this->value;
    }
    
    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getDelimiter()
    {
        return $this->delimiter;
    }
    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function addOption($value, $name="")
    {
        if ( $name != "" ) {
            $this->options[$value] = $name;
        } else {
            $this->options[$value] = $value;
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function addOptionArray($arr)
    {
        if ( is_array($arr) ) {
            foreach ( $arr as $k=>$v ) {
                $this->addOption($k, $v);
            }
        }
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function getOptions()
    {
        return $this->options;
    }

    /**
     * Description
     *
     * @param type $var description
     * @return type description
     */
    function render()
    {
        $count = 0;
        $ret = "";
        foreach ( $this->getOptions() as $value => $name ) {
            if ( $count > 0 ) {
                $ret .= $this->getDelimiter();
            }
            $ret .= "<input type='radio' class='radio' name='".$this->getName()."' id='".$this->getName()."' value='".$value."'";
            $selected = $this->getValue();
            if ( isset($selected) && ($value == $selected) ) {
                $ret .= " checked='checked'";
            }
            $ret .= $this->getExtra()." />".$name;
            $count++;
        }
        return $ret;
    }
}
?>
