<?php
/**
 * $file id
 * Ciamos - Content Management System
 * This class is for Ciamos error handling
 *
 * @package Ciamos
 * @copyright (C) 2004-2005 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_xxx
 * @link link to information for the subpackage
 *
 */

Class SysErrorHandler extends SysHandler
{
    var $production_level = 0;

	/*	Function: SysErrorHandler()
	*	----------------------------------------------------------------
	*	Purpose:			Extension function for SysHandler class that 
	*						records and displays errors
	*	Arguments:			$production_level
	*	Returns/Assigns:	Displays errors.
	*/ 
    function SysErrorHandler($production_level = 0)
    {
        global $sysConfig;

        $this->production_level = $production_level;
        set_error_handler(array($this, 'ex_error_handler'));
    }

	/*	Function: ex_error_handler()
	*	----------------------------------------------------------------
	*	Purpose:			Extension function for SysHandler class that 
	*						displays the errors
	*	Arguments:			$errno,$errstr,$errfile,$errline
	*	Returns/Assigns:	Displays the errors based on $errno
	*/ 
    function ex_error_handler($errno='', $errstr='', $errfile='', $errline='')
    {
        global $sysConfig;

        $errortype = array (
            1    => _ERR_ERROR,
            2    => _ERR_WARNING,
            4    => _ERR_PARSE,
            8    => _ERR_NOTICE,
            16   => _ERR_CORE_ERROR,
            32   => _ERR_CORE_WARNING,
            64   => _ERR_COMPILE_ERROR,
            128  => _ERR_COMPILE_WARNING,
            256  => _ERR_USER_ERROR,
            512  => _ERR_USER_WARNING,
            1024 => _ERR_USER_NOTICE
            );
        if ( ( $sysConfig['debug_mode'] & 1 )
                && ( error_reporting() & $errno) ) { 
            $errfile =  substr($errfile, strlen(SYS_ROOT_PATH)); 
            $output .= '
            	<div class="errhandler">
            	'._ERR_NUMBER.': '.$errno.' ['.$errortype[$errno].']<br />
            	'._ERR_MESSAGE.': <b>'.$errstr.'</b><br />
            	'._ERR_FILE.': <a href="'.SYS_ROOT_URL.'/class/debug/highlight.php?file='.$errfile.'&line='.$errline.'#'.$errline.'" title="'._ERR_SHOW.'" target="errcode">'.$errfile.'</a><br />
            	'._ERR_LINE.': '.$errline.'
            </div>';
            echo $output;
        }
    }
}
?>
