<?php
/**
 * Ciamos - Content Management System
 * This class is for Ciamos Https handling
 * @package Ciamos
 * @copyright (C) 2004-2005 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_xxx
 * @link link to information for the subpackage
 *
 */
class SysCheckHttps extends SysHandler {

	/*	Function: SysCheckHttps()
	*	----------------------------------------------------------------
	*	Purpose:			Extension function for SysHandler class that 
	*						checks for secure http connection availability
	*	Arguments:			
	*	Returns/Assigns:	Returns _HTTPS as either true or false
	*/ 
	function SysCheckHttps() 
	{
		/**
		 * Check if https is enabled
		 */
		if ( $_SERVER['HTTPS'] ) {
			$tmp_https = $_SERVER['HTTPS'];
		} else {
			$tmp_https = $_ENV['HTTPS'];
		}
		if ( strtoupper($tmp_https) == 'ON' ) {
			define('_HTTPS', true);
		} else {
			define('_HTTPS', false);
		}
		return $tmp_https;
	}
}
?>