<?php
/**
 * Ciamos - Content Management System
 * This class is for Ciamos IP Retrieval
 * @package Ciamos
 * @copyright (C) 2004-2005 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_xxx
 * @link link to information for the subpackage
 *
 */
if ( !defined('CIAMOS_MAINFILE_INCLUDED') ) {
	header("Location: ../../index.php");
	exit();
}

Class SysGetIp extends SysHandler {

var $ip;

	/*	Function: SysGetIp()
	*	----------------------------------------------------------------
	*	Purpose:			Extension function for SysHandler class that 
	*						checks for the users' IP address
	*	Arguments:			
	*	Returns/Assigns:	Returns the users' IP address.
	*/ 
	function SysGetIp()
	{
		// global $_SERVER, $_ENV;

		if ( $_SERVER['HTTP_X_FORWARDED_FOR'] ) {
			$tmp_ip[1] = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			$tmp_ip[1] = $_ENV['HTTP_X_FORWARDED_FOR'];
		}
		if ( $_SERVER['HTTP_CLIENT_IP'] ) {
			$tmp_ip[2] = $_SERVER['HTTP_CLIENT_IP'];
		} else {
			$tmp_ip[2] = $_ENV['HTTP_CLIENT_IP'];
		}
		if ( $_SERVER['REMOTE_ADDR'] ) {
			$tmp_ip[3] = $_SERVER['REMOTE_ADDR'];
		} else {
			$tmp_ip[3] = $_ENV['REMOTE_ADDR'];
		}

		switch( true ) {
			
			case !empty($tmp_ip[1]):
			$tmp_ip[1] = preg_replace('/,.*/', '', $tmp_ip[1]);
			define('_REMOTE_ADDR', $tmp_ip[1]);
			break;

			case !empty($tmp_ip[2]):
			define('_REMOTE_ADDR', $tmp_ip[2]);
			break;

			case !empty($tmp_ip[3]):
			define('_REMOTE_ADDR', $tmp_ip[3]);
			break;

			default:
			define('_REMOTE_ADDR', '0.0.0.0'); // empty or filled ..dunno yet
		}
	}
}
?>