<?php
/**
 * Ciamos - Content Management System
 * This class is for Ciamos variable handling
 * @package Ciamos
 * @copyright (C) 2004-2005 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_xxx
 * @link link to information for the subpackage
 *
 */
class SysCheckVariables extends SysHandler 
{

	/*	Function: SysCheckVariables()
	 *	----------------------------------------------------------------
	 *	Purpose:			Extension function for SysHandler class that 
	 *						checks for the variables
	 *	Arguments:			
	 *	Returns/Assigns:	Checks and sets variables
	 */ 
	function SysCheckVariables() 
	{
		//global $_SERVER;
		/**
		 * Detect variables now, reuse later
		 */
		define('_PHP_SELF', $_SERVER['PHP_SELF']);

		/**
		 * SERVER followed by ENV comparison :: apache/iis, cgi/isapi :: ..so check them all :)
		 */
		$var_array = array('HTTP_HOST', 'QUERY_STRING', '_SCRIPT_NAME', '_HTTP_REFERER', 
		      '_REQUEST_METHOD', '_HTTP_USER_AGENT');
		foreach ($var_array as $var) {
		    if ( !empty($_SERVER[$var]) ) {
		          define($var      , $_SERVER[$var]);
		    } else {
		          define($var      , $_ENV[$var]);
		    }
		}
		if ( !empty($_SERVER['REQUEST_URI']) ) {
		    $R_URI = $_SERVER['REQUEST_URI']; 
		} else {
		    $R_URI = $_ENV['REQUEST_URI'];
		}
		if ( !empty($R_URI) ) {
		    define('_REQUEST_URI', $R_URI); 
		} else {
		    define('_REQUEST_URI', _PHP_SELF._QUERY_STRING);
		}
	}
}
?>