<?php
/**
 * File: $Id: sysstory.php,v 1.7 2005/05/15 16:13:13 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( defined("CIAMOS_STORY_INCLUDED") ) {
    return;
}
define("CIAMOS_STORY_INCLUDED", true);

include_once(SYS_ROOT_PATH."/class/syscomments.php");
include_once(SYS_ROOT_PATH."/class/systopic.php");

/**
    * Description
    *
    * @param type $var description
    * @return type description
    */
class SysStory
{
    var $table;
    var $storyid;
    var $topicid;
    var $uid;
    var $title;
    var $hometext;
    var $bodytext = "";
    var $counter;
    var $created;
    var $published;
    var $hostname;
    var $allow_html    = 0;
    var $allow_smileys = 1;
    var $allow_bbcode  = 1;
    var $ihome         = 0;
    var $notifypub     = 0;
    var $type          = "user";
    var $approved;
    var $topicdisplay;
    var $topicalign;
    var $db;
    var $commentstable;
    var $topicstable;

    /**
     * Enter description here...
     *
     * @param unknown_type $storyid
     */
    function Story($storyid=-1)
    {
        $this->table = "";
        $this->commentstable = "";
        $this->topicstable = "";
        if (is_array($storyid)) {
            $this->makeStory($storyid);
        } elseif ($storyid != -1) {
            $this->getStory(intval($storyid));
        }
    }
    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setStoryId($value)
    {
        $this->storyid = $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setTopicId($value)
    {
        $this->topicid = $value;
    }
    
    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setUid($value)
    {
        $this->uid = $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setTitle($value)
    {
        $this->title = $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setHometext($value)
    {
        $this->hometext = $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setBodytext($value)
    {
        $this->bodytext = $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setPublished($value)
    {
        $this->published = $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setHostname($value)
    {
        $this->hostname = $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setHtml($value=false)
    {
        $this->allow_html = (boolean) $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setSmileys($value=false)
    {
        $this->allow_smileys = (boolean) $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setBBcode($value=0)
    {
        $this->allow_bbcode = intval($value);
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setIhome($value)
    {
        $this->ihome = (boolean) $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setNotifyPub($value)
    {
        $this->notifypub = (boolean) $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setType($value)
    {
        global $myts;

        $this->type = $value;
        $myts->setType($value);
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setApproved($value=false)
    {
        $this->approved = (boolean) $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setTopicdisplay($value)
    {
        $this->topicdisplay = (boolean) $value;
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $value
     */
    function setTopicalign($value)
    {
        $this->topicalign = (boolean) $value;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $approved
     * @return unknown
     */
    function store($approved=false)
    {
        global $myts, $db;

        $title    = $myts->makeTboxData4Save($this->title);
        $hometext = $myts->makeTboxData4Save($this->hometext);
        $bodytext = $myts->makeTboxData4Save($this->bodytext);

        if ( !isset($this->notifypub) || $this->notifypub != 1 ) {
            $this->notifypub = 0;
        }
        if ( !isset($this->topicdisplay) || $this->topicdisplay != 0 ) {
            $this->topicdisplay = 1;
        }
        $published = '0';
        if ( $this->approved ) {
            $published = $this->published;
        }
        if ( !isset($this->storyid) ) {
            $newstoryid = $db->genId($this->table."_storyid_seq");
            $created = time();
            $sql = "
                INSERT 
                    INTO ".$this->table." 
                    SET storyid       =$newstoryid,
                        uid           =".$this->uid.",
                        title         ='".$title."',
                        created       =".$created.",
                        published     =".$published.",
                        hostname      ='".$this->hostname."',
                        allow_html    =".intval($this->allow_html).",
                        allow_smileys =".intval($this->allow_smileys).",
                        allow_bbcode  =".intval($this->allow_bbcode).",
                        hometext      ='".$hometext."',
                        bodytext      ='".$bodytext."',
                        counter       =0,
                        topicid       =".intval($this->topicid).",
                        ihome         =".intval($this->ihome).",
                        notifypub     =".intval($this->notifypub).",
                        type          ='".$this->type."',
                        topicdisplay  ='".$this->topicdisplay."',
                        topicalign    ='".$this->topicalign."'";
        } else {
            $sql = "
                UPDATE ".$this->table."
                    SET title         ='".$title."',
                        published     =".$published.",
                        allow_html    =".intval($this->allow_html).",
                        allow_smileys =".intval($this->allow_smileys).",
                        allow_bbcode  =".intval($this->allow_bbcode).",
                        hometext      ='".$hometext."',
                        bodytext      ='".$bodytext."',
                        topicid       =".intval($this->topicid).",
                        ihome         =".intval($this->ihome).",
                        topicdisplay  ='".$this->topicdisplay."',
                        topicalign    ='".$this->topicalign."'
                    WHERE storyid = ".$this->storyid."";
        }
        $return = ( $result = $db->query($sql) );
        return $return;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $storyid
     */
    function getStory($storyid)
    {
        global $db;

        $sql   = "
                SELECT *
                    FROM ".$this->table."
                    WHERE storyid=".$storyid."";
        $array = $db->fetch_array($db->query($sql));
        $this->makeStory($array);
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $array
     */
    function makeStory($array)
    {
        if ( is_array($array) ) {
            foreach( $array as $key=>$value ) {
                $this->$key = $value;
            }
        }
    }


    /**
     * Enter description here...
     *
     * @return unknown
     */
    function delete()
    {
        global $db;

        $sql = "
            DELETE
                FROM ".$this->table."
                WHERE storyid = ".$this->storyid."";
        $return = false;
        if ( $result = $db->query($sql) ) {
            if ( $this->commentstable ) {
                $commentsarray = array();
                $com           = new SysComments($this->commentstable, "storyid");
                $criteria      = array("item_id=".$this->storyid."", "pid=0");
                $commentsarray = $com->getAllComments($criteria);
                foreach ( $commentsarray as $comment ) {
                    $comment->delete();
                }
            }
            $return = true;
        }
        return $return;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function updateCounter()
    {
        global $db;

        $sql = "
            UPDATE ".$this->table."
                SET counter = counter + 1
                WHERE storyid = ".$this->storyid."";
        $return = false;
        if ( $result = $db->query($sql) ) {
            $return = true;
        }
        return $return;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function topicid()
    {
        return $this->topicid;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function topic()
    {
        return new SysTopic($this->topicstable, $this->topicid);
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function uid()
    {
        return $this->uid;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function uname()
    {
        return SysUser::getUnameFromId($this->uid);
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $format
     * @return unknown
     */
    function title($format="Show")
    {
        global $myts;

        $allow_smileys = intval($this->allow_smileys());

        switch ( $format ) {
            case "Show":
            $title = $myts->makeTboxData4Show($this->title, $allow_smileys);
            break;

            case "Edit":
            $title = $myts->makeTboxData4Edit($this->title);
            break;

            case "Preview":
            $title = $myts->makeTboxData4Preview($this->title, $allow_smileys);
            break;

            case "InForm":
            $title = $myts->makeTboxData4PreviewInForm($this->title);
            break;
        }
        return $title;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $format
     * @return unknown
     */
    function hometext($format="Show")
    {
        global $myts;

        $allow_html    = intval($this->allow_html());
        $allow_smileys = intval($this->allow_smileys());
        $allow_bbcode  = intval($this->allow_bbcode());

        $myts->setType($this->type);

        switch ( $format ) {
            case "Show":
            $hometext = $myts->makeTareaData4Show($this->hometext, $allow_html, $allow_smileys, $allow_bbcode);
            break;

            case "Edit":
            $hometext = $myts->makeTboxData4Edit($this->hometext);
            break;

            case "Preview":
            $hometext = $myts->makeTareaData4Preview($this->hometext, $allow_html, $allow_smileys, $allow_bbcode);
            break;

            case "InForm":
            $hometext = $myts->makeTboxData4PreviewInForm($this->hometext);
            break;
        }
        return $hometext;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $format
     * @return unknown
     */
    function bodytext($format="Show")
    {
        global $myts;

        $allow_html    = intval($this->allow_html());
        $allow_smileys = intval($this->allow_smileys());
        $allow_bbcode  = intval($this->allow_bbcode());

        $myts->setType($this->type);

        switch($format) {
            case "Show":
            $bodytext = $myts->makeTareaData4Show($this->bodytext, $allow_html, $allow_smileys, $allow_bbcode);
            break;

            case "Edit":
            $bodytext = $myts->makeTboxData4Edit($this->bodytext);
            break;

            case "Preview":
            $bodytext = $myts->makeTareaData4Preview($this->bodytext, $allow_html, $allow_smileys, $allow_bbcode);
            break;

            case "InForm":
            $bodytext = $myts->makeTboxData4PreviewInForm($this->bodytext);
            break;
        }
        return $bodytext;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function counter()
    {
        return $this->counter;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function created()
    {
        return $this->created;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function published()
    {
        return $this->published;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function hostname()
    {
        return $this->hostname;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function storyid()
    {
        return intval($this->storyid);
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function allow_html()
    {
        return intval($this->allow_html);
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function allow_smileys()
    {
        return intval($this->allow_smileys);
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function allow_bbcode()
    {
        return intval($this->allow_bbcode);
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function notifypub()
    {
        return intval($this->notifypub);
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function type()
    {
        return $this->type;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function ihome()
    {
        return intval($this->ihome);
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function topicdisplay()
    {
        return $this->topicdisplay;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $astext
     * @return unknown
     */
    function topicalign($astext=true)
    {
        if ( $astext ) {
            if ( $this->topicalign == "R" ) {
                $ret = "right";
            } else {
                $ret = "left";
            }
            return $ret;
        }
        return $this->topicalign;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getCommentsCount()
    {
        global $db;
        
        $sql = "
            SELECT COUNT(*)
                FROM ".$this->commentstable."
                WHERE item_id=".$this->storyid."";
        $result = $db->query($sql);
        list($count) = $db->fetch_row($result);
        return $count;
    }
}
?>