<?php
/**
 * File: $Id: common.php,v 1.70 2005/05/27 06:51:32 greyhead Exp $
 * Ciamos: Manages personal messages
 * Ciamos - Content Management System
 * :TODO: add detailed description of this file
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_core
 * @link link to information for the subpackage
 * @author Half-Dead
 */

if ( !defined('CIAMOS_MAINFILE_INCLUDED') ) {
    exit();
}

error_reporting(2039);
set_magic_quotes_runtime(0);
$objCache = new stdClass();

define('SYS_MOD_PATH', SYS_ROOT_PATH.'/'.SYS_MOD_FOLDER);

/**
 * Include global config files
 */
include_once(SYS_MOD_PATH.'/system/cache/config.php');
include(SYS_MOD_PATH."/language/common/functions.php");
if ( !empty($sysConfig['language']) ) {
    $sysConfig['language'] = $sysConfig['language'];
} else {
    $sysConfig['language'] = $sysConfig['default_language'];
}

if ( $sysConfig['gzip_compression'] ) {
    ob_start('ob_gzhandler');
} else {
    ob_start();
}

/**
 * Include functions file
 */
include_once(SYS_ROOT_PATH.'/include/functions.php');

if ( $sysConfig['offline_site'] ) {
			redirectHeader('',100,$sysConfig['offline_msg'],0,0);
			exit();
}

/*
 * Security
 */
include_once(SYS_MOD_PATH.'/system/cache/security.php');
include_once(SYS_ROOT_PATH.'/class/syshandler.php');
$sysHandler = array();
$sysHandler['parent']   = New SysHandler;
$sysHandler['error']    = New SysErrorHandler(1);
$sysHandler['https']    = New SysCheckHttps;
$sysHandler['requests'] = New SysCheckRequests;

/**
 * Backwards compatibility settings
 */
$sysConfig['SYS_ROOT_URL']  = SYS_ROOT_URL;
$sysConfig['root_path']     = SYS_ROOT_PATH.'/';
define('SYS_URL', SYS_ROOT_URL);

define('SYS_SIDEBLOCK_LEFT', 0);
define('SYS_SIDEBLOCK_RIGHT', 1);
define('SYS_SIDEBLOCK_BOTH', 2);
define('SYS_CENTERBLOCK_LEFT', 3);
define('SYS_CENTERBLOCK_RIGHT', 4);
define('SYS_CENTERBLOCK_CENTER', 5);
define('SYS_CENTERBLOCK_ALL', 6);

define('BLOCK_ABSOLUTETOP', 7);
define('BLOCK_ABSOLUTEBOTTOM', 8);

define('SYS_BLOCK_INVISIBLE', 0);
define('SYS_BLOCK_VISIBLE', 1);

define('SYS_MATCH_START', 0);
define('SYS_MATCH_END', 1);
define('SYS_MATCH_EQUAL', 2);
define('SYS_MATCH_CONTAIN', 3);

define('SYS_ADMIN_URL', SYS_ROOT_URL.'/admin.php');
define('SYS_MOD_URL',   SYS_ROOT_URL.'/'.SYS_MOD_FOLDER);
define('SYS_FORMDUMP',  SYS_ROOT_URL."/class/debug/formdump.php");

/* Check and detect variables */
$sysHandler['variables'] = New SysCheckVariables;

/* Set ip */
$sysHandler['ip'] = New SysGetIp;

/* Check for and set requests */
$sys_request = $sysHandler['requests']->SysCheckRequests();

/* Check for HTTPS connection */
$tmp_https = $sysHandler['https']->SysCheckHttps();

/* Detect platform */
$sysHandler['platform'] = New SysPlatform;

/**
 * Register Globals Compatibility
 */
$globals_test = @ini_get('register_globals');
if ( isset($globals_test) && empty($globals_test) ) {
    if ( !empty($_GET) )  {
        extract($_GET, EXTR_SKIP);
    }
    if ( !empty($_POST) ) {
        extract($_POST, EXTR_OVERWRITE);
    }
    define('_GLOBALS', false);
} else {
    define('_GLOBALS', true);
}

/**
 * Error reporting settings
 */
include_once(SYS_ROOT_PATH.'/class/debug/debug.php');

/**
 * Include version info file
 */
$sys_version = file (SYS_ROOT_PATH."/include/VERSION");
$sys_version = strval($sys_version[0]);
include_once(SYS_MOD_PATH.'/system/cache/meta.php');

/**
 * Include site-wide lang file
 */
if ( @file_exists(SYS_ROOT_PATH.'/language/'.$sysConfig['language'].'/global.php') ) {
    include_once(SYS_ROOT_PATH.'/language/'.$sysConfig['language'].'/global.php');
} else {
    include_once(SYS_ROOT_PATH.'/language/english/global.php');
}

/**
 * Include page-specific lang file
 */
if ( isset($sysOption['pagetype']) ) {
    if ( @file_exists(SYS_ROOT_PATH.'/language/'.$sysConfig['language'].'/'.$sysOption['pagetype'].'.php') ) {
        include_once(SYS_ROOT_PATH.'/language/'.$sysConfig['language'].'/'.$sysOption['pagetype'].'.php');
    } else {
        include_once(SYS_ROOT_PATH.'/language/english/'.$sysOption['pagetype'].'.php');
    }
}
if ( !defined('_USE_MULTIBYTES') ) {
    define('_USE_MULTIBYTES', 0);
}

/**
 * Include check
 */
include_once(SYS_ROOT_PATH.'/include/syscheck.php');

/**
 * Connecting to database around line 165 
 */
if ( $sysConfig['database'] ) {
    include_once(SYS_ROOT_PATH.'/class/database/'.$sysConfig['database'].'.php');
    if ( $sysConfig['backups'] ) {
        include_once(SYS_ROOT_PATH.'/class/dbbackup.php');
    }


    if ( $sysConfig['database'] == "pgsql" ) {
        /**
         * postgresql layer 
         */
        if ( defined("CIAMOS_DBBACKUP_INCLUDED") ) {
            $db = new DBBackup();
        } else {
            $db = new Database();
        }
        $db->setPrefix($sysConfig['prefix']);
        $result1 = @$db->connect($sysConfig['db_pconnect'], $sysConfig['database'],
        $sysConfig['dbhost'], $sysConfig['dbport'], $sysConfig['dbname'],
        $sysConfig['dbuname'], $sysConfig['dbpass']);
        if ( !$result1 ) {
            echo $db->error();
            exit();
        }
    } elseif ( $sysConfig['database'] == "mysql" ) { 
        /**
         * mysql layer 
         */
        if ( defined("CIAMOS_DBBACKUP_INCLUDED") ) {
            $db = new DBBackup();
        } else {
            $db = new Database();
        }
        $db->setPrefix($sysConfig['prefix']);
        $result1 = @$db->connect($sysConfig['dbhost'], $sysConfig['dbuname'],
                $sysConfig['dbpass'], $sysConfig['db_pconnect']); 
        if ( !$result1 ) {
            echo $db->error();
            exit();
        }
        $result2 = @$db->select_db($sysConfig['dbname']);
        if ( !$result2 ) {
            echo $db->error();
            exit();
        }
    }
    $db->setDebug($sysConfig['debug_mode']);
}

/* Security setting the tables  */
$sysHandler['security'] = New Security;

/* Check for abuse */
$sysHandler['abuse'] = New SysCheckAbuse;

/* Check for banned */
$sysHandler['banned'] = New SysCheckBanned;

$sysHandler['security']->checkGlobalVars();

/**
 * Include template
 */
include_once(SYS_ROOT_PATH.'/class/systemplate.php'); 
$module_template = new SysTemplate();
 
/**
 * Include sanitizer
 */
include_once(SYS_ROOT_PATH.'/class/module.textsanitizer.php');
$myts = new MyTextSanitizer();
$myts->setAllowImage($sysConfig['allow_image']);
$myts->setAllowLibrary($sysConfig['allow_library']);

/**
 * Include basic constructor classes
 * unless this is an install
 */
$sql = "SHOW TABLES LIKE '".$db->prefix('%')."'";
$result = $db->query($sql);
if ( $db->num_rows($result) > 0 ) {
    unset( $sysUser );
    include_once(SYS_ROOT_PATH.'/class/datalist.php');
    $block_cache 	= initDataList('SELECT * FROM '.$db->prefix('newblocks') , 	$db->prefix('newblocks'), 	'bid');
    $module_cache 	= initDataList('SELECT * FROM '.$db->prefix('modules') , 	$db->prefix('modules'), 	'mid');
    $topic_cache 	= initDataList('SELECT * FROM '.$db->prefix('topics') , 	$db->prefix('topics'), 		'topic_id');

    include_once(SYS_ROOT_PATH.'/class/sysobject.php');
    include_once(SYS_ROOT_PATH.'/class/sysgroup.php');
    include_once(SYS_ROOT_PATH.'/class/sysuser.php');
    include_once(SYS_ROOT_PATH.'/class/sysmodule.php');
    include_once(SYS_ROOT_PATH.'/class/sysblock.php');
}

/**
 * Login a user if there is a valid session
 */
if ( $sysConfig['use_sessions'] == 1 ) {
    session_set_cookie_params ($sysConfig['session_expire'] , '/');
    if ( $_COOKIE[$sysConfig['session_name']] ) {
        session_id($_COOKIE[$sysConfig['session_name']]);
    }
    if ( function_exists('session_cache_expire') ) {
        $session_cache_expire = intval($sysConfig['session_expire']/60);
        @session_cache_expire($session_cache_expire);
    }
    session_start();
    $session_var = $HTTP_SESSION_VARS[$sysConfig['session_name']];
} else {
    $session_var = $_COOKIE[$sysConfig['session_name']];
}
if ( !empty($session_var) ) {
    include_once(SYS_ROOT_PATH.'/class/sessions.class.php');
    $session = new SysUserSession($session_var);
    if ( $session->isValid() ) {
        $session->update();
        $sysUser = new SysUser($session->uid());
    }
}

/**
 * Setup module specific stuff if in a module dir
 */
if ( basename(dirname(_PHP_SELF)) == "admin" 
        && file_exists('../version.php')) {
    /**
     * This is a module admin folder
     */        
    $module_dir  = basename(dirname(dirname(_PHP_SELF)));
    $module_path = SYS_MOD_PATH.'/'.$module_dir;
    $module_url  = SYS_MOD_URL.'/'.$module_dir;
} elseif ( file_exists('version.php') ) {
    /**
     * This is a module folder
     */
    $module_dir  = basename(dirname(_PHP_SELF));
    $module_path = SYS_MOD_PATH.'/'.$module_dir;
    $module_url  = SYS_MOD_URL.'/'.$module_dir;

    $sysModule =& SysModule::getByDirname($module_dir);
    $check = false;
    if ( $sysModule && $sysModule->isActivated() ) {
        $check = true;
    }
    if ( !$check ) {
        /*
        include_once(SYS_ROOT_PATH.'/header.php');
        echo '<h4>'._MODULENOEXIST.'</h4>';
        include_once(SYS_ROOT_PATH.'/footer.php');
        exit();
        */
        redirectHeader(SYS_ROOT_URL.'/', 1, _MODULENOEXIST);
        exit();
    }
    if ( $sysUser ) {
        if ( !SysGroup::checkRight('module', $sysModule->mid(), $sysUser->groups()) ) {
            redirectHeader(SYS_ROOT_URL.'/', 1, _NOPERM);
            exit();
        }
    } elseif ( !SysGroup::checkRight('module', $sysModule->mid(), 0) ) {
        redirectHeader(SYS_ROOT_URL.'/', 1, _NOPERM);
        exit();
    }
    if ( @file_exists($module_path.'/language/'.$sysConfig['language'].'/global.php') ) {
        include_once($module_path.'/language/'.$sysConfig['language'].'/global.php');
    } elseif ( @file_exists($module_path.'/language/english/global.php') ) {
        include_once($module_path.'/language/english/global.php');
    }
} else {
    /**
     * If not in a module set page style
     */
    if ( empty($sysOption['page_style'])
            && ( $sysConfig['startpage'] == "--" )
            && ( basename(_PHP_SELF) == 'index.php' ) ) {
        $sysOption['page_style'] = 1; // start
    }
    $module_dir = false;
}

/**
 * load theme functions
 * Note : these entries must be after the user login 
 * to access user theme paths 
 */
define(SYS_THEME_PATH,      SYS_ROOT_PATH.'/themes/'.getTheme());
define(SYS_THEME_URL,       SYS_ROOT_URL.'/themes/'.getTheme());
define(THEME_IMAGE_PATH,    SYS_THEME_PATH."/images");
define(THEME_IMAGE_URL,     SYS_THEME_URL."/images");
define(THEME_TEMPLATE_PATH, SYS_THEME_PATH."/templates/modules");

include_once(SYS_ROOT_PATH.'/include/themefunc.php');
if ( @file_exists(SYS_THEME_PATH.'/include/thisthemefunc.php') ) {
    include_once(SYS_THEME_PATH.'/include/thisthemefunc.php');
}
/**
 * Making the system work with Charsets
 */
// header('Content-Type: text/html; charset=_CHARSET');
?>