<?php
/**
 * @return void
 * @desc Enter description here...
 */
function makeBottomBlocks()
{
    global $sysUser;

    $side = BLOCK_ABSOLUTEBOTTOM;
    $sysblock = new SysBlock();
    $arr = array();
    if ( $sysUser ) {
        $arr =& $sysblock->getAllBlocksByGroup($sysUser->groups(), true, $side, SYS_BLOCK_VISIBLE);
    } else {
        $arr =& $sysblock->getAllBlocksByGroup(SysGroup::getByType("Anonymous"), true, $side, SYS_BLOCK_VISIBLE);
    }

    foreach ( $arr as $myblock ) {
        $block = array();
        $b_content .= "<div class='absoluteBottom'>";
        $block =& $myblock->buildBlock();

        if ( $block ) {
             $b_content .= $myblock->showBlock(BLOCK_ABSOLUTEBOTTOM, $block['title'], $block['content']);
        }
        unset($myblock);
        unset($block);
     $b_content .= "</div>";
     return $b_content;
    }
}

/**
 * Function to display center block
 */
function makeCBlock($position='')
{
    global $sysUser, $sysOption;
	$b_content = '';
    $sysblock = new SysBlock();
    $cc_block   = $cl_block = $cr_block = "";
    $arr        = array();

    if ( $sysUser ) {
        $arr =& $sysblock->getAllBlocksByGroup($sysUser->groups(), true, SYS_CENTERBLOCK_ALL, SYS_BLOCK_VISIBLE);
    } else {
        $arr =& $sysblock->getAllBlocksByGroup(SysGroup::getByType("Anonymous"), true, SYS_CENTERBLOCK_ALL, SYS_BLOCK_VISIBLE);
    }
    $size = count($arr);
    if ( $size > 0 ) {

        $b_content .= openTable();

        foreach ( $arr as $myblock ) {
            $block = array();
            $block =& $myblock->buildBlock();
			
            $nextblock++;
            $prevblock = ($nextblock-2);

            if ( $prevblock >= 0 ) {
                $prev = $arr[$prevblock]->getVar("side");
            } else {
                $prev = false;
            }

            if ( $nextblock < count($arr) ) {
                $curr = $myblock->getVar("side");
                $next = $arr[$nextblock]->getVar("side");
            } else {
                $curr = $myblock->getVar("side");
                $next = false;
            }

            if ( $block ) {
                switch( $myblock->getVar("side") ) {

                    case SYS_CENTERBLOCK_LEFT:
                    $b_content .= "
            <table align='center' width='100%' cellpadding='0' cellspacing='0' border='0'>
            <tr>
                <td width='50%'>";
                    $b_content .= $myblock->showBlock(SYS_CENTERBLOCK_LEFT, $block['title'], $block['content']);
                    $b_content .= "  </td>";
                    if ( $next !== SYS_CENTERBLOCK_RIGHT ) {
                        $b_content .= "  <td width='50%'>&nbsp;</td>
            </tr>
            </table>";
                    }
                    break;

                    case SYS_CENTERBLOCK_RIGHT:
                    if ( $prev !== SYS_CENTERBLOCK_LEFT ) {
                        $b_content .= "
            <table align='center' width='100%' cellpadding='0' cellspacing='0' border='0'>
            <tr>
                <td width='50%'>&nbsp;</td>";
                    }
                    $b_content .= "<td width='50%'>";
                    $b_content .= $myblock->showBlock(SYS_CENTERBLOCK_RIGHT, $block['title'] , $block['content']);
                    $b_content .= "</td></tr></table>";
                    break;

                    case SYS_CENTERBLOCK_CENTER:
                    $b_content .= $myblock->showBlock(SYS_CENTERBLOCK_CENTER, $block['title'], $block['content']);
                    break;
                }


            } // END $block
            unset($myblock);
            unset($block);
        } // END FOREACH

        $b_content .= closeTable();
        return $b_content;
    } // END count($arr)
}

/**
 * Purpose : Builds the blocks on both sides
 * Input   : $side = On wich side should the block are displayed?
 * 0, l, left : On the left side
 * 1, r, right: On the right side
 *  other:   Only on one side (
 * Call from theme.php makes all blocks on the left side
 * and from theme.php for the right site)
 */
function makeSidebar($side)
{
    global $sysUser;

    $return = '';
    $sysblock = new SysBlock();
    $arr = array();

    if ( $side == "left" ) {
        $side = SYS_SIDEBLOCK_LEFT;
    } elseif ( $side == "right" ) {
        $side = SYS_SIDEBLOCK_RIGHT;
    } else {
        $side = SYS_SIDEBLOCK_BOTH;
    }

    if ( $sysUser ) {
        $user = $sysUser->groups();
    } else {
        $user = SysGroup::getByType("Anonymous");
    }
    $arr =& $sysblock->getAllBlocksByGroup($user, true, $side, SYS_BLOCK_VISIBLE);
    foreach ( $arr as $myblock ) {
        $block = array();
        $block =& $myblock->buildBlock();

        if ( $block ) {
            if ( $side == SYS_SIDEBLOCK_LEFT ) {
                $sideblock = SYS_SIDEBLOCK_LEFT;
            } else {
                $sideblock = SYS_SIDEBLOCK_RIGHT;
            }
            $return .= $myblock->showBlock($sideblock, $block['title'], $block['content']);
        }
        unset($myblock);
        unset($block);
    } // END FOREACH
    return $return;
}

/**
 * @return void
 * @desc Enter description here...
 */
function makeTopBlocks()
{
    global $sysUser;

    $side = BLOCK_ABSOLUTETOP;
    $sysblock = new SysBlock();
    $arr = array();
    if ( $sysUser ) {
    $arr =& $sysblock->getAllBlocksByGroup($sysUser->groups(),
            true, $side, SYS_BLOCK_VISIBLE);
    } else {
        $arr =& $sysblock->getAllBlocksByGroup(SysGroup::getByType("Anonymous"),
            true, $side, SYS_BLOCK_VISIBLE);
    }

    foreach ( $arr as $myblock ) {
        $block = array();
        $b_content .= "<div class='absoluteTop'>";
        $block =& $myblock->buildBlock();
        if ( $block ) {
            $b_content .= $myblock->showBlock(BLOCK_ABSOLUTETOP, $block['title'], $block['content']);
        }
        unset($myblock);
        unset($block);
        $b_content .= "</div>";
    }
    return $b_content;
}

/**
 * Deprecated functions - included for backward compatibility only
 * Add more as needed
 */
function make_cblock($position='') 
{
    makeCBlock($position);
}

?>
