<?php
/**
 * Function to display formatted times in user timezone
 */
function formatTimestamp($time, $format="l", $timeoffset="")
{
	global $sysConfig, $sysUser;

	if ( $timeoffset == "" ) {
		if ( $sysUser ) {
			$timeoffset = $sysUser->getVar("timezone_offset");
		} else {
			$timeoffset = $sysConfig['default_TZ'];
		}
	}

	if ( $format == "s" ) {
		$datestring = _SHORTDATESTRING;
	} elseif ( $format == "m" ) {
		$datestring = _MEDIUMDATESTRING;
	} elseif ( $format == "l" ) {
		$datestring = _DATESTRING;
	} elseif ( $format == "mysql" ) {
		$datestring = "Y-m-d H:i:s";
	} elseif ( $format != "" ) {
		$datestring = $format;
	} else {
		$datestring = _DATESTRING;
	}

	$usertimestamp = ($time + (($timeoffset - ($sysConfig['server_TZ'] - date('I'))) * 3600));
	$datetime = date($datestring, $usertimestamp);
	$datetime = ucfirst($datetime);

	return $datetime;
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function formatURL($url='', $file='')
{
	if ( ($url != '') && !preg_match("'^((http|https|ftp|ftps|ed2k|ajsfp)://{1})$'i", $url) ) {
		if ( $file != '' ) {
			if ( preg_match("'^((http|https|ftp|ftps|ed2k|ajsfp)://{1}.{3,})'i", $file) ) {
				return $file;
			} elseif (substr($url, -1) != '/') {
				$file = '/'.$file;
			}
		}
		if ( preg_match("'^((http|https|ftp|ftps|ed2k|ajsfp)://{1}.{3,})'i", $url) ) {
			return $url.$file;
		} else {
			return "http://".$url.$file;
		}
	}
	return NULL;
}
?>