<?php

/**
 * Function to get css file for a certain theme
 */
function getCss($theme)
{
    global $sysModule;

    $theme_dir = SYS_ROOT_PATH.'/themes/'.$theme.'/style';
    $theme_url = SYS_ROOT_URL.'/themes/'.$theme.'/style';
    $mod_dir = false;
    if ( $sysModule ) {
        $mod_dir   = $sysModule->dirname();
    }
    if ( preg_match('/(MSIE)|(Opera)/i', _HTTP_USER_AGENT) ) {
        if ( $mod_dir && @file_exists($theme_dir.'/'.$mod_dir.'_style.css') ) {
            return ($theme_url.'/'.$mod_dir.'_style.css');
        } elseif ( @file_exists($theme_dir.'/style.css') ) {
            return ($theme_url.'/style.css');
        }
    } else {
        if ( $mod_dir && @file_exists($theme_dir.'/'.$mod_dir.'_styleNN.css') ) {
            return ($theme_url.'/'.$mod_dir.'_styleNN.css');
        } elseif ( @file_exists($theme_dir.'/styleNN.css') ) {
            return ($theme_url.'/styleNN.css');
        } elseif ( $mod_dir && @file_exists($theme_dir.'/'.$mod_dir.'_style.css') ) {
            return ($theme_url.'/'.$mod_dir.'_style.css');
        } elseif ( @file_exists($theme_dir.'/style.css') ) {
            return ($theme_url.'/style.css');
        }
    }
}

function getCssDirection($theme)
{
	global $sysModule;

	$theme_dir = SYS_ROOT_PATH.'/themes/'.$theme.'/style/'._DIRECTION;
	$theme_url = SYS_ROOT_URL.'/themes/'.$theme.'/style/'._DIRECTION;

    if ( $mod_dir && @file_exists($theme_dir.'/'.$mod_dir.'_styleNN.css') ) {
		return ($theme_url.'/'.$mod_dir.'_styleNN.css');
    } elseif ( @file_exists($theme_dir.'/styleNN.css') ) {
        return ($theme_url.'/styleNN.css');
    } elseif ( $mod_dir && @file_exists($theme_dir.'/'.$mod_dir.'_style.css') ) {
        return ($theme_url.'/'.$mod_dir.'_style.css');
    } elseif ( @file_exists($theme_dir.'/style.css') ) {
        return ($theme_url.'/style.css');
    }
}

/**
 * Function to get a user selected theme file
 */
function getTheme()
{
    global $sysConfig, $sysUser;

    $theme = $sysConfig['default_theme'];
    if ( $sysUser ) {
        $themename = $sysUser->getVar("theme");
        if ( @file_exists(SYS_ROOT_PATH."/themes/$themename/theme.php") ) {
            $theme = $themename;
        }
    }
    return $theme;
}


/**
 * Enter description here...
 *
 * @param boolean $debug
 */
function sysFooter($debug = true)
{
    global $sysConfig;

    if ( $sysConfig['display_loading_img'] == true ) {
        closeWaitBox();
    }
    siteCache("cache");
    if ( !empty($sysConfig['debug_mode']) && !empty($debug) ) {
        debugInfo($sysConfig['debug_mode']);
    }
    //echo "</body></html>";
    ob_end_flush();
}


/**
 * Enter description here...
 *
 * @param unknown $closehead
 */
function sysHeader($closehead=true)
{
    global $db, $meta, $sysUser, $sys_version;
	return;
    if ( !headers_sent() ) {
        if ( !empty($meta['p3p']) ) {
            header("P3P: CP='".$meta['p3p']."'");
        }
        if ( $sysUser || ($meta['pragma'] == 1) ) {
            header('Expires: Sat, 18 Aug 2002 05:30:00 GMT');
            header('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT');
            header('Cache-Control: no-store, no-cache, max-age=1, s-maxage=1, must-revalidate, post-check=0, pre-check=0');
        }
    }

    // We only generate keywords if in debug mode, or if it's really a search engine.
    if ( $meta['extractor'] ) {
        if ( !$meta['cloaking'] ) {
            include_once(SYS_MOD_PATH . "/system/admin/meta-generator/include/functions.php");
        } elseif ( $meta['cloaking'] && !preg_match("/(".$meta['user_agents'].")/i", _HTTP_USER_AGENT) ) {
            include_once(SYS_MOD_PATH . "/system/admin/meta-generator/include/functions.php");
        }
    }
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo _LANGCODE;?>" lang="<?php echo _LANGCODE;?>" dir="<?php echo _DIRECTION;?>">
<head>
<title><?php echo $meta['title']; ?></title>
<meta http-equiv='content-type' content='text/html; charset=<?php echo _CHARSET; ?>' />
<meta http-equiv='content-language' content='<?php echo _LANGCODE; ?>' />
<meta name='rating' content='<?php echo $meta['rating']; ?>' />
<meta name='robots' content='<?php echo $meta['index'].", ".$meta['follow']; ?>' />
<meta name='generator' content='Ciamos <?php echo $sys_version; ?>' />
<meta name='keywords' content='<?php echo $meta['keywords']; ?>' />
<meta name='description' content='<?php echo $meta['description']; ?>' />
<meta name='author' content='<?php echo $meta['author']; ?>' />
<meta name='copyright' content='<?php echo $meta['copyright']; ?>' />
<?php
    readfile(SYS_MOD_PATH .'/system/cache/header.php');
    $themecss = getCss(getTheme());
	$themecssdir = getCssDirection(getTheme());
    /**
     *  if possible check if the Main Menu block is active, so show this line.
     */
    echo "<link rel='stylesheet' media='all' href='".SYS_ROOT_URL."/themes/".getTheme()."/style/menu.css' type='text/css' />\n";
    echo "<link rel='stylesheet' media='all' href='$themecss' type='text/css' />\n";
    echo "<link rel='stylesheet' media='all' href='$themecssdir' type='text/css' />\n";
    echo "<link rel='shortcut icon' href='".SYS_ROOT_URL."/images/favicon.ico' />\n";
    //echo "<script type='text/javascript' language='JavaScript' src='".SYS_ROOT_URL ."/include/sysjs.php''></script>\n";
    include_once(SYS_ROOT_PATH .'/include/sysjs.php');
    if ( $closehead ) {
        echo "</head>\n<body>";
    }
}
?>