<?php
/**
 * File: $Id: registerform.php,v 1.10 2005/02/17 17:24:43 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */
include_once(SYS_ROOT_PATH."/class/syslists.php");
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

// initialize form vars
$uname           = isset($sys_request['uname'])           ? $myts->makeTboxData4PreviewInForm($sys_request['uname']) : "";
$email           = isset($sys_request['email'])           ? $myts->makeTboxData4PreviewInForm($sys_request['email']) : "";
$user_viewemail  = isset($sys_request['user_viewemail'])  ? $sys_request['user_viewemail']                           : "";
$url             = isset($sys_request['url'])             ? $myts->makeTboxData4PreviewInForm($sys_request['url'])   : "";
$timezone_offset = isset($sys_request['timezone_offset']) ? $sys_request['timezone_offset']                          : "";
$user_avatar     = isset($sys_request['user_avatar'])     ? $sys_request['user_avatar']                              : "blank.gif";

$nickname_text = new SysFormText(_NICKNAME, "uname", 26, 25, $uname);

$email_tray   = new SysFormElementTray(_EMAIL, "<br />");
$email_text   = new SysFormText("", "email", 25, 60, $email);
$email_option = new SysFormCheckBox("", "user_viewemail", $user_viewemail);
$email_option->addOption(1, _US_ALLOWVIEWEMAIL);
$email_tray->addElement($email_text);
$email_tray->addElement($email_option);

$url_text = new SysFormText(_US_WEBSITE, "url", 26, 255, $url);
$selected = ($timezone_offset != "") ? $timezone_offset : $sysConfig['default_TZ'];
$timezone_select = new SysFormSelectTimezone(_US_TIMEZONE, "timezone_offset", $selected);
$avatar_select   = new SysFormSelect("", "user_avatar", $user_avatar);
$avatar_array    =& SysLists::getImgListAsArray(SYS_ROOT_PATH."/images/avatar/");
$avatar_select->addOptionArray($avatar_array);
$a_dirlist      =& SysLists::getDirListAsArray(SYS_ROOT_PATH."/images/avatar/");
$a_dir_labels   = array();
$a_count        = 0;
$a_dir_link     = "<a href=\"javascript:openWithSelfMain('".SYS_ROOT_URL."/misc.php?action=showpopups&amp;type=avatars&amp;start=".$a_count."','avatars',600,400);\">Avatars</a>";
$a_count        = $a_count + count($avatar_array);
$a_dir_labels[] = new SysFormLabel("", $a_dir_link);

foreach ($a_dirlist as $a_dir) {
    if ( $a_dir == "users" ) {
        continue;
    }

    $avatars_array =& SysLists::getImgListAsArray(SYS_ROOT_PATH."/images/avatar/".$a_dir."/", $a_dir."/");
    $avatar_select->addOptionArray($avatars_array);
    $a_dir_link     = "<a href=\"javascript:openWithSelfMain('".SYS_ROOT_URL."/misc.php?action=showpopups&amp;type=avatars&amp;subdir=".$a_dir."&amp;start=".$a_count."','avatars',600,400);\">".$a_dir."</a>";
    $a_dir_labels[] = new SysFormLabel("", $a_dir_link);
    $a_count        = $a_count + count($avatars_array);
}

$avatar_select->setExtra("onchange='showImgSelected(\"avatar\", \"user_avatar\", \"images/avatar\")'");
$avatar_label = new SysFormLabel("", "<img src='images/avatar/001.png' name='avatar' id='avatar' alt='' />");
$avatar_tray  = new SysFormElementTray(_AVATAR, "&nbsp;");
$avatar_tray->addElement($avatar_select);
$avatar_tray->addElement($avatar_label);

foreach ($a_dir_labels as $a_dir_label) {
    $avatar_tray->addElement($a_dir_label);
}

$pwd_text      = new SysFormPassword(_PASSWORD  , "pass");
$pwd_text2     = new SysFormPassword(_US_VERIFYPASS, "vpass");
$mailok_radio  = new SysFormRadioYN(_US_MAILOK, 'user_mailok', 1);
$img_verify    = 0;

if ( $sysConfig['img_verify'] && function_exists('imagecreate') ) {
    include_once(SYS_ROOT_PATH."/class/rc4.crypt.php");

    $checksum   = "verified";
    $pass       = strtoupper(makepass());
    $rc4        = new rc4_crypt();
    $rc4->key($pass);
    $rc4->crypt($checksum);

    $im         = imagecreatefrompng('images/verify.png');
    $text_color = imagecolorallocate($im, 50, 50, 50);
    imagestring($im, 5, 2, 2, $pass, $text_color);
    imagepng($im, "cache/verify.png");
    imagedestroy($im);

    $verify_crc  = new SysFormHidden("verify_crc", base64_encode($checksum));
    $verify_text = new SysFormText('&nbsp;<img src="cache/verify.png?'.time().'" /><br />', "verify_text", 12, 8);
    $verify_tray = new SysFormElementTray(_US_ENTERVERIF, " ");
    $verify_tray->addElement($verify_text);

    if (@file_exists("cache/verify.png")) {
        $img_verify = 1;
    }
}


$op_hidden     = new SysFormHidden("op", "newuser");
$submit_button = new SysFormButton("", "submit", _SUBMIT, "submit");
$reg_form      = new SysThemeForm(_US_USERREG, "userinfo", "register.php");
$reg_form->addElement($nickname_text);
$reg_form->addElement($email_tray);
$reg_form->addElement($url_text);
$reg_form->addElement($timezone_select);
$reg_form->addElement($avatar_tray);
$reg_form->addElement($pwd_text);
$reg_form->addElement($pwd_text2);
$reg_form->addElement($mailok_radio);

if ( $img_verify == 1 ) {
    $reg_form->addElement($verify_tray);
    $reg_form->addElement($verify_crc);
    $required = array("uname", "email", "pass", "vpass", "verify_text");
} else {
    $required = array("uname", "email", "pass", "vpass");
}

$reg_form->addElement($op_hidden);
$reg_form->addElement($submit_button);
$reg_form->setRequired($required);
?>
