<?php
/**
 * File: $Id: index.php,v 1.16 2005/05/26 14:30:27 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author: Francisco Burzi (@link http://www.phpnuke.org)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */

include_once('include/header.php');
global $articles_config, $eh, $sysHandler;

/**/
$module_template -> setTemplate(SYS_THEME_PATH.'/templates/modules/articles/index.html');
/**/

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function listArticles()
{
    global $articles_config, $db, $eh, $meta, $myts, $sysConfig, 
        $sysModule, $module_template, $module_path;

    $intro = join('', file("./cache/intro.php"));
    $myts->setType('admin');
    
    include_once( SYS_ROOT_PATH."/class/datatree.php" );
    $mytree = New DataTree($sysModule->mid());
    
    include_once($module_path."/include/header.php");
    foreach ( $mytree->getAllIDs() as $topics )  {
        $topic      = $mytree->getSingleItem($topics);
        $topicname  = $topic['topic_title'];
        $topicid    = $topic['topic_id'];
        $topicdesc  = $mytree->getTopicDescription($topicid);
        $image      = $topic['topic_imgurl'];
        
        $topicname = $myts->makeTboxData4Show($topicname);
        $topicdesc = $myts->makeTboxData4Show($topicdesc);

        $sql = "
            SELECT count(*)
                FROM ".$db->prefix('articles')."
                WHERE topicid = $topicid";
        $result = $db->query($sql);
        list( $count ) = $db->fetch_row($result);
        if ( $count > 0 ) {
            if ( !empty($image) ) {
                $topic_image = "<a href='./index.php?op=listtopics&amp;topicid=$topicid'>
                    <img src='".formatURL(SYS_MOD_URL."/system/cache/topics/",
                $image)."' border='0' alt='$topicname' title='$topicname' /></a>";
            }
            $topic_link =  "<a style='font-weight:bold;' href='./index.php?op=listtopics&amp;topicid=$topicid'>$topicname:</a>";
            $topic_desc = wordwrap($topicdesc, 95, '<br />');

            $module_template -> setSwitch('rss_enable', $articles_config['rss_enable']);
            $module_template -> setOutputVarArray('articlesentry', 'topic_image', $topic_image);
            $module_template -> setOutputVarArray('articlesentry', 'topic_link', $topic_link);
            $module_template -> setOutputVarArray('articlesentry', 'count', $count);
            $module_template -> setOutputVarArray('articlesentry', 'topic_desc', $topic_desc);
            $module_template -> setSwitch('listArticles', true);
        }
    }
    include_once($module_path."/include/footer.php");
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function listTopics($topicid)
{
    global $articles_config, $db, $eh, $myts, $sys_request, $sysHandler, 
        $sysModule, $sysUser, $module_template, $module_path;

    $limit  = intval($articles_config['article_limit']);
    if ( !$limit ) {
        $limit = 10;
    }

    $access = new groupAccess('listtopics');
    $access->loadGroups($topicid, 'topicid', "articles");
    if ( !$access->checkGroups(1) ) {
        $sysHandler['security']->showSecurityERR("javascript:history.go(-1)", 3, _NOPERM);
        exit();
    }
    include_once(SYS_ROOT_PATH."/class/datatree.php");
    $mytree = New DataTree($sysModule->mid());
    $topic = $mytree->getSingleItem($topicid);

    $topicname = $myts->makeTboxData4Show($topic['topic_title']);
    $image = $topic['topic_imgurl'];

    include_once($module_path."/include/header.php");
    openTable();

    if ( !empty($image) ) {
        $topic_image = "<img src='".formatURL(SYS_MOD_URL."/system/cache/topics/",
        $image)."' border='0' alt='$topicname' />";
    }
    $topic_name = sprintf(_AR_THISTOPIC, $topicname);
    $table_head = array ('t1'=>_AR_ARTICLE, 't2'=>_AR_PUB_BY, 't3'=> _ON, 't4'=>_AR_READS, 't5'=>"&nbsp;");

    $sql = "
        SELECT COUNT(*)
            FROM ".$db->prefix("articles");
    $result        = $db->query($sql);
    list($numrows) = $db->fetch_row($result);

    $cnumrows = count($numrows);

    if ( $cnumrows > 0 ) {
        $show = false;
        if ( $sys_request['show'] ) {
            $show = $sys_request['show'];
        }
        $sql = "
            SELECT artid, title, byline, author, content, counter, date
                FROM ".$db->prefix("articles")."
                WHERE topicid = $topicid";
        $result = $db->query($sql, $limit, $show);
        while ( list($artid, $title, $byline, $author, $content, $counter, $date ) 
                = $db->fetch_row($result)) {
            $title    = $myts->makeTboxData4Show($title);
            $byline   = $myts->makeTboxData4Show($byline);
            $content  = $myts->makeTareaData4Show($content);
            $thisUser = new SysUser($author);
            if ( !$thisUser->isActive() ) {
                $name = _AR_UNKNOWN;
            } else {
                $name = $thisUser->uname();
            }
            if ( $byline ) {
                $byline_code = "<br />&nbsp;&nbsp;"._AR_BYLINE.": $byline";
            }
            $table_data = array();
            $table_data['title']  = 
                "<a href='./index.php?op=viewarticle&artid=$artid'>
                <span style='font-weight:bold;'>$title</span></a>$byline_code";
            $table_data['author'] = 
                "<a href='".SYS_ROOT_URL."/userinfo.php?uid=$author'>$name</a>";
            $table_data['date']   = date("M-d-Y", $date);
            $table_data['count']  = $counter;
            $table_data['print']  = "<a href='./index.php?op=printpage&artid=$artid'>
                <img src='./images/print.gif' border='0' alt='" . _AR_PRINTERPAGE."' /></a>";
            
            $module_template -> setOutputVarArray('table_data_loop', $table_data);            
        }
    }
    if ( $cnumrows > 0 ) {
        $nav = new SysPageNav($cnumrows, $limit, $show, "show", "op=listtopics&amp;topicid=$topicid");
        if ( $nav->renderNav() ) {
            $navbar = "| ".$nav->renderNav();
        }
    }
    $return_link = "<a href='./index.php'>"._AR_RETURN2INDEX."</a>";

    $module_template -> setOutputVar('topic_image', $topic_image);
    $module_template -> setOutputVar('topic_name', $topic_name);
    $module_template -> setOutputVarArray('table_head_loop', $table_head);
    $module_template -> setOutputVar('return_link', $return_link);
    $module_template -> setOutputVar('navbar', $navbar);
    $module_template -> setSwitch('listTopics', true);
        
    include_once($module_path."/include/footer.php");
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function viewArticle($artid, $page)
{
    global $articles_config, $db, $eh, $meta, $myts, $page, $sys_request, $sysConfig, 
        $sysModule, $sysUser, $module_template, $module_path;

    $access = new groupAccess('viewarticle');
    $access->loadGroups($artid, 'artid', "articles");
    if ( !$access->checkGroups(1) ) {
        redirectHeader("javascript:history.go(-1)", 3, _NOACTION);
        exit();
    }

    if ( !isset($page) ) {
        $sql = "
            UPDATE ".$db->prefix("articles")."
                SET counter = counter+1
                WHERE artid = '$artid'";
        $db->query($sql);
    }
    $sql = "
        SELECT artid, topicid, title, author, date, content, counter
            FROM ".$db->prefix("articles")."
            WHERE artid = $artid";
    $result = $db->query($sql);
    list ( $artid, $topicid, $title, $author, $date, $content, $counter ) = $db->fetch_row($result);
    $title    = $myts->makeTboxData4Show($title);

    $myts->setType('admin');
    $content  = $myts->makeTareaData4Show($content, 1, 1, 1);
    $thisUser = new SysUser($author);

    if ( !$thisUser->isActive() ) {
        $name = _AR_UNKNOWN;
    } else {
        $name = $thisUser->uname();
    }
    include_once(SYS_ROOT_PATH."/class/datatree.php");
    $mytree = New DataTree($sysModule->mid());
    $topic = $mytree->getSingleItem($topicid);

    $topicid = $topic['topic_id'];
    $topicname      = $myts->makeTboxData4Show($topic['topic_title']);
    $contentpages = explode( "[pagebreak]", $content );
    $pages        = count($contentpages);

    if ( !isset($page) || !is_numeric($page) ) {
        $page = "0";
    }

    if ( $page > $pages ) {
        $page = $pages;
    }

    $nav = new SysPageNav($pages, 1, $page, "page", "op=viewarticle&artid=$artid");

    $name_link = "<a href='".SYS_ROOT_URL."/userinfo.php?uid=$author'>$name</a>";
    $topic_link = "<a href='./index.php?op=listtopics&topicid=$topicid'>"
        .sprintf(_AR_BACK2TOPIC, $topicname)."</a>";
    $return_link = "<a href='./index.php'>"._AR_RETURN2INDEX."</a>"; 
    $print_link = "<a href='./index.php?op=printpage&artid=$artid'>
        <img src='./images/print.gif' border='0' alt='" . _AR_PRINTERPAGE."' /></a>";
    $mail_link = "<a target='_top' href='mailto:?subject="
        .rawurlencode(sprintf(_AR_INTARTICLE, $meta['title']))."&body="
        .rawurlencode(sprintf(_AR_INTARTFOUND, $meta['title']).":\r\n"
        .SYS_MOD_URL."/".$sysModule->dirname()."/index.php?op=viewarticle&artid=".$artid)."'>
        <img src='images/friend.gif' border='0' alt='"._AR_SENDARTICLE."' />
        </a>";   

    include_once($module_path."/include/header.php");
    $module_template -> setOutputVar('title', $title);
    $module_template -> setOutputVar('name_link', $name_link);
    $module_template -> setOutputVar('date', date("M-d-Y", $date));
    $module_template -> setOutputVar('content', trim($contentpages[$page]));
    $module_template -> setOutputVar('nav', $nav->renderNav());
    $module_template -> setOutputVar('topic_link', $topic_link);
    $module_template -> setOutputVar('return_link', $return_link);
    $module_template -> setOutputVar('print_link', $print_link);
    $module_template -> setOutputVar('mail_link', $mail_link);
    $module_template -> setSwitch('viewArticle', true);
    include_once($module_path."/include/footer.php");
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function printArticlePage($artid)
{
    global $sysConfig, $db, $myts, $meta, $sys_version;

    $access = new groupAccess('printarticlepage');
    $access->loadGroups($artid, 'artid', "articles");
    if ( !$access->checkGroups(1) ) {
        redirectHeader("javascript:history.go(-1)", 3, _NOACTION);
        exit();
    }
    $sql = "
        SELECT title, author, date, content
            FROM ".$db->prefix("articles")."
            WHERE artid = $artid";
    $result = $db->query($sql);
    list($title, $author, $date, $content) = $db->fetch_row($result);
    $title    = $myts->makeTboxData4Show($title);

    $myts->setType('admin');
    $content  = $myts->makeTareaData4Show($content,1,0,1);
    $thisUser = new SysUser($author);
    if ( !$thisUser->isActive() ) {
        $name = _AR_UNKNOWN;
    } else {
        $name=$thisUser->uname();
    }
?>
<?php echo '<?xml version="1.0" encoding="'._CHARSET.'"?>';?>

<!DOCTYPE html
  PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $meta['langcode'];?>" lang="<?php echo $meta['langcode'];?>">
<head>
<title><?php echo $meta['title'];?></title>
<meta http-equiv="content-type" content="text/html; charset=<?php echo _CHARSET;?>">
<meta http-equiv="content-language" content="<?php echo $meta['langcode'];?>">
<?php if ($meta['pragma']) { ?>
<meta http-equiv="pragma" content="no-cache">
<?php } ?>
<meta name="rating" content="<?php echo $meta['rating'];?>">
<meta name="robots" content="<?php echo $meta['index'];?>, <?php echo $meta['follow'];?>">
<meta name="generator" content="Ciamos <?php echo $sys_version;?>">
<meta name="keywords" content="<?php echo $meta['keywords'];?>">
<meta name="description" content="<?php echo $meta['description'];?>">
<meta name="author" content="<?php echo $meta['author'];?>">
<meta name="copyright" content="<?php echo $meta['copyright'];?>">
<?php readfile(SYS_MOD_PATH."/system/cache/header.php");?>
<link rel="shortcut icon" href="<?php echo $meta['icon'];?>">
</head>
<body bgcolor='#ffffff' text='#000000'>
<table align='center' border='0' width='640' cellpadding='0' cellspacing='1' bgcolor='#000000'><tr><td>
<table border='0' width='640' cellpadding='20' cellspacing='1' bgcolor='#FFFFFF'><tr><td>
<div align='center'>
<?php

    if ( @file_exists(SYS_ROOT_URL."/themes/".$sysConfig['default_theme']."/images/logo.gif") ) {
        echo "<img src='".SYS_ROOT_URL."/themes/".$sysConfig['default_theme']."/images/logo.gif' border='0' alt='".$myts->makeTboxData4Show($meta['slogan'])."' />";
    } else {
        echo "<img src='".SYS_ROOT_URL."/images/logo.gif' border='0' alt='".$myts->makeTboxData4Show($meta['slogan'])."' />";
    }

    echo "
        </div>
        <br /><br />
        <font size='+2'><b>$title</b></font><br />
        <font size='2'>
        "._AR_PUB_BY." <a href='".SYS_ROOT_URL."/userinfo.php?uid=$author'>$name</a>
        , "._ON." ".formatTimestamp($date, "M-d-Y")."
        <br /><br />
        ".str_replace("[pagebreak]","",$content)."
        <br /><br />
        <hr size='1' noshade='noshade' />".sprintf(_AR_COMESFROM, $meta['title'])."
        <br /><a href=".SYS_ROOT_URL.">".SYS_ROOT_URL."</a>
        <br /><br />
        "._AR_URLFORTHIS."
        <br />
        <a href='".SYS_MOD_URL."/"._AR_DIR_NAME."/index.php?op=viewarticle&artid=$artid'>"
        .SYS_MOD_URL."/"._AR_DIR_NAME."/index.php?op=viewarticle&artid=$artid</a>
        </font>
        </td></tr></table>
        </td></tr></table>
        </body>
        </html>";
}


switch($op) {
    case "viewarticle":
        viewArticle($artid, $page);
        break;

    case "listtopics":
        listTopics($topicid);
        break;

    case "printpage":
        printArticlePage($artid);
        break;

    default:
        listArticles();
        break;
}
?>
