<?php
/**
 * File: $Id: functions.php,v 1.33 2005/05/30 12:16:25 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @author James Knickelbein (@link http://www.journeymilwaukee.com )
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function newDownloadGraphic($time, $status)
{
    global $module_url;

    $count     = 7;
    $startdate = ( time() - (86400 * $count) );
    $return = '';
    if ( $startdate < $time ) {
        if ( $status == 1 ) {
            $return = "&nbsp;<img src='$module_url/images/newred.gif'
                alt='"._DL_NEWTHISWEEK."' />";
        } elseif ( $status == 2 ) {
            $return = "&nbsp;<img src='$module_url/images/update.gif'
                alt='"._DL_UPTHISWEEK."' />";
        }
    }
    return $return;
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
 function popGraphic($hits)
 {
     global $downloadsConfig, $module_url;

     if ( $hits >= $downloadsConfig['popular'] ) {
         $return = "&nbsp;<img src ='$module_url/images/pop.gif'
            alt='"._POPULAR."' />";
     }
     return $return;
 }

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function convertOrderByTrans($orderby)
{
    global $sys_request;

    switch($orderby) {

        case "hits ASC":
        $orderbyTrans = _DL_POPULARITYLTOM;
        break;

        case "hits DESC":
        $orderbyTrans = _DL_POPULARITYMTOL;
        break;

        case "title ASC":
        $orderbyTrans = _DL_TITLEATOZ;
        break;

        case "title DESC":
        $orderbyTrans = _DL_TITLEZTOA;
        break;

        case "date ASC":
        $orderbyTrans = _DL_DATEOLD;
        break;

        case "date DESC":
        $orderbyTrans = _DL_DATENEW;
        break;

        case "rating ASC":
        $orderbyTrans = _DL_RATINGLTOH;
        break;

        case "rating DESC":
        $orderbyTrans = _DL_RATINGHTOL;
        break;
    }
    return $orderbyTrans;
}

/**
 * Description
 *
 * @param string $var description
 * @return string description
 */
function convertOrderByOut($orderby)
{
    global $sys_request;
    switch($orderby) {
        case "title ASC":
        $orderby = "titleA";
        break;

        case "date ASC":
        $orderby = "dateA";
        break;

        case"hits ASC":
        $orderby = "hitsA";
        break;

        case "rating ASC":
        $orderby = "ratingA";
        break;

        case "title DESC":
        $orderby = "titleD";
        break;

        case "date DESC":
        $orderby = "dateD";
        break;

        case "hits DESC":
        $orderby = "hitsD";
        break;

        case "rating DESC":
        $orderby = "ratingD";
        break;
    }
    return $orderby;
}

/**
 * Makes bytes into pretty sizes
 *
 * @param string $size size in Bytes
 * @return string Pretty size in bytes, Kb or Mb
 */
function prettySize($size)
{
    $mb = (1024*1024);
    if ( $size > $mb ) {
        $mysize = sprintf ("%01.2f", ($size/$mb)) . " MB";
    } elseif ( $size >= 1024 ) {
        $mysize = sprintf ("%01.2f", ($size/1024)) . " KB";
    } else {
        $mysize = sprintf(_DL_NUMBYTES, $size);
    }
    return $mysize;
}

/**
 * Updates rating data in itemtable for a given item
 *
 * @param string $sel_id ID of selection
 * @return void
 */
function updateDlRating($sel_id)
{
    global $db, $modversion, $table;

    $sql    = "
        SELECT rating
            FROM $table[3]
            WHERE lid = $sel_id";
    $result = $db->query($sql);
    $num_votes   = intval($db->num_rows($result));
    $totalrating = 0;
    while (list($rating) = @$db->fetch_row($result)) {
        $totalrating += intval($rating);
    }

    if ( $result ) {
        $finalrating = ($totalrating/$num_votes);
        $finalrating = number_format($finalrating, 2);
    } else {
        $finalrating = 0;
    }
    $sql = "
        UPDATE $table[3]
            SET rating=$finalrating,
                votes=$num_votes
            WHERE lid = $sel_id";
    $db->query($sql) or print($db->error());
}

/**
 * @desc Returns the total number of items in items table
 * that are associated with a given table $table id
 *
 * @param string $sel_id Selection ID
 * @param type $status description
 * @return integer number of items in items table
 */
function _getTotalItems($sel_id, $status='')
{
    global $db, $modversion, $mytree, $table;

    $count = 0;
    $arr   = array();
    $sql = "
        SELECT COUNT(*)
            FROM $table[1]
            WHERE cid=".$sel_id."";

    if ( $status!="" ) {
        $sql .= " AND status>=$status";
    }

    $result      = $db->query($sql);
    list($thing) = $db->fetch_row($result);
    $count = $thing;
    $arr   = $mytree->getAllChildId($sel_id);
    $size  = count($arr);

    for ( $i = 0; $i < $size; $i++ ) {
        $sql = "
            SELECT COUNT(*)
                FROM $table[1]
                WHERE cid=".$arr[$i]."";
        if ( $status != "" ) {
            $sql .= " AND status>=$status";
        }
        $result     = $db->query($sql);
        $return = 0;
        list($thing) = $db->fetch_row($result);
        $return += $thing;
    }
    return $return;
}

/**
 * @desc Returns the total number of items in table that
 * are associated with a given table $table id
 *
 * @param type $var description
 * @return integer Count
 */
function getTotalItems($sel_id, $status='')
{
    global $db, $modversion, $mytree, $table;

    $arr   = array();
    $arr   = $mytree->getAllChildId($sel_id);
    $size  = count($arr);
    $sql = '
        SELECT SUM(cid='.intval($sel_id).')';
    for ( $i = 0; $i < $size; $i++ ) {
        $sql .= ', SUM(cid='.intval($arr[$i]).')';
    }
    $sql .= ' FROM '.$table[1];
    if ( $status != '' ) {
        $sql .= ' WHERE status >= '.intval($status).'';
    }
    $result = $db->query($sql);
    $count  = $db->fetch_row($result);
    if ( !empty($count) ) {
        foreach ( $count as $key => $value ) {
            $return += $value;
        }
    }
    return $return;
}

/**
 * @return string HTML list of option tags
 * @param string array $array Sequence of option values
 * @desc Generates a series of option entries from an array,
 * the first option is selected
 * All option texts wlll be the same as the value
 */
function optionArray($array)
{
    $return = "";
    $sel =  " selected='selected'";
    foreach ( $array as $value ) {
        $return .= "<option value='$value'$sel>$value</option>";
        $sel = "";
    }
    return $return;
}
?>
