<?php
/**
 * File: $Id: admin_priv_forums.php,v 1.19 2005/03/25 15:03:21 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * Based on phpBB (@link http://www.phpBB.com)
 * @license type: GPL
 *
 */

include_once("admin_header.php");
include_once("../include/functions.php");
include_once("../include/config.php");
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

$op = $sys_request['op'];

/**
 * Check for valid op_edit in $sys_request
 */
$valid_op_edit = array('revokeuserpost', 'grantuserpost', 'deluser');
if ( in_array($sys_request['op_edit'], $valid_op_edit) ) {
    $op = $sys_request['op_edit'];
}
if ( $sys_request['submit'] == 'Submit' ) {
    $op = 'adduser';
}

if ( empty($op) ) {
    $sql = "
        SELECT forum_name, forum_id
            FROM ".$db->prefix("bb_forums")."
            WHERE forum_type = 1
            ORDER BY forum_id";
    $result = sqlSuccess($sql);
    if ( $myrow = $db->fetch_array($result) ) {
        $forum_array = array();
        do {
            $name = $myts->makeTboxData4Show($myrow['forum_name']);
            $forum_array[$myrow['forum_id']] = $name;
        } while ($myrow = $db->fetch_array($result));
    } else {
        $forum_array = array('-1' => _BB_NFID);
    }
    $form = new SysThemeForm(_BB_SELECTFORUMEDIT, 'select_pforum', './admin_priv_forums.php');
    $form_array = array();

    $form_array[] = new SysFormSelect('', 'forum', '', 1, false, $forum_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'showform');

    $form->display($form_array);

} else {
    /**
     * Opcode exists. See what it is, do stuff.
     */
    switch ( $op ) {
        case 'adduser':
        /**
         * Add user(s) to the list for this forum.
         */
        if ( $userids ) {
            foreach ($sys_request['userids'] as $key => $curr_userid) {
                $sql = "
                    INSERT INTO ".$db->prefix("bb_forum_access")."
                        SET forum_id = $forum,
                            user_id  = ".$curr_userid[0].",
                            can_post = 0";
                $result = sqlSuccess($sql);
            }
        }
        break;

        case 'deluser';
        /**
         * Remove a user from the list for this forum.
         */
        $sql = "
            DELETE
                FROM ".$db->prefix("bb_forum_access")."
                WHERE forum_id=$forum AND user_id=$op_userid";
        $result = sqlSuccess($sql);
        break;

        case 'clearusers':
        /**
         * Remove all users from the list for this forum.
         */
        $sql = "
            DELETE
                FROM ".$db->prefix("bb_forum_access")."
                WHERE forum_id=$forum";
        $result = sqlSuccess($sql);
        break;

        case 'grantuserpost':
        /**
         * Add posting rights for this user in this forum.
         */
        $sql = "
            UPDATE ".$db->prefix("bb_forum_access")."
                SET can_post=1
                WHERE forum_id=$forum AND user_id=$op_userid";
        $result = sqlSuccess($sql);
        break;

        case 'revokeuserpost':
        /**
         * Revoke posting rights for this user in this forum.
         */
        $sql = "
            UPDATE ".$db->prefix("bb_forum_access")."
                SET can_post=0
                WHERE forum_id=$forum AND user_id=$op_userid";
        $result = sqlSuccess($sql);
        break;
    }

    if ( $forum == -1 ) {
        closeTable();
        sysCpFooter();
        exit();
    } else {


        /**
         * Show the form for the given forum.
         */
        /**
         * Get forum name
         */
        $sql = "
            SELECT forum_name
                FROM ".$db->prefix("bb_forums")."
                WHERE forum_id=$forum";
        $result = sqlSuccess($sql);
        if ( $row = $db->fetch_array($result) ) {
            $forum_name = $myts->makeTboxData4Show($row['forum_name']);
        }
        /**
         * Get current users
         */
        $sql = "
            SELECT u.uid, u.uname, f.can_post
                FROM ".$db->prefix("users")." u, ".$db->prefix("bb_forum_access")." f
                WHERE u.uid=f.user_id AND f.forum_id=$forum";
        $result = sqlSuccess($sql);
        $current_users = array();
        while ( list($uid, $uname, $can_post) = $db->fetch_row($result) ) {
            $current_users[$uid]['uname'] = $uname;
            $current_users[$uid]['can_post'] = $can_post;
            $current_users[$uid]['can_access'] = true;
        }
        /**
         * Get possible new users
         */
        $sql = "
            SELECT uid, uname
                FROM ".$db->prefix("users")."
                WHERE uid <> 0 AND level <> -1
                ORDER BY uname ASC";
        $result = sqlSuccess($sql);
        /**
         * Add users to $new_users if they are not in $current_users
         */
        $new_users = array();
        while ( list($uid, $uname) = $db->fetch_row($result) ) {
            if ( !array_key_exists($uid, $current_users) ) {
                $new_users[$uid] = $uname;
            }
        }
        /**
         * Generate User table entries
         */
            $test[0][] = new SysFormLabel('', '<strong>User Name</strong>');
            $test[0][] = new SysFormLabel('', '');
            $test[0][] = new SysFormLabel('', '<strong>Post Toggle</strong>');
            $test[0][] = new SysFormLabel('', '<strong>Remove</strong>');
        // :: TODO :: this information is already in $current_users
        $sql = "
            SELECT u.uname, u.uid, f.can_post
                FROM ".$db->prefix("users")." u, ".$db->prefix("bb_forum_access")." f
                WHERE u.uid=f.user_id AND f.forum_id=$forum
                ORDER BY u.uname ASC";
        $result = sqlSuccess($sql);
        while ( $row = $db->fetch_array($result) ) {
            if ( $row['can_post'] ) {
                $post_text = "can post";
            } else {
                $post_text = "can't post";
            }
            $path = SYS_MOD_URL."/".$sysModule->dirname()."/admin/admin_priv_forums.php?forum=$forum&amp;op_userid=".$row['uid']."&amp;op_edit=";
            if ( $row['can_post'] ) {
                $post_toggle_link = myTextForm($path."revokeuserpost", _BB_REVOKEPOSTING);
            } else {
                $post_toggle_link = myTextForm($path."grantuserpost", _BB_GRANTPOSTING);
            }
            $remove_link = myTextForm($path."deluser", _REMOVE);

            $test[$row['uid']]['uname']     = new SysFormLabel('', $row['uname']);
            $test[$row['uid']]['post_text'] = new SysFormLabel('', $post_text);
            $test[$row['uid']]['post_link'] = new SysFormLabel('', $post_toggle_link);
            $test[$row['uid']]['remove']    = new SysFormLabel('', $remove_link);
        }
        /**
         * Set up clear all users button
         */
        $link = SYS_MOD_URL."/".$sysModule->dirname()."/admin/admin_priv_forums.php?forum=".$forum."&amp;op=clearusers";
        $clear_link = myTextForm($link, _BB_CLEARALLUSERS);

        /**
         * Create form
         */
        include_once(SYS_ROOT_PATH."/class/sysformloader.php");
        $form = new SysThemeForm(sprintf(_BB_EFPF, $forum_name), 'pforum_edit', './admin_priv_forums.php');

        $form_array = array();
        if ( count($new_users) > 0 ) {
            $form_array[] = new SysFormSelect(_BB_UWOA, 'userids[]', '', min(count($new_users), 10), 'multiple', $new_users);
            $form_array[] = new SysFormHidden('op', 'adduser');
            $form_array[] = new SysFormButtonTray();
        }
        if ( count($current_users) > 0 ) {
            $form_array[] = new SysFormElementTable('Forum Users', $test);
            $form_array[] = new SysFormLabel('', $clear_link);
        }
        $form_array[] = new SysFormHidden('forum', $forum);

        /**
         * Write form
         */
        $form->display($form_array);
    }
}
closeTable();
sysCpFooter();
?>
