<?php
/**
 * File: $Id: functions.php,v 1.10 2005/05/07 11:09:59 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * Based on phpBB (@link http://www.phpBB.com )
 *
 * @license GPL
 *
 */

/**
 *
 * Gets the total number of threads in a forum
 *
 * @param string $forum_id valid forum ID
 * @return number Thread count for forum
 */
function getTotalThreads($forum_id="")
{
    global $db;

    $return = _ERROR;
    if ( $forum_id ) {
        $sqladd = "WHERE forum_id = $forum_id";
    }
    $sql = "
        SELECT COUNT(*) AS total
            FROM ".$db->prefix('bb_threads').
            $sqladd;
    if ( ( $result = $db->query($sql) )
            && ( $myrow = $db->fetch_array($result) ) ) {
        $return = $myrow['total'];
    }
    return $return;
}

/**
 * Returns the total number of posts in the whole system, a forum, or a thread
 * Also can return the number of users on the system.
 *
 * @param type $id description
 * @param type $type values: users, all, forum, thread, (user deprecated)
 * @return type description
 */
function getTotalPosts($id, $type)
{
    global $db;

    switch($type) {
        case 'users':
        $sql = "
            SELECT COUNT(*) AS total
                FROM ".$db->prefix("users")." u
                WHERE (u.uid != 0) AND (level != -1)";
        break;

        case 'all':
        $sql = "
            SELECT COUNT(*) AS total
                FROM ".$db->prefix("bb_posts");
        break;

        case 'forum':
        case 'thread':
        $sql = "
            SELECT COUNT(*) AS total
                FROM ".$db->prefix("bb_posts")."
                WHERE thread_id = '$id'";
        break;

        // Old, we should never get this.
        case 'user':
        die("Should be using the users.user_posts column for this.");
        break;
    }

    if ( !$result = $db->query($sql) ) {
        $return = _ERROR;
    } elseif ( !$myrow = $db->fetch_array($result) ) {
        $return = '0';
    } else {
        $return = $myrow['total'];
    }
    return $return;
}

/**
 * Returns the most recent post in a forum, or on a thread
 *
 * @param string $id id - depends on type
 * @param string $type time_fix, forum, thread, user
 * @return type description
 */
function getLastPost($id, $type)
{
    global $db;

    switch( $type ) {
        case 'time_fix':
        $sql = "
            SELECT p.post_time
                FROM ".$db->prefix("bb_posts")." p
                WHERE p.thread_id = '$id'
                ORDER BY post_time DESC";
        break;

        case 'forum':
        $sql = "
            SELECT p.post_time, p.uid, u.uname
                FROM ".$db->prefix("bb_posts")." p, ".$db->prefix("users")." u
                WHERE p.forum_id = '$id' AND p.uid = u.uid
                ORDER BY post_time DESC";
        break;

        case 'thread':
        $sql = "
            SELECT p.post_time, u.uname
                FROM ".$db->prefix("bb_posts")." p, ".$db->prefix("users")." u
                WHERE p.thread_id = '$id' AND p.uid = u.uid
                ORDER BY post_time DESC";
        break;

        case 'user':
        $sql = "
            SELECT p.post_time
                FROM ".$db->prefix("bb_posts")." p
                WHERE p.uid = '$id'";
        break;
    }

    if ( !$result = $db->query($sql, 1, 0) ) {
        $return = _ERROR;
    } elseif ( !$myrow = $db->fetch_array($result) ) {
        $return = _BB_NOPOSTS;
    } elseif ( ($type != 'user') && ($type != 'time_fix') ) {
        $return = sprintf("%s <br /> %s %s", $myrow['post_time'], _BY2, $myrow['uname']);
    } else {
        $return = $myrow['post_time'];
    }
    return $return;
}

/**
 * @desc Lists the moderators of a forum
 *
 * @param string $forum_id Forum ID
 * @return void Outputs Forum moderator list-box
 */
function listModerators($forum_id=0)
{
    global $db, $myts;

    $sql = "
        SELECT u.uid, u.uname
            FROM ".$db->prefix("users")." u, ".$db->prefix("bb_forum_mods")." f
            WHERE f.forum_id=$forum_id AND f.user_id=u.uid";
    if ( $result = $db->query($sql) ) {
        /**
         * If more that one moderator generate list-box
         */
        if ( $db->num_rows($result) > 1 ) {
            $return = "
        <select class='select' name='moderators' onchange='top.location.href=\"".SYS_ROOT_URL."/userinfo.php?uid=\" + this.options[this.options.selectedIndex].value + \"\";'>
        <option value='1'>------</option>";
            while ( list($uid, $uname) = $db->fetch_row($result) ) {
                $return .= "<option value='$uid'>".$myts->makeTboxData4Show($uname)."</option>";
            }
            $return .= "</select>";
        /**
         * If only one moderator show name
         */
        } else {
            list($uid, $uname) = $db->fetch_row($result);
            $return .= " <a href='".SYS_ROOT_URL."/userinfo.php?uid=".$uid."'>".$myts->makeTboxData4Show($uname)."</a>";
        }
    } else {
        /**
         * If no moderator show ?
         */
        $return .= " ?";
    }
    echo $return;
}

/**
 * @desc Checks if a user is a moderator of a forum
 *
 * @param string $forum_id Forum ID
 * @param string $user_id User ID
 * @return boolean True if moderator, false if not or on error
 */
function isModerator($forum_id, $user_id)
{
    global $db;

    $sql = "
        SELECT user_id
            FROM ".$db->prefix("bb_forum_mods")."
            WHERE forum_id = '$forum_id' AND user_id = '$user_id'";
    $return = false;
    if ( $result = $db->query($sql) ) {
        if ( $myrow = $db->fetch_array($result) && $myrow['user_id'] = '' )  {
            $return = true;
        }
    }
    return $return;
}

/**
 * @return boolean
 * @param string $thread Thread ID
 * @desc Checks if a forum thread is locked
 */
function isLocked($thread)
{
    global $db;

    $sql = "
        SELECT thread_status
            FROM ".$db->prefix("bb_threads")."
            WHERE thread_id = '$thread'";
    $return = false;
    if ( $result = $db->query($sql) ) {
        if ( ( $m = $db->fetch_array($result) ) && ( $m[thread_status] === true ) ) {
            $return = true;
        }
        return $return;
    }
}

/**
 * @desc Checks if the given userid is allowed to log into the given (private) forumid.
 * If the "is_posting" flag is true, checks if the user is allowed to post to that forum.
 * @return boolean
 * @param string $userid User ID
 * @param string $forumid Forum ID
 * @param boolean $is_posting User is trying to post
 */
function checkPrivForumAuth($userid, $forumid, $is_posting)
{
    global $db;

    if ( $is_posting ) {
        $sqladd = "AND (can_post = 1)";
    }
    $sql = "
        SELECT count(*) AS user_count
            FROM ".$db->prefix("bb_forum_access")."
            WHERE (user_id = $userid) AND (forum_id = $forumid)
            $sqladd";
    $return = false;
    if ( $result = $db->query($sql) ) {
        if ( $row = $db->fetch_array($result)  && $row[user_count] > 0 ) {
            $return = true;
        }
    }
    return $return;
}

/**
 * @desc Displays an error message and exits the script. Used in the posting files.
 *
 * @param string $msg Error message
 * @return void Outputs error message and closes page
 */
function errorDie($msg)
{
    global $bbWidth;

    $return = "
        <br />
        <table border='0' cellpadding='1' cellspacing='0' align='center' width='$bbWidth'>
            <tr>
                <td class='bg2'>
                    <table border='0' cellpadding='1' cellspacing='1' width='100%'>
                        <tr class='bg3' align='left'>
                            <td><p><ul>$msg</ul></p></td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
        <br />";
    echo $return;
    closeTable();
    include_once("include/footer.php");
    exit();
}

/**
* Description
*
* @param type $var description
* @return type description
*/
function makeJumpbox()
{
    global $db, $myts, $sysUser, $sysModule, $mytree;

    $return = "
        <form action='viewforum.php' method='get'>
        <select class='select' name='forum'>
            <option value='-1'>"._BB_SELFORUM."</option>";

    include_once(SYS_ROOT_PATH."/class/datatree.php");
    $mytree = new DataTree($sysModule->mid());
    // :: At present this shows all Forum topics even if there is no forum for the topic
    $topics = $mytree->getAllIDs();
    foreach ( $topics as $topic ) {
        $topic = $mytree->getSingleItem($topic);
        //print_r($topic);
        $topic['topic_title'] = $myts->makeTboxData4Show($topic['topic_title']);
        $return .= "<option value='-1'>".$topic['topic_title']."</option>";
        $sub = "
            SELECT forum_id, forum_name, forum_type
                FROM ".$db->prefix("bb_forums")."
                WHERE topic_id ='$topic[topic_id]'
                ORDER BY forum_id";
        if ( $result = $db->query($sub) ) {
            while ( list($forum_id, $forum_name, $forum_type) = $db->fetch_row($result) ) {
                if ( $forum_type == 1 ) {
                    if ( !$sysUser || (!$sysUser->isAdmin($sysModule->mid())
                            && !checkPrivForumAuth($sysUser->uid(), $forum_row[$x]['forum_id'], 0)) ) {
                        continue;
                    }
                }
                $name = $myts->makeTboxData4Show($forum_name);
                $return .= "<option value='".$forum_id."'>+&nbsp;$name</option>";
            }
        } else {
            $return .= "<option value='0'>"._BB_ERRORCONNECT."</option>";
        }
    }
    $return .= "</select>
    <input type='submit' class='button' value='"._SUBMIT."' />
    </form>";
    echo $return;
}


/**
 * @return unknown
 * @param string $id
 * @param string $type
 * @desc Enter description here...
 */
function sync($id, $type)
{
    global $db;

    switch($type) {

        case 'forum':
            $sql = "
                SELECT max(post_id) AS last_post
                    FROM ".$db->prefix("bb_posts")."
                    WHERE forum_id = $id";
            if ( !$result = $db->query($sql) ) {
                die("Could not get post ID");
            }
            if ( $row = $db->fetch_array($result) ) {
                $last_post = $row["last_post"];
            }
            $sql = "
                SELECT count(post_id) AS total
                    FROM ".$db->prefix("bb_posts")."
                    WHERE forum_id = $id";
            if ( !$result = $db->query($sql) ) {
                die("Could not get post count");
            }
            if ( $row = $db->fetch_array($result) ) {
                $total_posts = $row["total"];
            }
            $sql = "
                SELECT count(thread_id) AS total
                    FROM ".$db->prefix("bb_threads")."
                    WHERE forum_id = $id";
            if ( !$result = $db->query($sql) ) {
                die("Could not get thread count");
            }
            if ( $row = $db->fetch_array($result) ) {
                $total_threads = $row["total"];
            }
            $sql = "
                UPDATE ".$db->prefix("bb_forums")."
                    SET forum_last_post_id  = $last_post,
                        forum_posts         = $total_posts,
                        forum_threads        = $total_threads
                    WHERE forum_id = $id";
            if ( !$result = $db->query($sql) ) {
                die("Could not update forum $id");
            }
            break;

        case 'thread':
            $sql = "
                SELECT max(post_id) AS last_post
                    FROM ".$db->prefix("bb_posts")."
                    WHERE thread_id = $id";
            if ( !$result = $db->query($sql) ) {
                die("Could not get post ID");
            }
            if ( $row = $db->fetch_array($result) ) {
                $last_post = $row["last_post"];
            }
            if ( $last_post > 0 ) {
                $sql = "
                    SELECT count(post_id) AS total
                        FROM ".$db->prefix("bb_posts")."
                        WHERE thread_id = $id";
                if ( !$result = $db->query($sql) ) {
                    die("Could not get post count");
                }

                if ( $row = $db->fetch_array($result) ) {
                    $total_posts = $row["total"];
                }
                $total_posts -= 1;
                $sql = "
                    UPDATE ".$db->prefix("bb_threads")."
                        SET thread_replies       = $total_posts,
                            thread_last_post_id  = $last_post
                        WHERE thread_id = $id";

                if ( !$result = $db->query($sql) ) {
                    die("Could not update thread $id");
                }
            }
            break;

        case 'all forums':
            $sql = "
                SELECT forum_id
                    FROM ".$db->prefix("bb_forums")."";
            if ( !$result = $db->query($sql) ) {
                die("Could not get forum IDs");
            }
            while ( $row = $db->fetch_array($result) ) {
                $id = $row["forum_id"];
                sync($id, "forum");
            }
            break;

        case 'all threads':
            $sql = "
                SELECT thread_id
                    FROM ".$db->prefix("bb_threads")."";
            if ( !$result = $db->query($sql) ) {
                die("Could not get thread IDs");
            }
            while ( $row = $db->fetch_array($result) ) {
                $id = $row["thread_id"];
                sync($id, "thread");
            }
            break;
    }
    return true;
}

?>
