<?php
/**
 * File: $Id: viewthread.php,v 1.16 2005/05/10 09:14:54 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * Based on phpBB (@link http://www.phpBB.com )
 *
 * @license GPL
 *
 */

include_once("include/header.php");

$forum    = intval($forum);
$thread_id = intval($thread_id);

if ( empty($forum) ) {
    redirectHeader('index.php', 2, _BB_ERRORFORUM);
    exit();
} elseif ( empty($thread_id) ) {
    redirectHeader('viewforum.php?forum='.$forum.'', 2, _BB_ERRORTHREAD);
    exit();
}

include_once("class/class.forumposts.php");

$sql = "
    SELECT
           t.thread_title,
           t.thread_status,
           t.thread_sticky,
           f.forum_name,
           f.forum_access,
           f.forum_type,
           f.allow_html,
           f.allow_sig,
           f.posts_per_page,
           f.hot_threshold,
           f.threads_per_page
       FROM ".$db->prefix("bb_threads")." t
       LEFT JOIN ".$db->prefix("bb_forums")." f ON f.forum_id = t.forum_id
       WHERE t.thread_id = $thread_id AND t.forum_id = $forum";

if ( !$result = $db->query($sql) ) {
    $error = "<h4>"._BB_ERROROCCURED."</h4><hr />"._BB_COULDNOTQUERY;
    redirectHeader("index.php", 2, $error);
    exit();
}

if ( !$forumdata = $db->fetch_array($result) ) {
    redirectHeader("index.php", 2, _BB_FORUMNOEXIST);
    exit();
}

/**
 * Check forum access
 */

if ( $forumdata['forum_type'] == 1 ) {
    if ( $sysUser
            && ( $sysUser->isAdmin($sysModule->mid())
            || ( checkPrivForumAuth($sysUser->uid(), $forum, true)) ) ) {
        // continue
    } else {
        $sysHandler['security']->showSecurityERR("index.php", 2, _BB_NORIGHTTOACCESS);
        exit();
    }
}

/**
 * Check if user can post
 */
$canpost = false;
if ( $forumdata['forum_access'] == 2 ) {
    $canpost = true;
} elseif ( !$sysUser) {
    $canpost = false;
} elseif ( $forumdata['forum_access'] == 1 ) {
    $canpost = true;
} elseif ( $sysUser->isAdmin
        || isModerator($forum, $sysUser->getVar("uid")) ) {
    $canpost = true;
}

$total = getTotalPosts($thread_id, "thread");
if ( $total > $forumdata['posts_per_page'] ) {
    $times = 0;
    for ($x=0; $x<$total; $x+=$forumdata['posts_per_page']) {
        $times++;
    }
    $pages = $times;
}

$forumdata['thread_title'] = $myts->makeTboxData4Show($forumdata['thread_title']);

cookie("bbthread_time[$thread_id]", time());

include_once(SYS_ROOT_PATH."/include/header.php");

openTable();
$total_forum = getTotalPosts($forum, 'forum');
echo "<table border='0' width='$bbWidth' cellpadding='5' align='center'>
        <tr>
            <td align='left'><img src='".$bbImage['f_open']."' alt='/' align='middle' />&nbsp;
                <a href='".$bbUrl['root']."index.php'>"._BB_FORUMINDEX."</a>
                <br />&nbsp;&nbsp;&nbsp;
                <img src='".$bbImage['f_open']."' alt='/' align='middle' />&nbsp;
                <a href='". $bbUrl['root']."viewforum.php?forum=$forum&amp;$total_forum'>".$myts->makeTboxData4Show($forumdata['forum_name'])."</a>
                <br />
                <img src='".$bbImage['f_content']."' alt='/' align='middle' />&nbsp;&nbsp;<b>".$forumdata['thread_title']."</b>
            </td>
            <td align='right'>";
if ( $canpost ) {
    echo "      <input type='button' class='button' value='"._BB_POSTNEW."' onclick='location.href=\"newthread.php?forum=".$forum."\"' />";
} else {
    echo "      <a href='".SYS_ROOT_URL."/register.php'>"._BB_REGTOPOST."</a>";
}
echo "      </td>
        </tr>
    </table>";

if ( isset($post_id) && $post_id != "" ) {
    $forumpost = new ForumPosts($post_id);
} else {
    $forumpost = new ForumPosts();
}

if ( $sysUser ) {
    if ( !isset($order) ) {
        $order = $sysUser->getVar("uorder");
    }
    if ( !isset($viewmode) && $sysUser->getVar("umode") != "0" ) {
        $viewmode = $sysUser->getVar("umode");
    }
} else {
    if ( !isset($order) ) {
        $order = $sysConfig['com_order'];
    }
    if ( !isset($viewmode) && ($sysConfig['com_mode'] != "0") ) {
        $viewmode = $sysConfig['com_mode'];
    }
}

if ( $order == 1 ) {
    $qorder = "post_time DESC";
} else {
    $qorder = "post_time ASC";
}
$forumpost->setOrder($qorder);

if ( !isset($post_id) || $post_id == "" ) {
    $pid=0;
    $forumpost->setThreadId($thread_id);
    $forumpost->setParent($pid);
}

if ( $viewmode == "thread" ) {
    $postsArray = $forumpost->getTopPosts();
} else {
    $viewmode = "flat";
    if ( isset($start) ) {
        $postsArray = $forumpost->getAllPosts($forumdata['posts_per_page'], $start);
    } else {
        $postsArray = $forumpost->getAllPosts($forumdata['posts_per_page']);
    }
}

include("include/navbar.php");

$adminview = false;
if ( $sysUser && ( $sysUser->isAdmin($sysModule->mid())
            || isModerator($forum, $sysUser->uid()) ) ) {
    $adminview = true;
}

if ( $viewmode == "flat" ) {
    $count = 0;
    foreach ($postsArray as $obj) {
        if ( !($count % 2) ) {
            $row_color = 1;
        } else {
            $row_color = 2;
        }
        $forumpost->setType($obj->type);
        $obj->showPost($viewmode, $order, $canpost, $forumdata['thread_status'], $forumdata['allow_sig'], $adminview, $row_color);
        $count++;
    }
}

//if the mode is thread, show thread
if ( $viewmode == "thread" ) {
    foreach ($postsArray as $obj) {
        $forumpost->setType($obj->type);
        $obj->showPost($viewmode, $order, $canpost, $forumdata['thread_status'], $forumdata['allow_sig'], $adminview);

        //if not in the top page, show links
        if ( $forumpost->parent() ) {
            echo "<div style='text-align:left'>";
            echo "&nbsp;<a href='./viewthread.php?forum=$forum&amp;thread_id=$thread_id&amp;viewmode=$viewmode&amp;order=$order'>"._TOP."</a>&nbsp;|&nbsp;<a href='"._PHP_SELF."?forum=$forum&amp;thread_id=$thread_id&amp;post_id=".$forumpost->parent()."&amp;viewmode=".$viewmode."&amp;order=".$order."#".$forumpost->parent()."'>"._PARENT."</a>";
            echo "</div>";
        }
        echo "<br />";
        $treeArray = $forumpost->getPostTree($obj->postid());
        if ( count($treeArray) > 0 ) {
            $obj->showTreeHead();
            $count = 0;
            foreach ($treeArray as $treeItem) {
                if ( !($count % 2) ) {
                    $color_num = 1;
                } else {
                    $color_num = 2;
                }
                $treeItem->showTreeItem($viewmode, $order, $color_num);
                $count++;
            }
            $obj->showTreeFoot();
        }
        echo "<br />";
    }
}

if ( !isset($refresh) && $viewmode != "thread" ) {
    $sql = "
        UPDATE ".$db->prefix("bb_threads")."
            SET thread_views=thread_views+1
            WHERE thread_id=$thread_id";
    $db->query($sql);
}

if ( !$forumpost->parent() ) {
	echo "<br />";
    include("include/navbar.php");
}

/**
 * Post New thread + Admin icons
 */
echo "<table width='$bbWidth'><tr><td align='left'>";
if ( $canpost == true ) {
    echo "<input type='button' class='button' value='"._BB_POSTNEW."' onclick='location.href=\"newthread.php?forum=".$forum."\"' /></td><td align='left' width='100%' >";
}

if ( !empty($sysUser) && ( $sysUser->isAdmin($sysModule->mid())
            || isModerator($forum, $sysUser->uid()) ) ) {
    $link_root = "<a href='".$bbUrl['root']."threadmanager.php?thread_id=$thread_id&amp;forum=$forum&amp;mode=";
    if ( $forumdata['thread_status'] ) {
        echo $link_root."unlock'><img src='".$bbImage['unlockthread']."' alt='"._BB_UNLOCKTHREAD."' /></a> ";
    } else {
        echo $link_root."lock'><img src='".$bbImage['lockthread']."' alt='"._BB_LOCKTHREAD."' /></a> ";
    }
    echo $link_root."move'><img src='".$bbImage['movethread']."' alt='"._BB_MOVETHREAD."' /></a> ";
    echo $link_root."del'><img src='".$bbImage['delthread']."' alt='"._BB_DELETETHREAD."' /></a> ";

    if ( $forumdata['thread_sticky'] == 0 ) {
        echo $link_root."sticky'><img src='".$bbImage['stickythread']."' alt='"._BB_STICKYTHREAD."' /></a>";
    } else {
        echo $link_root."unsticky'><img src='".$bbImage['unstickythread']."' alt='"._BB_UNSTICKYTHREAD."' /></a>";
    }
}
echo "</td><td align='right' nowrap='nowrap'>";

/**
 * Forum jump box
 */
makeJumpbox();
echo "</td></tr></table>";

closeTable();
include_once("include/footer.php");
?>
