<?php
/**
 * File: $Id: ratelink.php,v 1.13 2005/05/12 17:36:07 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author James Knickelbein <http://www.journeymilwaukee.com>
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

include_once("include/header.php");
include_once(SYS_ROOT_PATH."/class/module.errorhandler.php");

if ( $sys_request['submit'] ) {
    $eh = new ErrorHandler();
    $ratinguser = 0;
    if ( $sysUser ) {
        $ratinguser = $sysUser->uid();
    }

    /**
     * Make sure only 1 anonymous from an IP in a single day.
     */
    $anonwaitdays = 1;
    $ip     = _REMOTE_ADDR;
    $lid    = intval($sys_request['lid']);
    $rating = intval($sys_request['rating']);

    /**
     * Check if Rating is Null
     */
    if ( $rating == "--" ) {
        redirectHeader("ratelink.php?lid=".$lid."", 4, _LK_NORATING);
        exit();
    }

    /**
     * Check if Link POSTER is voting (UNLESS Anonymous users allowed to post)
     */
    if ( $ratinguser != 0 ) {
        $sql = "
        SELECT submitter
            FROM ".$db->prefix("links")."
            WHERE lid = $lid";
        $result = $db->query($sql);
        while (list($ratinguserDB) = $db->fetch_row($result)) {
            if ($ratinguserDB == $ratinguser) {
                redirectHeader("index.php", 4, _LK_CANTVOTEOWN);
                exit();
            }
        }

        /**
         * Check if REG user is trying to vote twice.
         */
        $sql = "
        SELECT ratinguser
            FROM ".$db->prefix("links_votedata")."
            WHERE lid = $lid";
        $result = $db->query($sql);
        while (list($ratinguserDB) = $db->fetch_row($result)) {
            if ($ratinguserDB == $ratinguser) {
                redirectHeader("index.php", 4, _LK_VOTEONCE2);
                exit();
            }
        }
    }

    /**
     * Check if ANONYMOUS user is trying to vote more than once per day.
     */
    if ( $ratinguser == 0 ) {
        $yesterday = (time()-(86400 * $anonwaitdays));
        $sql = "
        SELECT COUNT(*)
            FROM ".$db->prefix("links_votedata")."
            WHERE lid = $lid
                AND ratinguser = 0
                AND ratinghostname  = '$ip'
                AND ratingtimestamp > $yesterday";
        $result = $db->query($sql);
        list($anonvotecount) = $db->fetch_row($result);
        if ($anonvotecount > 0) {
            redirectHeader("index.php", 4, _LK_VOTEONCE2);
            exit();
        }
    }
    $rating = min($rating, 10);

    /**
     * All is well.  Add to Line Item Rate to DB.
     */
    $newid    = $db->genId($db->prefix("links_votedata")."_ratingid_seq");
    $datetime = time();
    $sql = "
    INSERT
        INTO ".$db->prefix("links_votedata")."
        SET ratingid        = $newid,
            lid             = $lid,
            ratinguser      = $ratinguser,
            rating          = $rating,
            ratinghostname  = '$ip',
            ratingtimestamp = $datetime";
    $db->query($sql) or $eh->show("0013");

    /**
     * All is well.  Calculate Score & Add to Summary (for quick retrieval & sorting) to DB.
     */
    updateLinkRating($lid);
    $ratemessage = _LK_VOTEAPPRE."<br />".sprintf(_LK_THANKURATE, $meta['title']);
    redirectHeader("index.php", 2, $ratemessage);
    exit();

} else {
    include_once(SYS_ROOT_PATH."/include/header.php");
    include_once(SYS_ROOT_PATH."/class/sysformloader.php");

    $page_title = "<div class='BlockTitle'>"._LK_RATETHISSITE."</div>";
    $sql = "
        SELECT title
            FROM ".$db->prefix("links")."
            WHERE lid = $lid";
    $result = $db->query($sql);
    list( $title ) = $db->fetch_row($result);
    for ( $i = 10; $i > 0; $i-- ) {
        $rate_array[$i] =$i;
    }

    $form = new SysThemeForm($page_title, 'ratelink', 'ratelink.php');
    $form_array = array();

    $form_array[] = new SysFormLabel($title, "
                        <div>"._LK_VOTEONCE."<div>
                        <div>"._LK_RATINGSCALE."<div>
                        <div>"._LK_BEOBJECTIVE."<div>
                        <div>"._LK_DONOTVOTE."<div>");
    $form_array[] = new SysFormSelect('', 'rating', 5, 1, false, $rate_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('lid', $lid);

    openTable();
    $form->display($form_array);
    closeTable();
}
include_once("include/footer.php");
?>
