<?php
/**
 * File: $Id: class.newsstory.php,v 1.14 2005/03/02 00:07:14 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @author The Xoops Project (@link http://www.xoops.org )
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */

include_once(SYS_ROOT_PATH."/class/sysstory.php");

class NewsStory extends SysStory
{

    var $newstopic;   // SysTopic object

    function NewsStory($storyid = -1)
    {
        global $db, $sysModule;

        $this->table         = $db->prefix("news_stories");
        $this->commentstable = $db->prefix("news_comments");
        $this->topicstable   = $db->prefix("topics");
        $this->moduleurl     = SYS_MOD_URL."/".$sysModule->dirname();

        if (is_array($storyid)) {
            $this->makeStory($storyid);
            $this->newstopic = $this->topic();
        } elseif ($storyid != -1) {
            $this->getStory(intval($storyid));
            $this->newstopic = $this->topic();
        }
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function getAllPublished($limit=0, $start=0, $topic=0, $ihome=0,
            $asobject=true)
    {
        global $db, $myts;

        $ret = array();
        $sql = "
            SELECT *
                FROM ".$db->prefix("news_stories")."
                WHERE published > 0 AND published <= ".time()."";

        if ( !empty($topic) ) {
            if ( is_array($topic) && count($topic) > 0 ) {
                //$t1 = $topic[0];
                //array_shift($topic);
                $sql .= "
                    AND (topicid='".implode("' OR topicid='", $topic )."')";
            } else {
                $sql .= "
                    AND topicid=".intval($topic);
            }
        }
        if ( !empty($ihome) ) {
            $sql .= "
                    AND ihome=".$ihome;
        }

        $sql   .= "
                ORDER BY published DESC";
        $result = $db->query($sql, intval($limit), intval($start));
        while ( $myrow = $db->fetch_array($result) ) {
            if ( $asobject ) {
                $ret[] = new NewsStory($myrow);
            } else {
                $ret[$myrow['storyid']] = $myts->makeTboxData4Show($myrow['title']);
            }
        }

        return $ret;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function getAllAutoStory($limit=0, $asobject=true)
    {
        global $db, $myts;

        $ret    = array();
        $sql    = "
            SELECT *
                FROM ".$db->prefix("news_stories")."
                WHERE published > ".time()."
                ORDER BY published ASC";
        $result = $db->query($sql, $limit, 0);

        while ( $myrow = $db->fetch_array($result) ) {
            if ( $asobject ) {
                $ret[] = new NewsStory($myrow);
            } else {
                $ret[$myrow['storyid']] = $myts->makeTboxData4Show($myrow['title']);
            }
        }

        return $ret;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function getAllSubmitted($limit=0, $asobject=true)
    {
        global $db, $myts;

        $ret    = array();
        $sql    = "
            SELECT *
                FROM ".$db->prefix("news_stories")."
                WHERE published=0
                ORDER BY created DESC";
        $result = $db->query($sql, $limit, 0);

        while ( $myrow = $db->fetch_array($result) ) {
            if ( $asobject ) {
                $ret[] = new NewsStory($myrow);
            } else {
                $ret[$myrow['storyid']] = $myts->makeTboxData4Show($myrow['title']);
            }
        }

        return $ret;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function getByTopic($topicid)
    {
        global $db;

        $ret    = array();
        $sql = "
            SELECT *
                FROM ".$db->prefix("news_stories")."
                WHERE topicid=".intval($topicid)."";
        $result = $db->query($sql);

        while ($myrow = $db->fetch_array($result)) {
            $ret[] = new NewsStory($myrow);
        }

        return $ret;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function countByTopic($topicid=false)
    {
        global $db;

        $sql = "
            SELECT COUNT(*)
                FROM ".$db->prefix("news_stories")."
                WHERE topicdisplay = 0 AND published > 0 ";
        if ( $topicid ) {
            if ( is_array($topicid) ) {
                $sql .= "AND (topicid = '".implode("' OR topicid = '", $topicid )."')";
            } else {
                $sql .= "AND topicid = ".intval($topicid)."";
            }
        }
        $result = $db->query($sql);
        list($count) = $db->fetch_row($result);

        return $count;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function topic_title()
    {
        return $this->newstopic->topic_title();
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function adminlink()
    {
        $return = "&nbsp;[ <a href='".$this->moduleurl."/admin/index.php?op=edit&amp;storyid=".$this->storyid."'>"._EDIT."</a> | <a href='".$this->moduleurl."/admin/index.php?op=delete&amp;storyid=".$this->storyid."'>"._DELETE."</a> ]&nbsp;";
        return $return;
    }

    /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function imglink()
    {
        if ( $this->newstopic->topic_imgurl() ) {
            $return = "<a href='".$this->moduleurl."/index.php?storytopic=".$this->topicid."'>
            <img src='".formatURL($this->moduleurl."/cache/topics/", $this->newstopic->topic_imgurl())."' alt='".$this->newstopic->topic_title()."' hspace='10' vspace='10' align='".$this->topicalign()."' /></a>";
        }
        return $return;
    }

     /**
    * Description
    *
    * @param type $var description
    * @return type description
    */
    function textlink()
    {
        global $sysModule;
        $return = "<a href='".$this->moduleurl."/index.php?storytopic=".$this->topicid()."'>".$this->newstopic->topic_title()."</a>";
        return $return;
    }
}
?>