<?php
/**
 * File: $Id: pollresults.php,v 1.12 2005/03/25 15:03:57 greyhead Exp $
 *
*  Ciamos: Simple + Flexible + Advanced Content Management
*  < http://www.ciamos.com >
*/
/**
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */$results_page = 1;

include_once('../../mainfile.php');
include_once('./include/constants.php');
include_once(SYS_ROOT_PATH."/class/syscomments.php");
include_once("./class/poll.php");
include_once("./class/polloption.php");
include_once("./class/polllog.php");
include_once("./class/pollrenderer.php");

$item_id = (!empty($item_id)) ? intval($item_id) : 0;
$poll_id = (!empty($poll_id)) ? intval($poll_id) : 0;

if ( empty($item_id) && empty($poll_id) ) {
    redirectHeader("index.php", 0);
    exit();
}

include_once(SYS_ROOT_PATH."/include/header.php");

// set comment mode if not set
if ( !isset($mode) || $mode == "" || ($mode != 0 && $mode != "thread" && $mode != "flat") ) {
    if ( $sysUser ) {
        $mode = $sysUser->getVar("umode");
    } else {
        $mode = $sysConfig['com_mode'];
    }
}


if ( !empty($comment_id) ) {
    $pollcomment = new SysComments($db->prefix("pollcomments"), $comment_id);
} else {
    $pollcomment = new SysComments($db->prefix("pollcomments"));
}

$item_id = (!empty($poll_id)) ? $poll_id : $item_id;
$pollcomment->setVar("item_id", $item_id);
$parentid = $pollcomment->getVar("pid");

if ( empty($parentid) ) {
    openTable();
    echo "<div class='modname'>"._PL_NAME."</div>\n<br />";
    $poll     = new SysPoll($item_id);
    $renderer = new SysPollRenderer($poll);
    echo $renderer->renderResults();
    closeTable();
    echo "<br />";
}

/**
* Comments start here
*/
// set comment order if not set
if ( !isset($order) ) {
    if ( $sysUser ) {
        $order = $sysUser->getVar("uorder");
    } else {
        $order = $sysConfig['com_order'];
    }
}
$order = intval($order);

$orderby = ($order == 1) ? "date DESC" : "date ASC";
if ( $mode == "flat" ) {
    $criteria = array("item_id=".$item_id."");
    $commentsArray = $pollcomment->getAllComments($criteria, true, $orderby);
} elseif ( $mode == "thread" ) {
    $criteria = array("item_id=".$item_id."", "pid=".$pollcomment->getVar("pid")."");
    $commentsArray = $pollcomment->getAllComments($criteria, true, $orderby);
} else {
    $commentsArray = "";
}

openTable();
$pollcomment->printNavBar($item_id, $mode, $order);

// Now, show comments
if ( is_array($commentsArray) && count($commentsArray) ) {
    if ( $sysUser && $sysUser->isAdmin($sysModule->mid()) ) {
        $adminview = 1;
    } else {
        $adminview = 0;
    }
    if ( $mode == "flat" ) {
        $count = 0;
        foreach ( $commentsArray as $ele ) {
            if ( !($count % 2) ) {
                $color_num = 1;
            } else {
                $color_num = 2;
            }
            $ele->showThreadPost($order, $mode, $adminview, $color_num);
            $count++;
        }
    }
    if ( $mode == "thread" ) {
        foreach ( $commentsArray as $ele ) {
            $ele->showThreadPost($order, $mode, $adminview);
            //show thread tree
            //if not in the top page, show links to parent and top comment
            if ( $ele->getVar("pid") != 0 ) {
                echo "<div style='text-align:left'>";
                echo "&nbsp;<a href='./pollresults.php?item_id=".$ele->getVar("item_id")."&amp;mode=".$mode."&amp;order=".$order."'>"._TOP."</a>&nbsp;|&nbsp;";
                echo "<a href='./pollresults.php?item_id=".$ele->getVar("item_id")."&amp;comment_id=".$ele->getVar("pid")."&amp;mode=".$mode."&amp;order=".$order."#".$ele->getVar("pid")."'>"._PARENT."</a>";
                echo "</div>";
            }
            echo "<br />";
            $treeArray = $ele->getCommentTree();
            if ( count($treeArray) >0 ) {
                $ele->showTreeHead();
                $count = 0;
                foreach ( $treeArray as $treeItem ) {
                    if ( !($count % 2) ) {
                        $color_num = 1;
                    } else {
                        $color_num = 2;
                    }
                    $treeItem->showTreeItem($order, $mode, $color_num);
                    $count++;
                }
                $ele->showTreeFoot();
            }
        }
        echo "<br />";
    }
}

closeTable();
/**
* Comments stop here
*/
include_once(SYS_ROOT_PATH."/include/footer.php");
?>
