<?php
/**
* File: $Id: main.php,v 1.11 2005/05/07 11:10:04 greyhead Exp $
* Administration for backups - Recycle Bin
* @package Ciamos
* @copyright (C) 2004 Ciamos Development Team.
* @license GPL {@link http://www.gnu.org/licenses/gpl.html}
* @link http://www.ciamos.com
* @subpackage Ciamos_xxx
* @link link to information for the subpackage
* @author Florian Solcher (alphalogic) (@link http://www.alphalogic.org)
*/

if ( !preg_match("/admin\.php/i", _PHP_SELF) ) {
    exit();
}
global $sys_request, $sysHandler, $sysModule, $sysSecurity, $sysUser, $db;

if ( !$sysUser->isAdmin($sysModule->mid()) ) {
    $sysHandler['security']->showSecurityERR(SYS_ROOT_URL.'/', 2, _NOPERM);
    exit();
}

//$op = 'default';
if ( isset($sys_request) ) {
    foreach ( $sys_request as $k => $v ) {
        $$k = $v;
    }
}
if ( isset($sys_request[$id]) ) {
    $id = $sys_request[$id];
}

switch ( $op ) {

    case 'undo':
    if ( !$db->backupExists($id) ) {
        redirectHeader("admin.php?fct=backups", 2, _RB_BDNE);
        exit();
    } else {
        if ( $sys_request['ok'] ) {
            $db->undoBackup($id);
            redirectHeader("admin.php?fct=backups", 1, _UPDATED);
            exit();
        } else {
            sysCpHeader();
            openTable();
            echo "
                    <h4 style='color: #ff0000'>"._RB_AYSUB."</h4>
                    <table>
                        <tr>
                        <td>".myTextForm("admin.php?fct=backups&op=undo&id=".$id."&ok=1",_YES)."</td>
                            <td>".myTextForm("admin.php?fct=backups", _NO)."</td>
                        </tr>
                    </table>
                    <br /><br />";
            closeTable();
            sysCpFooter();
        }
    }
    break;

    case 'delete':
    
    if ( !$db->backupExists($id) ) {
        redirectHeader("admin.php?fct=backups", 2, _RB_BDNE);
        exit();
    } else {
        if ( $sys_request['ok'] ) {
            $db->deleteBackup($id);
            redirectHeader("admin.php?fct=backups", 1, _RB_BD);
            exit();
        } else {
            sysCpHeader();
            openTable();
            echo "
                    <h4 style='color: #ff0000'>"._RB_AYSDB."</h4>
                    <table>
                        <tr>
                        <td>".myTextForm("admin.php?fct=backups&op=delete&id=".$id."&ok=1",_YES)."</td>
                            <td>".myTextForm("admin.php?fct=backups", _NO)."</td>
                        </tr>
                    </table>
                    <br /><br />";
            closeTable();
            sysCpFooter();

        }
    }
    break;

    default:
    sysCpHeader();
    if ( $sysConfig['backups'] ) {
        include_once(SYS_ROOT_PATH."/class/sysformloader.php");

        $table_array = array();
        $table_array[-1]['date']    = new SysFormLabel('', _DATE);
        $table_array[-1]['table']   = new SysFormLabel('', _TABLE);
        $table_array[-1]['sql']     = new SysFormLabel('', _RB_QUERIES);
        $table_array[-1]['actions'] = new SysFormLabel('', _ACTION);

        foreach ( $db->getBackups() as $id => $backup ) {
            // $id++;
            $sql = array();
            include_once($backup['file']);
            $actions = "<a href='admin.php?fct=backups&op=delete&id=$id'>"._DELETE."</a>&nbsp;|&nbsp;
            <a href='admin.php?fct=backups&op=undo&id=$id'>"._RB_UNDO."</a>";
            $table_array[$id]['date']    = new SysFormLabel('', formatTimestamp($backup['date']));
            $table_array[$id]['table']   = new SysFormLabel('', $backup['table']);
            $table_array[$id]['sql']     = new SysFormLabel('', implode('<br />', $sql));
            $table_array[$id]['actions'] = new SysFormLabel('', $actions);
            unset ($sql);
        }

        $form = new SysThemeForm(_RB_RB, 'DBBackup', _PHP_SELF);
        $form_array = array();
        $form_array[] = new SysFormElementTable('', $table_array);
        
        $form->display($form_array, true);
    } else {
        displayMessage(_RB_NOT_ACTIVATED);
    }
    sysCpFooter();
    break;
}
?>
