<?php
/**
 * File: $Id: preferences.php,v 1.25 2005/05/17 20:07:04 alphalogic Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

// check if the user is authorised
if ( !$sysUser->isAdmin($sysModule->mid()) ) {
    redirectHeader(SYS_ROOT_URL.'/', 2, _NOPERM);
    exit();
} 

include_once(SYS_ROOT_PATH."/class/sysformloader.php");
include_once(SYS_ROOT_PATH."/class/syslists.php");

function showPrefs()
{
    global $sysConfig, $sysUser;

    if ( $sysConfig['adminmail'] ) {
         $amail = $sysConfig['adminmail'];
    } else {
         $amail = $sysUser->getVar("email", "E");
    }
    $moduleslist       =& SysModule::getHasMainModulesList(true);
    $moduleslist["../.."] = _NONE;
    $unamelv_array = array(0 => _PR_STRICT, 1 => _PR_MEDIUM, 2 => _PR_LIGHT);
    $debug_options = array(
        "1" =>_PR_DBGERR,
        "2" =>_PR_DBGTIME,
        "4" =>_PR_DBGINFO,
        "8" =>_PR_DBGLOG,
        "16"=>_PR_DBGVIS);
    $debug_ops = array();
    foreach ( array(1, 2, 4, 8, 16) as $value ) {
        if ( $sysConfig['debug_mode'] & $value ) {
            $debug_ops[] = $value;
        }
    }
    
    $cache_array = array(0=>_OFF, 300=>5, 600=>10, 900=>15, 1800=>30, 3600=>60, 5400=>90, 7200=>120, 10800=>180);
    $cmode_array = array("0"=>_NOCOMMENTS, "flat"=>_FLAT, "thread"=>_THREADED);
    
    $form_array = $theme_array = $lib_array = $newuser_array = $av_array = $htmlarea_array = array();
    $form = new SysThemeForm(_PR_SITEPREF, "pref_form", "admin.php?fct=preferences");
    
    $form_array[] = new SysFormText(_PR_ADMINML, "adminmail", 50, 100, $amail);
    $form_array[] = new SysFormSelect(_PR_MAILFUNC, "mail_function", $sysConfig['mail_function'], 
        1, false, array('mail'=>'mail()', 'email'=>'email()'));
    $form_array[] = new SysFormSelectLang(_PR_LANGUAGE, "language", $sysConfig['language']);
    $form_array[] = new SysFormSelect(_PR_STARTPAGE, "startpage", $sysConfig['startpage'], 
        1, false, $moduleslist);
    $form_array[] = new SysFormSelectTimezone(_PR_DEFAULTTZ, "default_TZ", $sysConfig['default_TZ']);
        $theme_array[] = new SysFormSelectTheme("", "default_theme", $sysConfig['default_theme']);
        $theme_array[] = new SysFormCheckBox(_PR_CHNGUTHEME, "changeusers", ''. array(1 => _PR_CHNGUTHEME));
    $form_array[] = new SysFormElementTray(_PR_DTHEME, "&nbsp;", $theme_array);

    $form_array[] = new SysFormRadioYN(_PR_ALLOWTHEME, "allow_theme", $sysConfig['allow_theme'], _YES,_NO);
    $form_array[] = new SysFormSelect(_PR_MM_LAYOUT, "mainmenu_layout", $sysConfig['mainmenu_layout'], 
        1, false, array(0=>_PR_MM_CSSSTATIC, 1=>_PR_MM_JSDROPDOWN));
    $form_array[] = new SysFormText(_PR_ANONNAME, "anonymous", 50, 100, $sysConfig['anonymous']);
    $form_array[] = new SysFormText(_PR_MINPASS, "minpass", 10, 10, $sysConfig['minpass']);
    $form_array[] = new SysFormRadioYN(_PR_ANONPOST, "anonpost", $sysConfig['anonpost'], _YES,_NO);

    $form_array[] = new SysFormText(_PR_MAXPMS, "max_pms", 5, 5, $sysConfig['max_pms']);
    $form_array[] = new SysFormRadioYN(_PR_SITEOFFLINE, "offline_site", $sysConfig['offline_site'], _YES, _NO);
    $form_array[] = new SysFormTextArea(_PR_OFFLINEMSG, "offline_msg", $sysConfig['offline_msg'], 6);
    $form_array[] = new SysFormRadioYN(_PR_ALLOWHTML, "allow_html", $sysConfig['allow_html'], _YES,_NO);
    
    $form_array[] = new SysFormRadioYN(_PR_ALLOWIMAGE, "allow_image", $sysConfig['allow_image'], _YES,_NO);

        $lib_array[] = new SysFormRadioYN(_PR_LIBUSE, "allow_library", $sysConfig['allow_library'], _YES,_NO);
        $lib_array[] = new SysFormRadioYN(_PR_LIBUPLOAD, "lib_allow_upload", $sysConfig['lib_allow_upload'], _YES, _NO);
        $lib_array[] = new SysFormText(_PR_LIBW, "lib_width", 4, 4, $sysConfig['lib_width']);
        $lib_array[] = new SysFormText(_PR_LIBH, "lib_height", 4, 4, $sysConfig['lib_height']);
        $lib_array[] = new SysFormText(_PR_LIBMAX, "lib_maxsize", 7, 7, $sysConfig['lib_maxsize']);
    $form_array[] = new SysFormElementTray(_PR_LIBCONF, "<br />", $lib_array);
    
    $form_array[] = new SysFormRadioYN(_PR_ALLOW_REGISTER, "allow_register", $sysConfig['allow_register'], _YES,_NO);
    $form_array[] = new SysFormRadioYN(_PR_VERIFY_IMG, "img_verify", $sysConfig['img_verify'], _YES,_NO);
    $form_array[] = new SysFormRadioYN(_PR_AUTOREGISTER, "auto_register", $sysConfig['auto_register'], _YES,_NO);
    
        $newuser_array[] = new SysFormRadioYN("", "new_user_notify", $sysConfig['new_user_notify'], _YES,_NO);
        $newuser_array[] = new SysFormSelectGroup(_PR_NOTIFYTO, "new_user_notify_group", 
            false, $sysConfig['new_user_notify_group'], 1, false);
    $form_array[] = new SysFormElementTray(_PR_NEWUNOTIFY, "<br />", $newuser_array);

    $form_array[] = new SysFormRadioYN(_PR_SELFDELETE, "self_delete", $sysConfig['self_delete'], _YES,_NO);
    $form_array[] = new SysFormRadioYN(_PR_LOADINGIMG, "display_loading_img", $sysConfig['display_loading_img'], _YES,_NO);
    $form_array[] = new SysFormRadioYN(sprintf(_PR_USEGZIP,phpversion()), "gzip_compression", $sysConfig['gzip_compression'], _YES,_NO);
    $form_array[] = new SysFormSelect(_PR_UNAMELVL, "uname_test_level", 
        $sysConfig['uname_test_level'], 1, false, $unamelv_array);
    $form_array[] = new SysFormText(_PR_USERCOOKIE, "cookie_name", 50, 100, $sysConfig['cookie_name'], _PR_USERCOOKIEH);
    $form_array[] = new SysFormText(_PR_SESSCOOKIE, "session_name", 50, 100, $sysConfig['session_name'], _PR_SESSCOOKIEH);
    $form_array[] = new SysFormText(_PR_SESSEXPIRE, "session_expire", 15, 8, $sysConfig['session_expire']);
    $form_array[] = new SysFormRadioYN(_PR_SESSUSE, "use_sessions", $sysConfig['use_sessions'], _YES, _NO);
    $form_array[] = new SysFormRadioYN(_PR_BANNERS, "banners", $sysConfig['banners'], _YES, _NO);
    $form_array[] = new SysFormCheckBox(_PR_DEBUGMODE, "debug_mode", $debug_ops, $debug_options);
    $form_array[] = new SysFormSelect(_PR_CACHETIME, "cache_time", $sysConfig['cache_time'],
        1, false, $cache_array);
    $form_array[] = new SysFormSelect(_PR_COMMODE, "com_mode", $sysConfig['com_mode'],
        1, false, $cmode_array);
    $form_array[] = new SysFormSelect(_PR_COMORDER, "com_order", $sysConfig['com_order'],
        1, false, array("0"=>_OLDESTFIRST, "1"=>_NEWESTFIRST));

        $av_array[] = new SysFormRadioYN(_PR_AVATARALLOW, "avatar_allow_upload", $sysConfig['avatar_allow_upload'], _YES, _NO);
        $av_array[] = new SysFormText(_PR_AVATARW, "avatar_width", 4, 4, $sysConfig['avatar_width']);
        $av_array[] = new SysFormText(_PR_AVATARH, "avatar_height", 4, 4, $sysConfig['avatar_height']);
        $av_array[] = new SysFormText(_PR_AVATARMAX, "avatar_maxsize", 7, 7, $sysConfig['avatar_maxsize']);
    $form_array[] = new SysFormElementTray(_PR_AVATARCONF, "<br />", $av_array);
    
        $htmlarea_array[]  = new SysFormText(_PR_HTMLAREAROWS, "htmlarea_rows", 4, 4, $sysConfig['htmlarea_rows']);
        $htmlarea_array[]  = new SysFormText(_PR_HTMLAREACOLS, "htmlarea_cols", 4, 4, $sysConfig['htmlarea_cols']);
    $form_array[] = new SysFormElementTray(_PR_HTMLAREA, "<br />", $htmlarea_array);

    $form_array[] = new SysFormRadioYN(_PR_BACKUPS, "backups", $sysConfig['backups'], _YES, _NO);
	$form_array[] = new SysFormRadioYN(_PR_SOURCECODESTYLE, "sourcecodestyle", $sysConfig['sourcecodestyle'], _YES, _NO);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'save');
    $form_array[] = new SysFormHidden("old_session_use", $sysConfig['use_sessions']);
    $form_array[] = new SysFormHidden("old_session_name", $sysConfig['session_name']);


    $form->display($form_array, true);
}


/**
 * Validates and Saves the System Preferences to a cache file
 *
 */
function saveSysPrefs(
    $adminmail,
    $mail_function,
    $language,
    $startpage,
    $default_TZ,
    $default_theme,
    $allow_theme,
	$mainmenu_layout,
    $anonymous,
    $minpass,
    $anonpost,
    $max_pms,
    $offline_site,
    $offline_msg,
    $allow_register,
    $img_verify,
    $auto_register,
    $new_user_notify,
    $new_user_notify_group,
    $self_delete,
    $display_loading_img,
    $gzip_compression,
    $uname_test_level,
    $cookie_name,
    $session_name,
    $old_session_name,
    $session_expire,
    $use_sessions,
    $old_session_use,
    $banners,
    $com_mode,
    $com_order,
    $allow_html,
    $allow_image,
    $allow_library,
    $lib_allow_upload,
    $lib_width,
    $lib_height,
    $lib_maxsize,
    $debug_mode,
    $cache_time,
    $avatar_allow_upload,
    $avatar_width,
    $avatar_height,
    $avatar_maxsize,
    $htmlarea_rows,
    $htmlarea_cols,
    $backups,
    $sourcecodestyle)
{
    global $sysConfig, $myts, $sys_request;

    $error = "";
    if ( !function_exists("$mail_function") ) {
        $error .= "<h4>".sprintf(_PR_INVLDMAILFUNC, $mail_function)."</h4>";
    }
    if ( !is_numeric($minpass) ) {
        $error .= "<h4>"._PR_INVLDMINPASS."</h4>";
    }
    if ( !is_numeric($session_expire) ) {
        $error .= "<h4>"._PR_INVLDSEXP."</h4>";
    }
    if ( empty($cookie_name) || preg_match("/[^a-z0-9_-]/", $cookie_name) ) {
        $error .= "<h4>"._PR_INVLDUCOOK."</h4>";
    }
    if ( empty($session_name) || preg_match("/[^a-z0-9_-]/i", $session_name) ) {
        $error .= "<h4>"._PR_INVLDSCOOK."</h4>";
    }
    if ( empty($adminmail) ) {
        $error .= "<h4>"._PR_ADMNOTSET."</h4>";
    }
    if ( $error ) {
        sysCpHeader();
        echo $error;
        sysCpFooter();
        exit();
    }

    $debug_size = count($debug_mode);
    for ( $i = 0; $i < $debug_size; $i++ ) {
        $debug_out += $debug_mode[$i];
    }

    $config = "<"."?php
/*********************************************************************
"._PR_REMEMBER."
"._PR_IFUCANT."
*********************************************************************/

// "._PR_ADMINML."
\$sysConfig['adminmail'] = \"".$myts->makeTboxData4PreviewInForm($adminmail)."\";

// "._PR_MAILFUNC."
\$sysConfig['mail_function'] = \"".$mail_function."\";

// "._PR_LANGUAGE."
\$sysConfig['language'] = \"".$myts->makeTboxData4PreviewInForm($language)."\";

// "._PR_STARTPAGE."
\$sysConfig['startpage'] = \"".$myts->makeTboxData4PreviewInForm($startpage)."\";

// "._PR_DTHEME."
\$sysConfig['default_theme'] = \"".$myts->makeTboxData4PreviewInForm($default_theme)."\";

// "._PR_ALLOWTHEME." (1="._YES." 0="._NO.")
\$sysConfig['allow_theme'] = ".intval($allow_theme).";

// "._PR_MM_LAYOUT." (0="._PR_MM_CSSSTATIC." 0="._PR_MM_JSDROPDOWN.")
\$sysConfig['mainmenu_layout'] = ".$mainmenu_layout.";

// "._PR_ANONNAME."
\$sysConfig['anonymous'] = \"".$myts->makeTboxData4PreviewInForm($anonymous)."\";

// "._PR_MINPASS."
\$sysConfig['minpass'] = ".intval($minpass).";

// "._PR_ANONPOST." (1="._YES." 0="._NO.")
\$sysConfig['anonpost'] = ".intval($anonpost).";

// "._PR_MAXPMS."
\$sysConfig['max_pms'] = ".intval($max_pms).";

// "._PR_SITEOFFLINE."
\$sysConfig['offline_site'] = ".intval($offline_site).";

// "._PR_OFFLINEMSG."
\$sysConfig['offline_msg'] = \"".$myts->makeTboxData4PreviewInForm($offline_msg)."\";

// "._PR_ALLOWHTML." (1="._YES." 0="._NO.")
\$sysConfig['allow_html'] = ".intval($allow_html).";

// "._PR_LIBUSE." (1="._YES." 0="._NO.")
\$sysConfig['allow_library'] = ".intval($allow_library).";

// "._PR_LIBUPLOAD." (1="._YES." 0="._NO.")
\$sysConfig['lib_allow_upload'] = ".intval($lib_allow_upload).";

// "._PR_LIBW."
\$sysConfig['lib_width'] = ".intval($lib_width).";

// "._PR_LIBH."
\$sysConfig['lib_height'] = ".intval($lib_height).";

// "._PR_LIBMAX."
\$sysConfig['lib_maxsize'] = ".intval($lib_maxsize).";

// "._PR_ALLOWIMAGE." (1="._YES." 0="._NO.")
\$sysConfig['allow_image'] = ".intval($allow_image).";

// "._PR_ALLOW_REGISTER." (1="._YES." 0="._NO.")
\$sysConfig['allow_register'] = ".intval($allow_register).";

// "._PR_VERIFY_IMG." (1="._YES." 0="._NO.")
\$sysConfig['img_verify'] = ".intval($img_verify).";

// "._PR_AUTOREGISTER." (1="._YES." 0="._NO.")
\$sysConfig['auto_register'] = ".intval($auto_register).";

// "._PR_NEWUNOTIFY." (1="._YES." 0="._NO.")
\$sysConfig['new_user_notify'] = ".intval($new_user_notify).";

// "._PR_NOTIFYTO."
\$sysConfig['new_user_notify_group'] = ".intval($new_user_notify_group).";

// "._PR_SELFDELETE." (1="._YES." 0="._NO.")
\$sysConfig['self_delete'] = ".intval($self_delete).";

// "._PR_LOADINGIMG." (1="._YES." 0="._NO.")
\$sysConfig['display_loading_img'] = ".intval($display_loading_img).";

// ".sprintf(_PR_USEGZIP,phpversion())." (1="._YES." 0="._NO.")
\$sysConfig['gzip_compression'] = ".intval($gzip_compression).";

// "._PR_UNAMELVL."  ("._PR_STRICT."=0 "._PR_MEDIUM."=1 "._PR_LIGHT."=2)
\$sysConfig['uname_test_level'] = ".intval($uname_test_level).";

// "._PR_USERCOOKIE."
\$sysConfig['cookie_name'] = \"".$cookie_name."\";

// "._PR_SESSCOOKIE."
\$sysConfig['session_name'] = \"".$session_name."\";

// "._PR_SESSEXPIRE."
\$sysConfig['session_expire'] = ".intval($session_expire).";

// "._PR_SESSUSE."
\$sysConfig['use_sessions'] = ".intval($use_sessions).";

// "._PR_SERVERTZ."
\$sysConfig['server_TZ'] = \"".(date('Z')/3600)."\";

// "._PR_DEFAULTTZ."
\$sysConfig['default_TZ'] = \"".$default_TZ."\";

// "._PR_BANNERS." (1="._YES." 0="._NO.")
\$sysConfig['banners'] = ".intval($banners).";

// "._PR_DEBUGMODE."
\$sysConfig['debug_mode'] = ".intval($debug_out).";

// "._PR_CACHETIME."
\$sysConfig['cache_time'] = ".intval($cache_time).";

// "._PR_COMMODE." (0="._NOCOMMENTS." flat="._FLAT." thread="._THREADED.")
\$sysConfig['com_mode'] = \"".$com_mode."\";

// "._PR_COMORDER." (0="._OLDESTFIRST." 1="._NEWESTFIRST.")
\$sysConfig['com_order'] = ".intval($com_order).";

// "._PR_AVATARALLOW." (1="._YES." 0="._NO.")
\$sysConfig['avatar_allow_upload'] = ".intval($avatar_allow_upload).";

// "._PR_AVATARW."
\$sysConfig['avatar_width'] = ".intval($avatar_width).";

// "._PR_AVATARH."
\$sysConfig['avatar_height'] = ".intval($avatar_height).";

// "._PR_AVATARMAX."
\$sysConfig['avatar_maxsize'] = ".intval($avatar_maxsize).";

// "._PR_HTMLAREAROWS."
\$sysConfig['htmlarea_rows'] = ".intval($htmlarea_rows).";

// "._PR_HTMLAREACOLS."
\$sysConfig['htmlarea_cols'] = ".intval($htmlarea_cols).";

// "._PR_BACKUPS."
\$sysConfig['backups'] = ".intval($backups).";

// "._PR_SOURCECODESTYLE."
\$sysConfig['sourcecodestyle'] = ".intval($sourcecodestyle).";
?".">";
    $file = fopen(SYS_MOD_PATH."/system/cache/config.php", "w");
    if ( -1 != fwrite($file, $config) ) {
        if ( ( $session_name != $old_session_name) 
                || ($use_sessions != $old_session_use) ) {
            global $HTTP_SESSION_VARS, $sys_request;
            if ( $use_sessions ) {
                if ( session_is_registered($old_session_name) ) {
                    $HTTP_SESSION_VARS[$session_name] = $HTTP_SESSION_VARS[$old_session_name];
                    session_unregister($old_session_name);
                } else {
                    session_start();
                    $HTTP_SESSION_VARS[$session_name] = $sys_request[$old_session_name];
                }
            } else {
                if (session_is_registered($old_session_name)) {
                    cookie($session_name, $HTTP_SESSION_VARS[$old_session_name], 360000);
                } else {
                    cookie($session_name, $sys_request[$old_session_name], 360000);
                    cookie($old_session_name);
                }
            }
        }
        fclose($file);
        redirectHeader("admin.php?fct=preferences", 2, _UPDATED, 1);
        exit();
    }
}
?>
