<?php
/**
 * File: $Id: main.php,v 1.39 2005/05/12 17:36:10 greyhead Exp $ admin.php,v 1.1.2.13 2004/04/30 03:51:12 masterkain Exp $
 *
 * Ciamos: this file is the System Admin Topics Manager
 * Ciamos - Content Management System
 *
 * :TODO: add detailed description of this file
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 *
 * @subpackage Ciamos_system_admin
 * @link link to information for the subpackage
 * @author alphalogic (@link http://alphalogic.org)
 *
 */

global $sys_request, $sysHandler, $sysModule, $sysSecurity, $sysUser;

if ( !preg_match("/admin\.php/i", _PHP_SELF) || !$sysUser->isAdmin($sysModule->mid()) )  {
   $sysHandler['security']->showSecurityERR(SYS_ROOT_URL.'/', 2, _NOPERM);
   exit;
}

include_once(SYS_ROOT_PATH.'/class/sysformloader.php');
include_once(SYS_ROOT_PATH."/class/datatree.php");

$datatree = new DataTree('', true, 'admin');

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function manageTopics()
{
    global $db, $sysConfig, $sysModule, $datatree, $sys_request;

    sysCpHeader();
    include ("maptopics.php");
    
    /**
     * Add a topic
     */
    $form = new SysThemeForm(_TM_ADDTOPIC, 'addSubTopic', 'admin.php');
    $form_array = $subtopic_array = array();

    $subtopic_array[] = new SysFormText('', 'topic_title', 40, 40);
    $subtopic_array[] = new SysFormLabel('', _TM_ASSUBTOPIC);
    $subtopic_array[] = new SysFormLabel('', $datatree->makeMySelBox('', 0, true, 'topic_pid'));
    $form_array[] = new SysFormElementTray(_TM_TOPICNAME, '&nbsp;', $subtopic_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'addTopic');
    $form_array[] = new SysFormHidden('fct', 'topics');

    $form->display($form_array, true);

    /**
     * Modify a topic description for use with a module
     */
    $modules  = SysModule::getHasTopicsModulesList();
    $form = new SysThemeForm(_TM_MODIFYTOPICDESC, 'modDesc', 'admin.php');
    $form_array = $topic_array = array();
    $topic_array[] = new sysFormLabel('', $datatree->makeMySelBox('', 0, false, '', '', false, 8, true));
    $topic_array[] = new SysFormLabel('', _TM_FOR);
    $topic_array[] = new SysFormSelect('', 'module', '', 8, true, $modules);
    $form_array[] = new SysFormElementTray(_TOPIC, '&nbsp;', $topic_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'modTopic');
    $form_array[] = new SysFormHidden('fct', 'topics');

    $form->display($form_array, true);
}

/**
 * @return void
 * @param integer $mid Module ID
 * @desc Generates Topic configuration page for System Admin
 */
function modTopic($mid='')
{
    global $db, $sysConfig, $newsConfig, $sysModule, $sys_request, $datatree;

    $modules    = $sysModule->getHasTopicsModulesList();
    $topic_id   = $sys_request['topic_id'];
    $topicArray = $datatree->getSingleItem($topic_id);

    sysCpHeader();

    if ( $mid == '' ) {
        /**
         * If no module selected
         */
        $formtitle = _TM_MODIFYTOPIC." : ".$topicArray['topic_title'];
        $imagestring = $imagetag = "";
        if ( $topicArray['topic_imgurl'] ) {
            $imagestring = "<p class='admintext'><i>"._TM_IMAGEOVERWRITE."</i></p>";
            $imagetag    = "<img src='".$datatree->getTopicImage($topicArray['topic_imgurl'])."' height='80'>";
        }
        $topicModules = explode('|',$topicArray['topic_modules']);
        $topicViewers = explode('|',$topicArray['topic_viewer']);
        $topicAdmins  = explode('|',$topicArray['topic_admins']);

        $sql = "
            SELECT *
                FROM ".$db->prefix('groups')."
                WHERE groupid != 1
                ORDER by name";
        $query = $db->query($sql);
        while ( $result = $db->fetch_object($query) ) {
            $g_array[$result->groupid] =  $result->name;
        }
        $delete = "onclick='location=\"admin.php?fct=topics&topic_pid="
                    .$topicArray['topic_pid']."&amp;topic_id="
                    .$topicArray['topic_id']."&amp;op=delTopic\"'";
        
        $form = new SysThemeForm($formtitle, 'modTopic', 'admin.php');
        $form_array = array();
        
        $form_array[] = new SysFormLabel('', _TM_GLOBALNOTE);
        $form_array[] = new SysFormText(_TM_TOPICNAME, 'topic_title', 30, 40, $topicArray['topic_title'], _TM_MAX40CHAR);
        $form_array[] = new SysFormLabel(_TM_PARENTTOPIC, $datatree->makeMySelBox('', $topicArray['topic_pid'], !$topicArray['topic_pid'], 'topic_pid'));

            $image_array[] = new SysFormLabel('', $imagetag);
            $image_array[] = new SysFormFile('', 'image', 10000);
            $image_array[] = new SysFormLabel('', $imagestring);
        $form_array[] = new SysFormElementTray(_TM_TOPICIMG, '<br />', $image_array);
        $form_array[] = new SysFormDhtmlTextArea(_DESCRIPTION, 'description', 
            $datatree->getTopicDescription($topic_id), 4, 40);
            
            //$access_array[0][] = new SysFormLabel('', _TM_MODULES);
            $access_array[0][] = new SysFormLabel('', _TM_VIEW);
            $access_array[0][] = new SysFormLabel('', _TM_ADMIN);
            //$access_array[1][] = new SysFormSelect('', 'modules', $topicModules, 10, true, $modules); 
            $access_array[1][] = new SysFormSelect('', 'viewer', $topicViewers, 10, true, $g_array);
            $access_array[1][] = new SysFormSelect('', 'admins', $topicAdmins, 10, true, $g_array); 
        $table_array[] = new SysFormElementTable('', $access_array);
        $form_array[] = new SysFormElementTray(_TM_ACCESS, '', $table_array);
        $form_array[] = new SysFormButtonTray(false, true, true, true, "onclick='javascript:history.go(-1)'", $delete);

        $form_array[] = new SysFormHidden('op', 'modTopicS');
        $form_array[] = new SysFormHidden('fct', 'topics');
        $form_array[] = new SysFormHidden('topic_id', $topic_id);
        
        $form->display($form_array, true);
    } else {
        /**
         * If a module selected
         */
        
        $formtitle = _TM_MODIFYTOPIC." : ".$topicArray['topic_title']." "._TM_FOR." ".$modules[$mid];
        if ( is_file(SYS_MOD_PATH.'/system/cache/topics/'.$mid.'.desc.php') ) {
            include (SYS_MOD_PATH.'/system/cache/topics/'.$mid.'.desc.php');
        }
        $delete = "onclick='location=\"admin.php?fct=topics&topic_pid="
                    .$topicArray['topic_pid']."&amp;topic_id=".$topicArray['topic_id']."&amp;op=delTopic\"'";
        
        $form = new SysThemeForm($formtitle, 'modTopic', 'admin.php');
        $form_array = array();

        $form_array[] = new SysFormDhtmlTextArea(_DESCRIPTION, 'description', 
            $datatree->getTopicDescription($topic_id, $mid), 5, 60);
        $form_array[] = new SysFormButtonTray(false, true, true, true, "onclick='javascript:history.go(-1)'", $delete);
        $form_array[] = new SysFormHidden('topic_id', $topicArray['topic_id']);
        $form_array[] = new SysFormHidden('op', 'modTopicS');
        $form_array[] = new SysFormHidden('mid', $mid);
        $form_array[] = new SysFormHidden('fct', 'topics');
        
        $form->display($form_array, true);
    }
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function modTopicS($mid='')
{
    global $db, $sys_request, $datatree;
    
    $topic_id   = $sys_request['topic_id']; 
    $topicArray = $datatree->getSingleItem($topic_id); 
    $topicpath  = SYS_MOD_PATH."/system/cache/topics/";

    $add = '';
    if ( $mid ) {
        $add = $mid.'.';
    } else {
        if ( $sys_request['topic_pid'] == $topic_id ) {
            displayMessage(_TM_ERRPARENT);
            exit();
        }
        $datatree->setTopicPid($sys_request['topic_pid']);
        $datatree->setTopicId($topic_id);
        $datatree->setAccess($sys_request['modules'], $sys_request['viewer'], $sys_request['admins']);
        $datatree->setTopicTitle($sys_request['topic_title']);
    }

    if ( !empty($_FILES['image']['name']) ) {
        include_once(SYS_ROOT_PATH."/class/fileupload.php");
        $upload = new fileupload();

        $upload->set_upload_dir($topicpath, 'image');
        $upload->set_accepted("gif|jpg|png", 'image');
        $upload->set_overwrite(2, 'image');
        $upload->set_basename($add.$topic_id, 'image');
            
        $result = $upload->upload();
        if ( $result['image'] ) {
            if ( !$mid ) {
                $datatree->setTopicImgurl($result['image']['filename']);
            }
        } else {
            redirectHeader("admin.php?fct=topics&op=managetopics", 3, $upload->errors());
            exit();
        }
    }
    $datatree->store();
    if ( $mid ) {
        $filename = $mid.".".$topic_id.".desc.php";
    } else {
        $filename = $topic_id.".desc.php";
    }
    $filepathname = $topicpath.$filename;
    if ( trim($sys_request['description']) ) {
        $content  = addslashes(trim($sys_request['description']));
        if ( $file = fopen($filepathname, "w") ) {
            fwrite($file, $content);
            fclose($file);
        }
    } elseif ( is_file($filepathname) ) {
            unlink($filepathname);
    }
    redirectHeader("admin.php?fct=topics&op=managetopics", 1, _UPDATED);
    exit();
}


/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function delTopic()
{
    global $db, $sys_request, $sysConfig, $sysModule, $datatree;

    if ( !$sys_request['ok'] ) {
        sysCpHeader();
        openTable();
        echo "
            <h4 style='color: #ff0000'>"._TM_WAYSYWTDTTAL."</h4>
            <table>
                <tr>
                    <td>".myTextForm("admin.php?fct=topics&op=delTopic&topic_id=".$sys_request['topic_id']."&ok=1",_YES)."</td>
                    <td>".myTextForm("admin.php?fct=topics&op=managetopics", _NO)."</td>
                </tr>
            </table>
            <br /><br />";
        closeTable();
    } else {
        /*
        $xt = new SysTopic($db->prefix("topics"), $sys_request['topic_id']);
        //get all subtopics under the specified topic
        $topic_arr = $xt->getAllChildTopics();
        array_push($topic_arr, $xt);
        foreach ( $topic_arr as $eachtopic ) {
            //get all stories in each topic
            $story_arr = NewsStory::getByTopic($eachtopic->topicId());
            @unlink(SYS_MOD_PATH.$sysModule->dirname()."/cache/topics/".basename($eachtopic->topic_imgurl()));
            foreach ( $story_arr as $eachstory ) {
                $eachstory->delete();
            }
            //all stories for each topic is deleted, now delete the topic data
            $eachtopic->delete();
        }
        */
        $datatree->deleteNode($sys_request['topic_id']);
        //buildRss();

        redirectHeader("admin.php?fct=topics&op=managetopics", 1, _UPDATED);
        exit();
    }
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function addTopic()
{
    global $db, $sys_request, $datatree;
    
    $data['topic_pid']   = $sys_request['topic_pid'];
    $data['topic_title'] = $sys_request['topic_title'];

    $datatree->makeTopic($data);
    
    redirectHeader("admin.php?fct=topics&op=modTopic&topic_id=".$db->insert_id(), 1, _UPDATED);
    exit();
}
$op = $sys_request['op'];
if ( $sys_request['delete'] == 'Delete' ) {
    $op = 'delTopic';
}
/**
 * Main Topics operation switch
 */
switch ( $op ) {
    
    case "addTopic":
    addTopic();
    break;

    case "delTopic":
    delTopic();
    break;

    case 'maptopics':
    include ("maptopics.php");
    break;

    case "modTopic":
    
    if ( $sys_request['module'][0] != 'gen' ) {
        $id = $sys_request['module'][0];
    } elseif ( $sys_request['topic-id'] ) {
        $id = $sys_request['topic-id'];
    } else {
        $id = "";
    }
    modTopic($id);
    break;

    case "modTopicS":
    
    if ( $sys_request['mid'] == '' ) {
        $mid = '';
    } else {
        $mid = $sys_request['mid'];
    }
    modTopicS($mid);
    break;

    case "managetopics":
    default:
    
    manageTopics();
    break;
}
?>
