<?php
/**
 * File: $Id: topicsmap.php
 *
 * Ciamos: this file is the System Admin Topics Manager
 * Ciamos - Content Management System
 *
 * :TODO: add detailed description of this file
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 *
 * @subpackage Ciamos_system_admin
 * @link link to information for the subpackage
 * @author greyhead (@link http://www.bobjanes.com)
 *
 */

if ( $sys_request['op'] == 'maptopics' ) {
    mapTopicsS();
} else {
    mapTopics();
}
   
/**
 * Generates Topic configuration page for System Admin
 *
 */
function mapTopics()
{
    global $db, $sysConfig, $sysModule, $sys_request, $datatree;

    $modules = $sysModule->getHasTopicsModulesList();
    $topics  = $datatree->getChildTreeArray(0);

    $form_array = $table_array = array();
    /**
     * Build header row
     */
    $table_array[0]['title'] = new SysFormLabel('', '');
    foreach ( $modules as $key => $module ) {
        $table_array[0][$key] = new SysFormLabel('', $module);
    }
    $table_array[0][] = new SysFormLabel('', _ACTION);
    /**
     * Build row for each topic
     */
    foreach ( $topics as $topic) {
        if ( $topic['topic_pid'] == 0 ) {
            $title = "<strong>".$topic['topic_title']."</strong>";
        } else {
            // Re-write prefix as ++ for clarity
            $prefix = strtr(substr($topic['prefix'], 1), '.', '+');
            $title = $prefix."&nbsp;".$topic['topic_title'];
        }
        $tid = $topic['topic_id'];
        $table_array[$tid]['title'] = new SysFormLabel('', $title);
        $topic_modules = explode('|', $topic['topic_modules']);
        foreach ( $modules as $key => $module ) {
            $tick = in_array($key, $topic_modules);
            $table_array[$tid][$key] = new SysFormCheckBox('', "map[$tid][$key]", $tick);
        }
        $action = "<a href='admin.php?fct=topics&amp;op=modTopic&amp;topic_id=$tid'>
            <img src='".SYS_ROOT_URL."/images/editor/edit.gif' alt='"._EDIT."' border='0' /></a>";
        $table_array[$tid]['action'] = new SysFormLabel('', $action);
        $table_array[$tid]['topic_id'] = new SysFormHidden("map['topic_id'][]", $tid);
    }

    $form_array[] = new SysFormElementTable('', $table_array);
    $form_array[] = new SysFormButtonTray();
    $form_array[] = new SysFormHidden('op', 'maptopics');
    $form_array[] = new SysFormHidden('fct', 'topics');
    
    $form = new SysThemeForm('TopicMap', 'Name', _PHP_SELF);
    
    /**
     * Show table
     */
    $form->display($form_array, true);
}

/**
 * Saves topic map information
 * if modules are set for a sub-topic set for parent as well
 *
 * @param type $var description
 * @return type description
 */
function mapTopicsS($mid='')
{
    global $db, $sys_request, $datatree;
    
    $map = $sys_request[map];
    $topic_array = $map["'topic_id'"]; 
    /**
     * First iteration
     * Loop through each topic and
     * include topics where no module is selected
     */
    $module_array = array();
    foreach ( $topic_array as $tid ) {
        
        /**
         * If one or more modules are selected add to array
         */
        if ( $map[$tid] ) {
            foreach ( $map[$tid] as $mid => $null ) {
                $module_array[$tid][] = $mid;
            }
        }
    }

    /**
     * Second iteration
     * Get topic parents & add topic modules to parent modules
     * this ensures that if a module is set for a sub-topic 
     * then it's also set for the sub-topic's parents 
     */
    foreach ( $topic_array as $tid ) {
        if ( $module_array[$tid] ) {
            $topic = $datatree->getSingleItem($tid);
            $parent_array = $datatree->getOnlyParentsForArray($tid);
            if ( $parent_array ) {
                foreach ( $parent_array as $parent ) {
                    $pid = $parent['topic_id'];
                    $module_array[$pid] = array_merge($module_array[$pid], $module_array[$tid]);
                }
            }
        }
    }

    /**
     * Third iteration 
     * Clean the module array and save topic info
     */
    foreach ( $topic_array as $tid ) {
        $topic = $datatree->getSingleItem($tid);
        // Skip cleaning if the array is empty i.e. no modules selected
        if ( $module_array[$tid] ) { 
            $module_array[$tid] = array_unique($module_array[$tid]);
            array_multisort($module_array[$tid]);
        }
        // save topic info
        $datatree->setTopicId($topic['topic_id']);
        $datatree->setTopicPid($topic['topic_pid']);
        $datatree->setTopicImgurl($topic['topic_imgurl']);
        $datatree->setTopicTitle($topic['topic_title']);
        $datatree->setAccess($module_array[$tid], $topic['topic_viewer'], $topic['topic_admins']);
        $datatree->store();
    }
    unset($module_array);

    redirectHeader(_PHP_SELF."?fct=topics&op=managetopics", 1, _UPDATED);
    exit();
}
?>
