<?php
/**
 * File: $Id: findusers.php,v 1.4 2005/05/07 11:10:08 greyhead Exp $
 *
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

if ( !preg_match("/admin\.php/i", _PHP_SELF) ) {
    exit();
}
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

function formFindUsers()
{
    global $myts, $sys_request, $sysHandler, $sysModule, $sysSecurity, $sysUser;

    $acttotal   = SysUser::countAllUsers(array("level>0"));
    $inacttotal = SysUser::countAllUsers(array("level=0"));
    $form_title = "<div class=BlockTitle>"._UA_FINDUS."<br />("
        .sprintf(_UA_ACTUS, "<span style='color:#ff0000;'>$acttotal</span>")."&nbsp;"
        .sprintf(_UA_INACTUS, "<span style='color:#ff0000;'>$inacttotal</span>").")";

    $match_array = array('st'=>_STARTSWITH, 'en'=>_ENDSWITH, 'eq'=>_MATCHES, 'co'=>_CONTAINS);
    $sort_type = array('uname'=>_USERNAME, 'email'=>_EMAIL, 'last_login'=>_UA_LASTLOGIN,
            'user_regdate'=>_UA_REGDATE, 'posts'=>_UA_POSTS);

    $form = new SysThemeForm($form_title, 'user_findform', 'admin.php');
    $form_array = array();

        $uname_array[] = new SysFormSelect('', 'user_uname_match', '', 1, false, $match_array);
        $uname_array[] = new SysFormText('', 'user_uname', 30, 60);
    $form_array[] = new SysFormElementTray(_USERNAME, '&nbsp;', $uname_array);

        $name_array[]  = new SysFormSelect('', 'user_name_match', '', 1, false, $match_array);
        $name_array[]  = new SysFormText('', 'user_name', 30, 60);
    $form_array[] = new SysFormElementTray(_REALNAME, '&nbsp;', $name_array);

        $email_array[] = new SysFormSelect('', 'user_email_match', '', 1, false, $match_array);
        $email_array[] = new SysFormText('', 'user_email', 30, 60);
    $form_array[] = new SysFormElementTray(_EMAIL, '&nbsp;', $email_array);

    $form_array[] = new SysFormText(_UA_URLC, 'user_url', 30, 100);

    //$timezone_select = new SysFormSelectTimezone(_UA_TIMEZONE, 'user_timezone_offset');
        $icq_array[] = new SysFormSelect('', 'user_icq_match', '', 1, false, $match_array);
        $icq_array[] = new SysFormText('', 'user_icq', 30, 100);
    $form_array[] = new SysFormElementTray(_ICQ, '&nbsp;', $icq_array);

        $aim_array[] = new SysFormSelect('', 'user_aim_match', '', 1, false, $match_array);
        $aim_array[] = new SysFormText('', 'user_aim', 30, 100);
    $form_array[] = new SysFormElementTray(_AIM, '&nbsp;', $aim_array);

        $yim_array[] = new SysFormSelect('', 'user_yim_match', '', 1, false, $match_array);
        $yim_array[] = new SysFormText('', 'user_yim', 30, 100);
    $form_array[] = new SysFormElementTray(_YIM, '&nbsp;', $yim_array);

        $msnm_array[] = new SysFormSelect('', 'user_msnm_match', '', 1, false, $match_array);
        $msnm_array[] = new SysFormText('', 'user_msnm', 30, 100);
    $form_array[] = new SysFormElementTray(_MSNM, '&nbsp;', $msnm_array);

    $form_array[] = new SysFormText(_LOCATION, 'user_from', 30, 100);
    $form_array[] = new SysFormText(_OCCUPATION, 'user_occ', 30, 100);
    $form_array[] = new SysFormText(_INTEREST, 'user_interest', 30, 100);

    //$form_array[] = new SysFormText(_UA_EXTRAINFO, 'user_bio', 30, 100);

    $form_array[] = new SysFormText(_UA_LASTLOGMORE, 'user_lastlog_more', 10, 5);
    $form_array[] = new SysFormText(_UA_LASTLOGLESS, 'user_lastlog_less', 10, 5);
    $form_array[] = new SysFormText(_UA_REGMORE, 'user_reg_more', 10, 5);
    $form_array[] = new SysFormText(_UA_REGLESS, 'user_reg_less', 10, 5);
    $form_array[] = new SysFormText(_UA_POSTSMORE, 'user_posts_more', 10, 5);
    $form_array[] = new SysFormText(_UA_POSTSLESS, 'user_posts_less', 10, 5);
    $form_array[] = new SysFormRadio(_UA_SHOWTYPE, 'user_type', 'actv',
        array('actv'=>_UA_ACTIVE, 'inactv'=>_UA_INACTIVE, 'both'=>_UA_BOTH));

        $sort_array[] = new SysFormSelect('', 'user_sort', '', 1, false, $sort_type);
        $sort_array[] = new SysFormRadio('', 'user_order', '1',  array('ASC'=>_ASCORDER,'DESC'=>_DESCORDER));
    $form_array[] = new SysFormElementTray(_SORTBY, '<br />', $sort_array);

    $form_array[] = new SysFormText(_UA_LIMIT, 'limit', 6, 2);
    if ( !empty($sys_request['group']) && intval($sys_request['group']) > 0 ) {
        $form_array[] = new SysFormHidden("group", intval($sys_request['group']));
    }
    $form_array[] = new SysFormHidden('fct', 'useradmin');
    $form_array[] = new SysFormHidden('sfct', 'findusers');
    $form_array[] = new SysFormHidden('op', 'submit');
    $form_array[] = new SysFormButtonTray();

    $form->display($form_array, true);
}

function submitFindUsers()
{
    global $myts, $sys_request, $sysHandler, $sysModule, $sysSecurity, $sysUser;

    openTable();

    $test_array = array('uname', 'name', 'email', 'icq', 'aim', 'yim', 'mnsm');
    $criteria = array();

    foreach ($test_array as $var ) {
        $criteria[] = buildCriteria($var);
    }

    if ( !empty($sys_request['user_url']) ) {
        $url = formatURL(trim($sys_request['user_url']));
        $criteria[] = "url LIKE '".$myts->oopsAddSlashesGPC($url)."%'";
    }

    //+++

    if ( !empty($sys_request['user_from']) ) {
        $criteria[] = "user_from LIKE '%".$myts->oopsAddSlashesGPC(trim($sys_request['user_from']))."%'";
    }

    if ( !empty($sys_request['user_interest']) ) {
        $criteria[] = "user_interest LIKE '%".$myts->oopsAddSlashesGPC(trim($sys_request['user_interest']))."%'";
    }

    if ( !empty($sys_request['user_occ']) ) {
        $criteria[] = "user_occ LIKE '%".$myts->oopsAddSlashesGPC(trim($sys_request['user_occ']))."%'";
    }

    //+++

    if ( !empty($sys_request['user_lastlog_more']) && is_numeric($sys_request['user_lastlog_more']) ) {
        $f_user_lastlog_more = intval(trim($sys_request['user_lastlog_more']));
        $time = time() - (60 * 60 * 24 * $f_user_lastlog_more);
        if ( $time > 0 ) {
            $criteria[] = "last_login < $time";
        }
    }

    if ( !empty($sys_request['user_lastlog_less']) && is_numeric($sys_request['user_lastlog_less']) ) {
        $f_user_lastlog_less = intval(trim($sys_request['user_lastlog_less']));
        $time = time() - (60 * 60 * 24 * $f_user_lastlog_less);
        if ( $time > 0 ) {
            $criteria[] = "last_login > $time";
        }
    }

    if ( !empty($sys_request['user_reg_more']) && is_numeric($sys_request['user_reg_more']) ) {
        $f_user_reg_more = intval(trim($sys_request['user_reg_more']));
        $time = time() - (60 * 60 * 24 * $f_user_reg_more);
        if ( $time > 0 ) {
            $criteria[] = "user_regdate < $time";
        }
    }

    if ( !empty($sys_request['user_reg_less']) && is_numeric($sys_request['user_reg_less']) ) {
        $f_user_reg_less = intval($sys_request['user_reg_less']);
        $time = time() - (60 * 60 * 24 * $f_user_reg_less);
        if ( $time > 0 ) {
            $criteria[] = "user_regdate > $time";
        }
    }

    //+++

    if ( !empty($sys_request['user_posts_more']) && is_numeric($sys_request['user_posts_more']) ) {
        $criteria[] = "posts > ".intval($sys_request['user_posts_more'])."";
    }

    if ( !empty($sys_request['user_posts_less']) && is_numeric($sys_request['user_posts_less']) ) {
        $criteria[] = "posts < ".intval($sys_request['user_posts_less'])."";
    }

    //+++

    if ( isset($sys_request['user_type']) ) {
        if ( $sys_request['user_type'] == "inactv" ) {
            $criteria[] = "level=0";
        } elseif ( $sys_request['user_type'] == "actv" ) {
            $criteria[] = "level>0";
        } else {
            $criteria[] = "level>=0";
        }
    }

    $validsort = array("uname", "email", "last_login", "user_regdate", "posts");
    if ( !in_array($sys_request['user_sort'], $validsort) ) {
        $sort      = "uname";
    } else {
        $sort      = $sys_request['user_sort'];
    }
    $order     = "ASC";

    if ( isset($sys_request['user_order']) && $sys_request['user_order'] == "DESC") {
        $order = "DESC";
    }
    $limit = 20;
    if ( !empty($sys_request['limit']) ) {
        $limit = intval($sys_request['limit']);
    }
    if ( $limit > 100 ) {
        $limit = 100;
    }
    $criteria = array_unique($criteria);
    $start = (!empty($sys_request['start'])) ? intval($sys_request['start']) : 0;
    $total = SysUser::countAllUsers($criteria);

    echo "
            <a href='admin.php?fct=useradmin&op=form'>". _UA_FINDUS ."</a>
            &nbsp;<span style='font-weight:bold;'>&raquo;&raquo;</span>"
            . _SEARCHRESULTS.": ".sprintf(_UA_USERSFOUND, $total)."
            <br /><br />";

    if ( $total == 0 ) {
        echo "<h4>"._UA_NOFOUND,"</h4>";
    } else if ( $start < $total ) {
        echo "
        <form action='admin.php' method='post' name='memberslist' id='memberslist'>
        <input type='hidden' name='op' value='delete_many' />
        <table border='0' cellpadding='0' cellspacing='0' width='100%'><tr>
        <td class='bg2'>
        <table width='100%' border='0' cellspacing='1' cellpadding='4'><tr class='bg3'>
        <td align='center'>
        <input type='checkbox' class='checkbox' name='memberslist_checkall' id='memberslist_checkall' onclick='sysCheckAll(\"memberslist\", \"memberslist_checkall\");' />
        </td>
        <td align='center'><b>"._AVATAR."</b></td>
        <td align='center'><b>"._USERNAME."</b></td>
        <td align='center'><b>"._REALNAME."</b></td>
        <td align='center'><b>"._EMAIL."</b></span></td>
        <td align='center'><b>"._PM."</b></td>
        <td align='center'><b>"._URL."</b></td>
        <td align='center'><b>"._UA_REGDATE."</b></td>
        <td align='center'><b>"._UA_LASTLOGIN."</b></td>
        <td align='center'><b>"._UA_POSTS."</b></td>
        <td align='center'>&nbsp;</td>
        </tr>";

        $foundusers =& SysUser::getAllUsers($criteria, true, "$sort $order", $limit, $start);
        foreach ( $foundusers as $fuser ) {
            if ( $fuser->getVar("user_avatar") ) {
                $fuser_avatar = "<img src='".SYS_ROOT_URL."/images/avatar/".$fuser->getVar("user_avatar")."' alt='' />";
            } else {
                $fuser_avatar = "&nbsp;";
            }
            if ( $fuser->getVar("name") ) {
                $fuser_name = $fuser->getVar("name");
            } else {
                $fuser_name = "&nbsp;";
            }
            echo "<tr class='bg1'>
                    <td align='center'>
                        <input type='checkbox' class='checkbox'
                            name='memberslist_id[]' id='memberslist_id[]'
                            value='".$fuser->getVar("uid")."' />
                        <input type='hidden' name='memberslist_uname[".$fuser->getVar("uid")."]'
                            id='memberslist_uname[]' value='".$fuser->getVar("uname")."' />
                    </td>";
            echo "  <td>".$fuser_avatar."</td>
                    <td><a href='".SYS_ROOT_URL."/userinfo.php?uid=".$fuser->getVar("uid")."'>"
                        .$fuser->getVar("uname")."</a></td>
                    <td>".$fuser_name."</td>
                    <td align='center'>
                        <a href='mailto:".$fuser->getVar("email")."'>
                            <img src='".SYS_ROOT_URL."/images/icons/email.gif' border='0'
                                alt='".sprintf(_SENDEMAILTO,$fuser->getVar('uname', 'E'))."' />
                        </a>
                    </td>
                    <td align='center'>
                        <a href='javascript:openWithSelfMain(\"".SYS_ROOT_URL
                                ."/pmlite.php?send2=1&amp;to_userid="
                                .$fuser->getVar("uid")."\",\"pmlite\",360,300);'>
                            <img src='".SYS_ROOT_URL."/images/icons/pm.gif' border='0'
                                alt='".sprintf(_SENDPMTO,$fuser->getVar('uname', 'E'))."' />
                        </a>
                    </td>
                    <td align='center'>";
            if ( $fuser->getVar("url","E") != "" ) {
                echo "<a href='".$fuser->getVar("url","E")."' target='_blank'>
                        <img src='".SYS_ROOT_URL."/images/icons/www.gif'
                            border='0' alt='"._VISITWEBSITE."' />
                      </a>";
            } else {
                echo "&nbsp;";
            }
            echo "  </td>
                    <td align='center'>".formatTimeStamp($fuser->getVar("user_regdate"),"s")."</td>
                    <td align='center'>";
            if ( $fuser->getVar("last_login") != 0 ) {
                echo formatTimeStamp($fuser->getVar('last_login'),'m');
            } else {
                echo "&nbsp;";
            }
            echo "  </td>
                    <td align='center'>".$fuser->getVar("posts")."</td>
                    <td align='center'>
                        <a href='".SYS_MOD_URL."/system/admin.php?fct=useradmin&amp;uid="
                            .$fuser->getVar("uid")."&amp;op=modifyUser'>"._EDIT."</a>
                    </td></tr>\n";
        }
        echo "
        </table></td>
        </tr><tr><td><select class='select' name='sfct'>
        <option value='users'>"._DELETE."</option> // users
        <option value='mailusers'>"._UA_SENDMAIL."</option>"; // mail users

        if ( !empty($sys_request['group']) ) {
            $group = intval($sys_request['group']);
        } else {
            $group = 0;
        }
        if ( $group > 0 ) {
            $add2group = new SysGroup($group);
            echo "<option value='group' selected='selected'>".sprintf(_UA_ADD2GROUP, $add2group->getVar('name'))."</option>";
        }
        echo "</select>&nbsp;";
        if ( $group > 0 ) {
            echo "<input type='hidden' name='groupid' value='".$group."' />
            <input type='hidden' name='fct' value='useradmin' />";
        }
        echo "
        <input type='submit' class='button' value='"._SUBMIT."' />
        </td></tr></table>
        </form>";

        $totalpages = ceil($total / $limit);
        if ( $totalpages > 1 ) {
            $hiddenform = "<form name='findnext' action='admin.php?fct=useradmin' method='post'><input type='hidden' name='sfct' value='findusers' />";
            foreach ( $sys_request as $k => $v ) {
                $hiddenform .= "<input type='hidden' name='$k' value='".$myts->oopsStripSlashesGPC($v)."' />\n";
            }
            if (!isset($sys_request['limit'])) {
                $hiddenform .= "<input type='hidden' name='limit' value='".$limit."' />\n";
            }
            if (!isset($sys_request['start'])) {
                $hiddenform .= "<input type='hidden' name='start' value='".$start."' />\n";
            }
            $prev = $start - $limit;
            if ( $start - $limit >= 0 ) {
                $hiddenform .= "<a href='#0' onclick='javascript:document.findnext.start.value=".$prev.";document.findnext.submit();'>"._PREVIOUS."</a>&nbsp;";
            }
            $counter = 1;
            $currentpage = ($start+$limit) / $limit;
            while ( $counter <= $totalpages ) {
                if ( $counter == $currentpage ) {
                    $hiddenform .= "<b>".$counter."</b> ";
                } elseif ( ($counter > $currentpage-4 && $counter < $currentpage+4) || $counter == 1 || $counter == $totalpages ) {
                    if ( $counter == $totalpages && $currentpage < $totalpages-4 ) {
                        $hiddenform .= "... ";
                    }
                    $hiddenform .= "<a href='#".$counter."' onclick='javascript:document.findnext.start.value=".($counter-1)*$limit.";document.findnext.submit();'>".$counter."</a> ";
                    if ( $counter == 1 && $currentpage > 5 ) {
                        $hiddenform .= "... ";
                    }
                }
                $counter++;
            }
            $next = $start+$limit;
            if ( $total > $next ) {
                $hiddenform .= "&nbsp;<a href='#".$total."' onclick='javascript:document.findnext.start.value=".$next.";document.findnext.submit();'>"._NEXT."</a>";
            }
            $hiddenform .= "</form>";
            echo "<div style='text-align:center'>"
                .$hiddenform."<br />".sprintf(_UA_USERSFOUND, $total)."</div>";
        }
    }
    closeTable();
}

/**
 * Turns form matchSelect fields into SQL WHERE statements
 *
 * @param ustring$varname
 * @return atring sql WHERE element
 */
function buildCriteria($varname)
{
    global $myts, $sys_request;

    $criteria = false;
    if ( !empty($sys_request['user_'.$varname]) ) {
        $match_string = $myts->oopsAddSlashesGPC(trim($sys_request['user_'.$varname]));
        $match = 'st';
        if ( !empty($sys_request['user_'.$varname.'_match']) ) {
            $match = $sys_request['user_'.$varname.'_match'];
        }

        switch ( $match ) {

            case 'st':
            $criteria = "$varname LIKE '$match_string%'";
            break;

            case 'en':
            $criteria = "$varname LIKE '%$match_string'";
            break;

            case 'eq':
            $criteria = "$varname = '$match_string'";
            break;

            case 'co':
            $criteria = "$varname LIKE '%$match_string%'";
            break;
        }
    }
    return $criteria;
}
?>