<?php
/**
 * File: $Id: groupform.php,v 1.4 2005/04/09 18:04:59 greyhead Exp $
 *
 * Ciamos: Simple + Flexible + Advanced Content Management
 * @link http://www.ciamos.com
 *
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

// global $_SERVER;

if ( preg_match("/groupform\.php/i", $_SERVER['PHP_SELF']) ) {
    exit();
}

include_once(SYS_ROOT_PATH."/class/sysformloader.php");

$name_text      = new SysFormText(_NAME, "name", 30, 50, $name_value);
$desc_text      = new SysFormTextArea(_DESCRIPTION, "desc", $desc_value);

/**
 * GET modules with admin rights
 */
$modules_array  = array();
$modules_array  = SysModule::getHasAdminModulesList();
$a_mod_checkbox = new SysFormCheckBox(_UA_ACTIVERIGHTS, "admin_mids[]", $a_mod_value);
foreach ($modules_array as $key=>$value) {
    $modules_array[$key] = $value."<br />";
}
$a_mod_checkbox->addOptionArray($modules_array);

/**
 * GET normal modules
 */
$modules_array  = array();
$modules_array  = SysModule::getHasMainModulesList();
$r_mod_checkbox = new SysFormCheckBox(_UA_ACCESSRIGHTS, "read_mids[]", $r_mod_value);
foreach ($modules_array as $key=>$value) {
    $modules_array[$key] = "$value<br />";
}
$r_mod_checkbox->addOptionArray($modules_array);

/**
 * GET absoluteblocks
 */
$new_blocks_array  = array();
$r_ablock_checkbox = new SysFormCheckBox(_UA_BLOCKRIGHTS.":<br /><i>"._ABSOLUTE."</i>", "read_bids[]", $r_block_value);
$blocks_array      = SysBlock::getAllBlocks("list", BLOCK_ABSOLUTETOP, 1, "weight", 1);
foreach ($blocks_array as $key=>$value) {
    $new_blocks_array[$key] = "<a href='".SYS_MOD_URL."/system/admin.php?fct=blocksadmin&op=edit&bid=".$key."'>".$value."</a><br />";
}
$blocks_array      = SysBlock::getAllBlocks("list", BLOCK_ABSOLUTEBOTTOM, 1, "weight", 1);
foreach ($blocks_array as $key=>$value) {
    $new_blocks_array[$key] = "<a href='".SYS_MOD_URL."/system/admin.php?fct=blocksadmin&op=edit&bid=".$key."'>".$value."</a><br />";
}
$r_ablock_checkbox->addOptionArray($new_blocks_array);


/**
 * GET leftblocks
 */
$new_blocks_array  = array();
$r_lblock_checkbox = new SysFormCheckBox(_UA_BLOCKRIGHTS.":<br /><i>"._LEFT."</i>", "read_bids[]", $r_block_value);
$blocks_array      = SysBlock::getAllBlocks("list", SYS_SIDEBLOCK_LEFT, 1, "weight", 1);
foreach ($blocks_array as $key=>$value) {
    $new_blocks_array[$key] = "<a href='".SYS_MOD_URL."/system/admin.php?fct=blocksadmin&op=edit&bid=".$key."'>".$value."</a><br />";
}
$r_lblock_checkbox->addOptionArray($new_blocks_array);

/**
 * GET centerblocks
 */
$new_blocks_array   = array();
$r_tcblock_checkbox = new SysFormCheckBox(_UA_BLOCKRIGHTS.":<br /><i>"._CENTER."</i>", "read_bids[]", $r_block_value);
$blocks_array       = SysBlock::getAllBlocks("list", SYS_CENTERBLOCK_ALL, 1, "weight", 1);
foreach ($blocks_array as $key=>$value) {
    $new_blocks_array[$key] = "<a href='".SYS_MOD_URL."/system/admin.php?fct=blocksadmin&op=edit&bid=".$key."'>".$value."</a><br />";
}
$r_tcblock_checkbox->addOptionArray($new_blocks_array);

/**
 * GET rightblocks
 */
$new_blocks_array  = array();
$r_rblock_checkbox = new SysFormCheckBox(_UA_BLOCKRIGHTS.":<br /><i>"._RIGHT."</i>", "read_bids[]", $r_block_value);
$blocks_array      = SysBlock::getAllBlocks("list", SYS_SIDEBLOCK_RIGHT, 1, "weight", 1);
foreach ($blocks_array as $key=>$value) {
    $new_blocks_array[$key] = "<a href='".SYS_MOD_URL."/system/admin.php?fct=blocksadmin&op=edit&bid=".$key."'>".$value."</a><br />";
}
$r_rblock_checkbox->addOptionArray($new_blocks_array);

/**
 * GET allowed html
 */
$htmlarray   = SysLists::getHtmlList();
$tags_value  = array();
$tags_value  = explode("|", $allowed_html_value);
$html_select = new SysFormSelect(_UA_ALLOWEDTAGS.":<br /><i>"._UA_ALLOWEDTAGS_DESC."</i>", "tags", $tags_value, 15, true);
$html_select->addOptionArray($htmlarray);

$op_hidden     = new SysFormHidden("op", $op_value);
$fct_hidden    = new SysFormHidden("fct", "useradmin");
$sfct_hidden   = new SysFormHidden("sfct", "group");
$submit_button = new SysFormButton("", "groupsubmit", $submit_value, "submit");

$form = new SysThemeForm($form_title, "groupform", "admin.php");
$form->addElement($name_text);
$form->addElement($desc_text);
$form->addElement($a_mod_checkbox);
$form->addElement($r_mod_checkbox);
$form->addElement($r_ablock_checkbox);
$form->addElement($r_lblock_checkbox);
$form->addElement($r_tcblock_checkbox);
$form->addElement($r_rblock_checkbox);
$form->addElement($html_select);

$form->addElement($op_hidden);
$form->addElement($fct_hidden);
$form->addElement($sfct_hidden);

if ( !empty($g_id_value) ) {
    $g_id_hidden = new SysFormHidden("g_id", $g_id_value);
    $form->addElement($g_id_hidden);
}

$form->addElement($submit_button);
$form->setRequired("name");
$form->display();
?>
