<?php
/**
 * File: $Id: mailform.php,v 1.5 2005/04/09 18:04:59 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

// global $_SERVER;

if ( preg_match("/mailform\.php/i", $_SERVER['PHP_SELF']) ) {
    exit();
}

$form = new SysThemeForm(_UA_SENDMTOUSERS, "mailusers", "admin.php?fct=useradmin&sfct=mailusers");
$form->setExtra("enctype='multipart/form-data'");

/**
 * From finduser section
 */
if ( !empty($sys_request['memberslist_id']) ) {
    $user_count = count($sys_request['memberslist_id']);
    $display_names = "";
    for ( $i=0; $i<$user_count; $i++) {
        $uid_hidden = new SysFormHidden("mail_to_user[]", $sys_request['memberslist_id'][$i]);
        $form->addElement($uid_hidden);
        $display_names .= "<a href='".SYS_ROOT_URL."/userinfo.php?uid=".$sys_request['memberslist_id'][$i]."' target='_blank'>".$sys_request['memberslist_uname'][$sys_request['memberslist_id'][$i]]."</a>, ";
    }
    $users_label = new SysFormLabel(_UA_SENDTO, substr($display_names, 0, -2));
    $form->addElement($users_label);
    $display_criteria = 0;
}

if ( !empty($display_criteria) ) {
    $group_select    = new SysFormSelectGroup(_UA_GROUPIS."<br />", "mail_to_group", false, '----', 5, true);
    $group_select->addOption(0, '----');
    $lastlog_min     = new SysFormText(_UA_LASTLOGMIN."<br />"._UA_TIMEFORMAT."<br />", "mail_lastlog_min", 20, 10);
    $lastlog_max     = new SysFormText(_UA_LASTLOGMAX."<br />"._UA_TIMEFORMAT."<br />", "mail_lastlog_max", 20, 10);
    $regd_min        = new SysFormText(_UA_REGDMIN."<br />"._UA_TIMEFORMAT."<br />", "mail_regd_min", 20, 10);
    $regd_max        = new SysFormText(_UA_REGDMAX."<br />"._UA_TIMEFORMAT."<br />", "mail_regd_max", 20, 10);
    $idle_more       = new SysFormText(_UA_IDLEMORE."<br />", "mail_idle_more", 10, 5);
    $idle_less       = new SysFormText(_UA_IDLELESS."<br />", "mail_idle_less", 10, 5);

    $umail_ok         = new SysFormCheckBox('', "mail_ok", 0);
    $umail_ok->addOption(1, _UA_MAILOK);

    $inactive_cbox   = new SysFormCheckBox(_UA_MAILINACTIVE."<br />", "mail_inactive");
    $inactive_cbox->addOption(1, _UA_IFCHECKD);
    $inactive_cbox->setExtra("onclick='disableElement(\"mail_lastlog_min\"); disableElement(\"mail_lastlog_max\"); disableElement(\"mail_idle_more\"); disableElement(\"mail_idle_less\"); disableElement(\"mail_to_group\");'");

    $criteria_tray = new SysFormElementTray(_UA_SENDTOUSERS, "<br /><br />");
    $criteria_tray->addElement($group_select);
    $criteria_tray->addElement($lastlog_min);
    $criteria_tray->addElement($lastlog_max);
    $criteria_tray->addElement($idle_more);
    $criteria_tray->addElement($idle_less);

    $criteria_tray->addElement($umail_ok);

    $criteria_tray->addElement($inactive_cbox);
    $criteria_tray->addElement($regd_min);
    $criteria_tray->addElement($regd_max);
    $form->addElement($criteria_tray);
}

$fname_text      = new SysFormText(_UA_MAILFNAME, "mail_fromname", 30, 255, $meta['title']);
$fromemail       = !empty($sysConfig['adminmail']) ? $sysConfig['adminmail'] : $sysUser->getVar("email", "E");
$femail_text     = new SysFormText(_UA_MAILFMAIL, "mail_fromemail", 30, 255, $sysUser->getVar("email", "E"));
$subject_caption = _SUBJECT."<br /><br /><span style='font-size:x-small;font-weight:bold;'>"._UA_MAILTAGS."</span><br /><span style='font-size:x-small;font-weight:normal;'>"._UA_MAILTAGS2."</span>";
$subject_text    = new SysFormText($subject_caption, "mail_subject", 50, 255);
$body_caption    = _UA_MAILBODY."<br /><br /><span style='font-size:x-small;font-weight:bold;'>"._UA_MAILTAGS."</span><br /><span style='font-size:x-small;font-weight:normal;'>"._UA_MAILTAGS1."<br />"._UA_MAILTAGS2."<br />"._UA_MAILTAGS3."<br />"._UA_MAILTAGS4."</span>";
$body_text       = new SysFormTextArea($body_caption, "mail_body", "", 10);
$to_checkbox     = new SysFormCheckBox(_UA_SENDTO, "mail_send_to", "mail");
$to_checkbox->addOption("mail", _EMAIL);
$to_checkbox->addOption("pm", _PM);

$to_emails = new SysFormText(_UA_TOEMAILS, "mail_to_emails", 55, 255);
$priority  = new SysFormSelect(_UA_PRIORITY, "mail_priority", 3);
$priority->addOptionArray(array(1 => '1 (Highest)', 2 => '2 (High)', 3 => '3 (Normal)', 4 => '4 (Low)', 5 => '5 (Lowest)'));
$mail_type = new SysFormRadio(_UA_TYPE, "mail_type", "text/plain");
$mail_type->addOption("text/html", "HTML");
$mail_type->addOption("text/plain", "TEXT");

$receipt = new SysFormCheckBox(_UA_RECEIPT, "mail_receipt", 0);
$receipt->addOption(1, _YES);

$file_select = new SysFormElementTray(_UA_ATTACH);
$file_browse = new SysFormFile('', 'attachment', 512000);
$file_inline = new SysFormCheckBox('', "inline", 0);
$file_inline->addOption(1, _UA_INLINE);
$file_select->addElement($file_browse);
$file_select->addElement($file_inline);

$op_hidden     = new SysFormHidden("op", "send");
$submit_button = new SysFormButton("", "mail_submit", _SEND, "submit");

$form->addElement($to_emails);
$form->addElement($priority);
$form->addElement($mail_type);
$form->addElement($receipt);
$form->addElement($fname_text);
$form->addElement($femail_text);
$form->addElement($subject_text);
$form->addElement($body_text);
$form->addElement($file_select);
$form->addElement($to_checkbox);
$form->addElement($op_hidden);
$form->addElement($submit_button);

$form->setRequired(array("mail_subject", "mail_body", "mail_send_to"));
?>
