<?php
/**
 * File: $Id: mailusers.php,v 1.5 2005/04/09 18:04:59 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */
if ( !preg_match("/admin\.php/i", _PHP_SELF) ) {
    exit();
}

if ( !$sysUser->isAdmin($sysModule->mid()) ) {
    echo "Access Denied";
    exit;
}
include_once(SYS_ROOT_PATH."/class/sysformloader.php");

$op = "form";
if (!empty($sys_request['op']) && $sys_request['op'] == "send") {
    $op =  $sys_request['op'];
}

if ( $op == "form" ) {
    sysCpHeader();
    displayUserHome();
    openTable();
    $display_criteria = 1;
    include_once(SYS_MOD_PATH."/system/admin/useradmin/include/mailform.php");
    $form->display();
    closeTable();
    sysCpFooter();
    exit();
}

if ( $op == "send" && !empty($sys_request['mail_send_to']) ) {
    $to_groups   = array();
    $to_users    = array();
    $send_users  = array();
    $criteria    = array();
    $sysMailer =& getMailer();

    if ( !empty($sys_request['mail_inactive']) ) {
        $criteria[] = "level = 0";
    } else {
        if ( !empty($sys_request['mail_to_group']) ) {
            foreach ($sys_request['mail_to_group'] as $groupid) {
                if ($groupid != 0) {
                    $mailgroup = new SysGroup($groupid);
                    $members   = $mailgroup->getMembers();
                    foreach ($members as $member) {
                        $to_groups[] = $member;
                    }
                }
            }
        }
        if ( !empty($sys_request['mail_lastlog_min']) ) {
            $f_mail_lastlog_min = trim($sys_request['mail_lastlog_min']);
            $time = mktime(0,0,0,substr($f_mail_lastlog_min,5,2),substr($f_mail_lastlog_min,8,2),substr($f_mail_lastlog_min,0,4));
            if ( $time > 0 ) {
                $criteria[] = "last_login > $time";
            }
        }
        if ( !empty($sys_request['mail_lastlog_max']) ) {
            $f_mail_lastlog_max = trim($sys_request['mail_lastlog_max']);
            $time = mktime(0,0,0,substr($f_mail_lastlog_max,5,2),substr($f_mail_lastlog_max,8,2),substr($f_mail_lastlog_max,0,4));
            if ( $time > 0 ) {
                $criteria[] = "last_login < $time";
            }
        }
        if ( !empty($sys_request['mail_idle_more']) && is_numeric($sys_request['mail_idle_more']) ) {
            $f_mail_idle_more = intval(trim($sys_request['mail_idle_more']));
            $time = (86400 * $f_mail_idle_more);
            $time = (time() - $time);
            if ( $time > 0 ) {
                $criteria[] = "last_login < $time";
            }
        }
        if ( !empty($sys_request['mail_idle_less']) && is_numeric($sys_request['mail_idle_less']) ) {
            $f_mail_idle_less = intval(trim($sys_request['mail_idle_less']));
            $time = (86400 * $f_mail_idle_less);
            $time = (time() - $time);
            if ( $time > 0 ) {
                $criteria[] = "last_login > $time";
            }
        }
        if ( !empty($sys_request['mail_ok']) ) {
            $criteria[] = "user_mailok = 1";
        }
    }

    if ( !empty($sys_request['mail_regd_min']) ) {
        $f_mail_regd_min = trim($sys_request['mail_regd_min']);
        $time = mktime(0,0,0,substr($f_mail_regd_min,5,2),substr($f_mail_regd_min,8,2),substr($f_mail_regd_min,0,4));
        if ( $time > 0 ) {
            $criteria[] = "user_regdate > $time";
        }
    }
    if ( !empty($sys_request['mail_regd_max']) ) {
        $f_mail_regd_max = trim($sys_request['mail_regd_max']);
        $time = mktime(0,0,0,substr($f_mail_regd_max,5,2),substr($f_mail_regd_max,8,2),substr($f_mail_regd_max,0,4));
        if ( $time > 0 ) {
            $criteria[] = "user_regdate < $time";
        }
    }

    if ( !empty($criteria) ) {
        if ( empty($sys_request['mail_inactive']) ) {
            $criteria[] = "level > 0";
        }
        $getusers =& SysUser::getAllUsers($criteria);
        foreach ($getusers as $getuser) {
            $to_users[] = $getuser;
        }
    }
}

if ( !empty($sys_request['mail_to_user']) ) {
    foreach ($sys_request['mail_to_user'] as $getuser) {
        $to_users[] = $getuser;
    }
}

if ( !empty($sys_request['mail_to_emails']) ) {
    $to_emails = explode(",", $sys_request['mail_to_emails']);
    foreach($to_emails as $email) {
        $sysMailer->setToEmails(trim($email));
    }
}

if ( !empty($to_users) && !empty($to_groups) ) {
    $send_users = array_intersect($to_users, $to_groups);
} elseif (!empty($to_users)) {
    $send_users = $to_users;
} elseif (!empty($to_groups)) {
    $send_users = $to_groups;
}

$send_users = array_unique($send_users);
$sysMailer->setToUsers($send_users);

sysCpHeader();
displayUserHome();
openTable();
if ( count(($send_users + $sysMailer->toEmails)) > 0 ) {
    $sysMailer->setFromName($sys_request['mail_fromname']);
    $sysMailer->setFromEmail($sys_request['mail_fromemail']);
    $sysMailer->setSubject($sys_request['mail_subject']);
    $sysMailer->setBody($sys_request['mail_body']);
    if ( in_array("mail", $sys_request['mail_send_to']) ) {
        $sysMailer->useMail();
    }
    if ( in_array("pm", $sys_request['mail_send_to']) && empty($sys_request['mail_inactive']) ) {
        $sysMailer->usePM();
    }
    if ( !empty($sys_request['mail_receipt']) ) {
        $sysMailer->setReceipt($sys_request['mail_fromemail']);
    }

    $sysMailer->setType($sys_request['mail_type']);
    $sysMailer->setPriority($sys_request['mail_priority']);

    if ( !empty($_FILES['attachment']['name']) ) {
        include_once(SYS_ROOT_PATH."/class/fileupload.php");
        $upload = new fileupload();
        $upload->set_upload_dir(SYS_ROOT_PATH . "/cache/", 'attachment');
        $upload->set_overwrite(1, 'attachment');
        $result = $upload->upload();
        if ($result['attachment']['filename']) {
            $attach_type = $sys_request['inline'] ? 'inline' : 'attachment';
            $sysMailer->attachFile(SYS_ROOT_PATH."/cache/".$result['attachment']['filename'], $result['attachment']['type'], $attach_type);
            @unlink(SYS_ROOT_PATH."/cache/".$result['attachment']['filename']);
        } else {
            $upload->errors(1);
        }
    }

    $sysMailer->useToggle(1);
    $sysMailer->send();
    echo $sysMailer->getSuccess();
    echo $sysMailer->getErrors();
} else {
    echo "<h4>"._UA_NOUSERMATCH."</h4>";
}

closeTable();
sysCpFooter();
?>
