<?php
/**
 * File: $Id: userform.php,v 1.7 2005/04/09 18:04:59 greyhead Exp $
 *  Ciamos: Simple + Flexible + Advanced Content Management
 *  < http://www.ciamos.com >
 * @author Kazumi Ono (@link http://www.mywebaddons.com/)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 */

// global $_SERVER;

if ( preg_match("/userform\.php/i", $_SERVER['PHP_SELF']) ) {
    exit();
}

$uid_label  = new SysFormLabel(_UA_USERID, $uid_value);
$uname_text = new SysFormText(_NICKNAME, "uname", 30, 60, $uname_value);
$name_text  = new SysFormText(_NAME, "name", 30, 60, $name_value);
$email_tray = new SysFormElementTray(_EMAIL, "<br />");
$email_text = new SysFormText("", "email", 30, 60, $email_value);
$email_tray->addElement($email_text);
$email_cbox = new SysFormCheckBox("", "user_viewemail", $email_cbox_value);
$email_cbox->addOption(1, _UA_AOUTVTEAD);
$email_tray->addElement($email_cbox);
$url_text      = new SysFormText(_URL, "url", 30, 100, $url_value);
$avatar_select = new SysFormSelect("", "user_avatar", $avatar_value);
$avatar_array  = SysLists::getImgListAsArray(SYS_ROOT_PATH."/images/avatar/");
$avatar_select->addOptionArray($avatar_array);
$a_dirlist      = SysLists::getDirListAsArray(SYS_ROOT_PATH."/images/avatar/");
$a_dir_labels   = array();
$a_count        = 0;
$a_dir_link     = "<a href=\"javascript:openWithSelfMain('".SYS_ROOT_URL."/misc.php?action=showpopups&amp;type=avatars&amp;start=".$a_count."','avatars',600,400);\">Ciamos</a>";
$a_count        = $a_count + count($avatar_array);
$a_dir_labels[] = new SysFormLabel("", $a_dir_link);

foreach ($a_dirlist as $a_dir) {
    if ( $a_dir == "users" ) {
        continue;
    }
    $avatars_array = SysLists::getImgListAsArray(SYS_ROOT_PATH."/images/avatar/".$a_dir."/", $a_dir."/");
    $avatar_select->addOptionArray($avatars_array);
    $a_dir_link     = "<a href=\"javascript:openWithSelfMain('".SYS_ROOT_URL."/misc.php?action=showpopups&amp;type=avatars&amp;subdir=".$a_dir."&amp;start=".$a_count."','avatars',600,400);\">".$a_dir."</a>";
    $a_dir_labels[] = new SysFormLabel("", $a_dir_link);
    $a_count        = $a_count + count($avatars_array);
}

if ( $sysConfig['avatar_allow_upload'] == 1 && $uid_value != "" ) {
    $myavatar = avatarExists($uid_value);
    if ( $myavatar != false ) {
        $avatar_select->addOption($myavatar, _US_MYAVATAR);
    }
}

$avatar_select->setExtra("onchange='showImgSelected(\"avatar\", \"user_avatar\", \"images/avatar\")'");
$avatar_label    = new SysFormLabel("", "<img src='".SYS_ROOT_URL."/images/avatar/".$avatar_value."' name='avatar' id='avatar' alt='' />");
$avatar_tray     = new SysFormElementTray(_AVATAR, "&nbsp;");
$avatar_tray->addElement($avatar_select);
$avatar_tray->addElement($avatar_label);

foreach ($a_dir_labels as $a_dir_label) {
    $avatar_tray->addElement($a_dir_label);
}

$theme_select    = new SysFormSelectTheme(_THEME, "theme", $theme_value);
$timezone_select = new SysFormSelectTimezone(_US_TIMEZONE, "timezone_offset", $timezone_value);
$icq_text        = new SysFormText(_ICQ, "user_icq", 20, 20, $icq_value);
$aim_text        = new SysFormText(_AIM, "user_aim", 20, 20, $aim_value);
$yim_text        = new SysFormText(_YIM, "user_yim", 20, 20, $yim_value);
$msnm_text       = new SysFormText(_MSNM, "user_msnm", 20, 20, $msnm_value);
$location_text   = new SysFormText(_LOCATION, "user_from", 30, 100, $location_value);
$occupation_text = new SysFormText(_OCCUPATION, "user_occ", 30, 100, $occ_value);
$interest_text   = new SysFormText(_INTEREST, "user_interest", 30, 255, $interest_value);
$sig_tray        = new SysFormElementTray(_SIGNATURE, "<br />");
$sig_tarea       = new SysFormTextArea("", "user_sig", $sig_value);
$sig_tray->addElement($sig_tarea);
$sig_cbox        = new SysFormCheckBox("", "attachsig", $sig_cbox_value);
$sig_cbox->addOption(1, _US_SHOWSIG);
$sig_tray->addElement($sig_cbox);
$umode_select    = new SysFormSelect(_US_CDISPLAYMODE, "umode", $umode_value);
$umode_select->addOptionArray(array("0"=>_NOCOMMENTS, "flat"=>_FLAT, "thread"=>_THREADED));
$uorder_select   = new SysFormSelect(_US_CSORTORDER, "uorder", $uorder_value);
$uorder_select->addOptionArray(array("0"=>_OLDESTFIRST, "1"=>_NEWESTFIRST));
$bio_tarea       = new SysFormTextArea(_US_EXTRAINFO, "bio", $bio_value);
$rank_select     = new SysFormSelect(_RANK, "rank", $rank_value);
$ranklist        = SysLists::getUserRankList();

if ( count($ranklist) > 0 ) {
    $rank_select->addOption(0, _UA_NSRA);
    $rank_select->addOption(0, "--------------");
    $rank_select->addOptionArray($ranklist);
} else {
    $rank_select->addOption(0, _UA_NSRID);
}

$pwd_text      = new SysFormPassword(_PASSWORD, "pass");
$pwd_text2     = new SysFormPassword(_UA_RETYPEPD, "pass2");
$fct_hidden    = new SysFormHidden("fct", "useradmin");
$sfct_hidden   = new SysFormHidden("sfct", "users");
$op_hidden     = new SysFormHidden("op", $op_value);
$submit_button = new SysFormButton("", "submit", _SUBMIT, "submit");

$form = new SysThemeForm($form_title, "userinfo", "admin.php");
$form->addElement($uname_text);
$form->addElement($name_text);
$form->addElement($email_tray);
$form->addElement($url_text);
$form->addElement($avatar_tray);
$form->addElement($theme_select);
$form->addElement($timezone_select);
$form->addElement($icq_text);
$form->addElement($aim_text);
$form->addElement($yim_text);
$form->addElement($msnm_text);
$form->addElement($location_text);
$form->addElement($occupation_text);
$form->addElement($interest_text);
$form->addElement($sig_tray);
$form->addElement($umode_select);
$form->addElement($uorder_select);
$form->addElement($bio_tarea);
$form->addElement($rank_select);
$form->addElement($pwd_text);
$form->addElement($pwd_text2);
$form->addElement($fct_hidden);
$form->addElement($sfct_hidden);
$form->addElement($op_hidden);
$form->addElement($submit_button);

if ( !empty($uid_value) ) {
    $uid_hidden = new SysFormHidden("uid", $uid_value);
    $form->addElement($uid_hidden);
    $form->setRequired(array("uname", "email"));
} else {
    $form->setRequired(array("uname", "email", "pass", "pass2"));
}

$form->display();
?>