<?php
/**
 * File: $Id: register.php,v 1.20 2005/03/25 15:02:43 greyhead Exp $
 * Ciamos: Register a user
 * Ciamos - Content Management System
 * :TODO: add detailed description of this file
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 * @subpackage Ciamos_core
 * @link link to information for the subpackage
 * @author The Xoops Project (@link http://www.xoops.org)
 */

$sysOption['pagetype']      = 'user';
$sysOption['page_style']    = 8;
$sysOption['nocache']       = true;

include_once("./mainfile.php");

if ( empty($sysConfig['allow_register']) ) {
    redirectHeader('index.php', 1, _NOREG);
    exit();
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function userCheck($uname, $email, $pass, $vpass, $verify_text, $verify_crc)
{
    global $sysConfig, $db, $myts, $sysBadEmails, $sysBadUnames;

    $stop = "";
    if ( !checkEmail($email) ) {
        $stop .= _INVALIDMAIL."<br />";
    }
    if ( strrpos($email,' ') > 0 ) {
        $stop .= _US_EMAILNOSPACES."<br />";
    }
    $uname  = $myts->oopsStripSlashesGPC($uname);
    $strict = "^a-zA-Z0-9_";
    $medium = "<>,.$%\#@!\'\"";
    $loose  = "?{}\[\]\(\)\^&*`~;:\\+=";
    $restriction_array = array(0=>$strict, 1=>$strict.$medium, 2=>$strict.$medium.$loose);
    $restriction = $restriction_array[$sysConfig['uname_test_level']];

    if ( empty($uname) || preg_match('#['.$restriction.'-]#', $uname) ) {
        $stop .= _US_INVALIDNICKNAME."<br />";
    }
    if ( strlen($uname) > 25 ) {
        $stop .= _US_NICKNAMETOOLONG."<br />";
    }
    if ( !empty($sysBadUnames) && hasMatch($sysBadUnames, $uname) ) {
        $stop .= _US_NAMERESERVED."<br />";
        break;
    }
    if ( strrpos($uname, ' ') > 0 ) {
        $stop .= _US_NICKNAMENOSPACES."<br />";
    }
    $sql = "
        SELECT COUNT(*)
            FROM ".$db->prefix("users")."
            WHERE uname='".addslashes($uname)."'";
    $result = $db->query($sql);
    list($count) = $db->fetch_row($result);

    if ( $count > 0 ) {
        $stop .= _US_NICKNAMETAKEN."<br />";
    }
    $count = 0;
    if ( $email ) {
        if ( !empty($sysBadEmails) && hasMatch($sysBadEmails, $email) ) {
            $stop .= _US_EMAILRESERVED."<br />";
            break;
        }
        $sql    = "
            SELECT COUNT(*)
                FROM ".$db->prefix("users")."
                WHERE email='".$myts->makeTboxData4Save($email)."'";
        $result = $db->query($sql);
        list($count) = $db->fetch_row($result);
        if ( $count > 0 ) {
            $stop .= _US_EMAILTAKEN."<br />";
        }
    }

    if ( empty($pass) || empty($vpass) ) {
        $stop .= _US_ENTERPWD."<br />";
    }

    if ( (isset($pass)) && ($pass != $vpass) ) {
        $stop .= _US_PASSNOTSAME."<br />";
    } elseif ( ($pass != "") && (strlen($pass) < $sysConfig['minpass']) ) {
        $stop .= sprintf(_US_PWDTOOSHORT, $sysConfig['minpass'])."<br />";
    }

    if ( $sysConfig['img_verify'] && function_exists('imagecreate') ) {
        include_once(SYS_ROOT_PATH."/class/rc4.crypt.php");
        $rc4 = new rc4_crypt();
        $rc4->key(strtoupper($verify_text));
        $verify_crc = base64_decode($verify_crc);
        $rc4->decrypt($verify_crc);

        if ( empty($verify_text) || $verify_crc != "verified" ) {
            $stop .= _US_BADVERIF."<br />";
        }
    }
    return $stop;
}

switch ( $sys_request['op'] ) {

    case "newuser":

    /**
     * Check registration
     */ 
    $uname       = trim($uname);
    $email       = trim($email);
    $pass        = trim($pass);
    $vpass       = trim($vpass);
    $verify_text = trim($verify_text);
    $verify_crc  = trim($verify_crc);
    $stop        = userCheck($uname, $email, $pass, $vpass, $verify_text, $verify_crc);
    if ( $stop ) {
        /**
         * There is a problem
         */
        echo "<span style='color:#ff0000;'>$stop</span>";
        include_once("include/registerform.php");
        $reg_form->display();
    } else {
        /**
         * Confirm registration
         */
        if ( $timezone_offset < 0 ) {
            $f_timezone = "GMT ".$timezone_offset;
        } else {
            $f_timezone = "GMT +".$timezone_offset;
        }
        $hidden_array = array();
        $hidden_array['uname']          = $myts->makeTboxData4PreviewInForm($uname);
        $hidden_array['email']          = $myts->makeTboxData4PreviewInForm($email);
        $hidden_array['user_viewemail'] = intval($user_viewemail);
        $hidden_array['user_avatar']    = $myts->makeTboxData4PreviewInForm($user_avatar);
        $hidden_array['timezone_offset'] = (float)$timezone_offset;
        $hidden_array['url']            = $myts->makeTboxData4PreviewInForm($url);
        $hidden_array['pass']           = $myts->makeTboxData4PreviewInForm($pass);
        $hidden_array['vpass']          = $myts->makeTboxData4PreviewInForm($vpass);
        $hidden_array['user_mailok']    = intval($user_mailok);
        $hidden_array['verify_text']    = $myts->makeTboxData4PreviewInForm($verify_text);
        $hidden_array['verify_crc']     = intval($user_mailok);
        $hidden_array['op']             = 'finish';

        include_once(SYS_ROOT_PATH."/class/sysformloader.php");
        $form = new SysThemeForm(_US_USERREGCONF, 'confirmRegister', 'register.php');
        $form_array = array();

        $form_array[] = new SysFormLabel(_USERNAME, $myts->makeTboxData4Preview($uname));
        $form_array[] = new SysFormLabel(_EMAIL, $myts->makeTboxData4Preview($email));
        if ( $user_avatar ) {
            $form_array[] = new SysFormLabel(_AVATAR, "<img src='".SYS_ROOT_URL."/images/avatar/".$user_avatar."' alt='' />");
        }
        if ( $url ) {
            $form_array[] = new SysFormLabel(_US_WEBSITE, formatURL($myts->makeTboxData4Preview($url)));
        }
        $form_array[] = new SysFormLabel(_US_TIMEZONE, $f_timezone);
        foreach ($hidden_array as $name => $value ) {
            $form_array[] = new SysFormHidden($name, $value);
        }
        $form_array[] = new SysFormButtonTray(false, false, false);

        include_once("include/header.php");
        $form->display($form_array, true);
        closeTable();
    }
    break;

    case "finish":

    include_once("include/header.php");
    $uname       = trim($uname);
    $email       = trim($email);
    $pass        = trim($pass);
    $vpass       = trim($vpass);
    $verify_text = trim($verify_text);
    $verify_crc  = trim($verify_crc);
    $stop        = userCheck($uname, $email, $pass, $vpass, $verify_text, $verify_crc);

    if ( empty($stop) ) {
        $newuser = new SysUser();

        if ( isset($user_viewemail) ) {
            $newuser->setVar("user_viewemail", $user_viewemail);
        }

        if ( isset($attachsig) ) {
            $newuser->setVar("attachsig",$attachsig);
        }

        $newuser->setVar("name" , $name);
        $newuser->setVar("uname", $uname);
        $newuser->setVar("email", $email);

        if ( !empty($url) ) {
            $newuser->setVar("url", formatURL($url));
        }

        $newuser->setVar("user_avatar", $user_avatar);
        $newuser->setVar("actkey", substr(md5(makepass()), 0, 8));
        $newuser->setVar("pass", md5($pass));
        $newuser->setVar("timezone_offset", $timezone_offset);
        $newuser->setVar("user_regdate", time());
        $newuser->setVar("uorder", $sysConfig['com_order']);
        $newuser->setVar("umode", $sysConfig['com_mode']);
        $newuser->setVar("user_mailok", $user_mailok);
        $newid = $newuser->store();

        if ( !$newid ) {
            openTable();
            echo _US_REGISTERNG;
            foreach($newuser->errors as $value) {
                echo "<br />-->".$value;
            }
            closeTable();
            include_once("include/footer.php");
            exit();
        }

        if ( !empty($sysConfig['auto_register']) ) {
            $newuser->setVar("uid", $newid);
            if ( $newuser->activate() ) {
                openTable();
                printf(_US_AUTOREGISTERED, $uname);
                closeTable();
                include_once("include/footer.php");
                exit();
            }
        }

        $sysMailer =& getMailer();
        $sysMailer->useMail();
        if ( $sysConfig['coppa'] ) {
            $sysMailer->setTemplate("coppa.tpl");
            $sysMailer->assign("UEMAIL"  , $email);
            $sysMailer->assign("UWEBSITE", $url);
            $sysMailer->assign("UNAME"   , $uname);
            $sysMailer->assign("UPASS"   , $pass);
        } else {
            $sysMailer->setTemplate("register.tpl");
        }

        $sysMailer->setSubject(sprintf(_US_USERKEYFOR, $uname));
        $sysMailer->assign("SITENAME", $meta['title']);
        $sysMailer->assign("ADMINMAIL", $sysConfig['adminmail']);
        $sysMailer->assign("SITEURL", SYS_ROOT_URL."/");
        $sysMailer->setToUsers($newid);
        $sysMailer->setFromEmail($sysConfig['adminmail']);
        $sysMailer->setFromName($meta['title']);
        $sysMailer->setPriority(2);
        openTable();

        if ( !$sysMailer->send() ) {
            echo _US_YOURREGMAILNG;
            foreach($sysMailer->errors as $value) {
                echo "<br />-->".$value;
            }
        } else {
            echo _US_YOURREGISTERED;
        }
        closeTable();

        /**
         * Send e-mail to webmaster(s)
         */
        if ( $sysConfig['new_user_notify'] && !empty($sysConfig['new_user_notify_group']) ) {
            $sysMailer =& getMailer();
            $sysMailer->useMail();
            $sysMailer->setToGroups($sysConfig['new_user_notify_group']);
            $sysMailer->setFromEmail($sysConfig['adminmail']);
            $sysMailer->setFromName($meta['title']);
            $sysMailer->setSubject(sprintf(_US_NEWUSERREGAT, $meta['title']));
            $sysMailer->setTemplate("newmember.tpl");
                $sysMailer->assign("UEMAIL"  , $email);
                $sysMailer->assign("UWEBSITE", $url);
                $sysMailer->assign("UNAME"   , $uname);
            $sysMailer->send();
        }
    } else {
        echo "<span style='font-weight:bold;'>$stop</span>";
        include_once("include/registerform.php");
        $reg_form->display();
    }
    break;

    case "register":
    default:

    include_once("include/header.php");
    openTable();
    include_once("include/registerform.php");
    $reg_form->display();
    closeTable();
    break;
}
include_once("include/footer.php");
?>
