<?php
/**
 * Theme Name: aqua (v1.0)
 * By GreyHead 
 */

/**
 * Modify these variables to set the templates 
 * for the standard blocks for this theme. 
 * If all the blocks are the same 
 * you can set all the variables to the same template file. 
 */
$blockLayout[sideblockleft]     = 'anyblock.html';
$blockLayout[sideblockright]    = 'anyblock.html';
$blockLayout[centerblockleft]   = 'centerblock_side.html';
$blockLayout[centerblockright]  = 'centerblock_side.html';
$blockLayout[centerblockcenter] = 'anyblock.html';
$blockLayout[absolutetop]       = 'top.html';
$blockLayout[absolutebottom]    = 'bottom.html';

/**
 * @return void
 * @param boolean $show_rblock
 * @desc Generates page header and NavBar opens main table
 * and generates left sidebar
*/
function themeheader($show_rblock=false)
{
    global $sysConfig, $sysUser, $meta;
    
    /**
     * Content for header block
     */
    $header = "
        <span style='float:left;' >
            <a href='".SYS_ROOT_URL."'>
                <img src='".THEME_IMAGE_URL."/logo.gif' alt='".$meta['slogan']."' />
            </a>
        </span>
        <span>".showBannerHere()."</span>
        <span style='float:right; padding:4px;'>
            <form id='pagesearch' action='".SYS_ROOT_URL."/search.php' method='post'>
			<img style='cursor:hand;' onclick='sysGetElementById('pagesearch').submit();' 
                align='middle' src='".THEME_IMAGE_URL."/find.gif' alt='"._SEARCH."' />
			<input type='text' class='login' name='query' size='12' />
			<input type='hidden' name='action' value='results' />&nbsp;
		</form>
        </span>";
    /**
     * Content for NavBar
     */
    $navBarcontent = tabMenu()
        ."<span style='float:right;' id='myclock'></span>";
    /**
     * Display content
     */    
    openWaitBox();
    makeTopBlocks();
    $content = "
        <script type='text/javascript' 
            src='".SYS_THEME_URL."/language/".$sysConfig['language']."/date.js' >
        </script>";
    $content .= "</head>
        <body onload='startclock();' background='".THEME_IMAGE_URL."/misc/fond2.gif'>";

    $content .= frameExt('frame.ext', '90%', 15, 15, $header, 'headerback');
    $content .= frameExt('frame.blue.ext', '90%', 15, 15, $navBarcontent );
    $content .= "
        <table width='100%' cellspacing='0'>
            <tr>
                <td id='leftblocks' align='left'>".makeSidebar('left')."<br /></td>
                <td align='center' width='100%'>";
    echo $content;
}

/**
 * @return void
 * @param boolean $show_rblock Is right block display on or off?
 * @param string $footer html to be dsiplayed in footer block
 * @desc Closes main display table, generates right blocks and shows footer table
 */
function themefooter($show_rblock=false, $footer='')
{
    if ( $show_rblock ) { 
        $right_block = "<td id='rightblocks' align='right'>".makeSidebar('right')."</td>";
    } else { 
        $right_block = "<td width='1' id='rightblocks' style='display:none;'>&nbsp;</td>"; 
    } 

    $content  = "
        <br /></td>
        $right_block
        </tr></table>"
        .frameExt('frame.ext', '95%', 15, 15, $footer);
    echo $content;
}

/**
 * @return void
 * @param unknown $poster
 * @param unknown $time
 * @param unknown $title
 * @param unknown $counter
 * @param unknown $thetext
 * @param unknown $timglink
 * @param unknown $adminlink
 * @param unknown $morelink
 * @desc Generates themed blocks for News postings 
 */
function themenews (
    $poster,
    $time,
    $title,
    $counter,
    $thetext,
    $timglink,
    $adminlink,
    $morelink=''
    )
{

    /**
     * Titlebar
     */
    echo "
    <table cellpadding='0'>
        <tr>
		    <td>
			    <table cellpadding='0' background='".THEME_IMAGE_URL."/tab/back.gif'>
				    <tr>
					    <td>
						    <table cellpadding='0' >
							    <tr>
                                    ".tdt('tab', 33, 'left', 'l.end', '', 33, 33)." 
								    <td align='center'>
									    <table cellpadding='0'>
										    <tr>
                                                ".tdt('tab', 10, 'right', 'c.l', '', 10, 33)." 
											    <td background='".THEME_IMAGE_URL."/tab/c.mid.gif' align='center' >
                                                    $title
                                                </td>
											    ".tdt('tab', 10, 'left', 'c.r', '', 10, 33)." 
										    </tr>
									    </table>
								    </td>
								    ".tdt('tab', 33, 'right', 'r.end', '', 33, 33)." 
							    </tr>
						    </table>
					    </td>
				    </tr>
			    </table>
		    </td>
        </tr>";
    /**
     * Contents frame
     */
    echo "
        <tr>
		    <td align='center'>
			    <table  width='100%' border='0' cellspacing='0' cellpadding='0' background='".THEME_IMAGE_URL."//frame.ext/back.gif'>
				    <!-- Top Spacing 1px -->
                    <tr>
					    ".tdx('', '', 'tabs_7', 9, 1)."
					    ".tdx('', '', '', 9, 1)."
                        ".tdx('100%', 'c', '', 9, 1)."
					    ".tdx('', '', '', 9, 1)."
					    ".tdx('', '', 'tabs_8', 9, 1)."
				    </tr>
                    <!-- Topic links row -->
				    <tr>
					    ".tdx('', '', 'tabs_7', 9, 1)."
					    ".tdx('', '', '', 9, 1)."
					    <td width='100%' align='left'>
						    <a href='modules.php?name=news&amp;new_topic=$topic'>
                                <img src='$timglink' border='0' alt='$topictext' align='right' hspace='10' vspace='10' />
                                [[Topic Link]]
                            </a>
						    <font class='content' color='#505050'>$content</font>
					    </td>
					    ".tdx('', '', '', 9, 1)."
					    ".tdx('', '', 'tabs_8', 9, 1)."
				    </tr>
                    <!-- Spacing 1px -->
				    <tr>
					    ".tdx('', '', 'tabs_7', 9, 1)."
					    ".tdx('', '', '', 9, 1)."
                        ".tdx('100%', 'c', '', 9, 1)."
					    ".tdx('', '', '', 9, 1)."
					    ".tdx('', '', 'tabs_8', 9, 1)."
				    </tr>
                    <!-- Content row -->
				    <tr>
					    ".tdx('', '', 'tabs_7', 9, 1)."
					    ".tdx('', '', '', 9, 1)."
					    <td width='100%' align='center'>
                            <!-- Content frame -->
						    <table cellpadding='0' border='0'  cellspacing='0'>
							    ".trx('/frame.int/', 't', '15', '15')."
							    <tr>
								    ".tdx('', '', '/frame.int/l.c', 15, 15)."
								    <td width='100%' align='center'  background='".THEME_IMAGE_URL."/cadre/fond.gif'>
									    <span class='postedby'>"._TH_POSTEDBY." ".$poster." "._TH_ON." ".$time." (".$counter." "._TH_READS.")</span>
                                        <div class='indextext'>$timglink $thetext</div>
									    <span class='more' align='right'>$adminlink $morelink</span>
								    </td>
								    ".tdx('', '', '/frame.int/r.c', 15, 15)."
							    </tr>
                                ".trx('/frame.int/', 'b', '15', '15')."
							 </table>
					    </td>
					    ".tdx('', '', '', 9, 1)."
					    ".tdx('', '', 'tabs_8', 9, 9)."
				    </tr>
                    <!-- Spacing 9px -->
				    <tr>
					    ".tdx('', '', 'tabs_9', 9, 9)."
					    ".tdx('', '', '', 9, 9)."
                        ".tdx('100%', '', '', false)."
					    ".tdx('', '', '', 9, 9)."
					    ".tdx('', '', 'tabs_10', 9, 9)."
				    </tr>
                    <!-- Bottom row of frame -->
				    <tr>
					    ".tdx('', '', 'tabs_11', 9, 9)."
					    ".tdx('', '', 'tabs_12', 9, 9)."
                        ".tdx('100%', '', 'tabs_13', false)."
					    ".tdx('', '', 'tabs_14', 9, 9)."
					    ".tdx('', '', 'tabs_15', 9, 9)."
				    </tr>
			    </table>
		    </td>
	    </tr>
    </table>


    ";
}

/**
 * The following functions are used to build the display elements
 * For most case you should not need to modify them
 */
 
/**
 * @return string
 * @param digit $type
 * @param string $title
 * @param string $content
 * @desc Makes a call to SysBlock class to create a themed block
*/
function themeblock($type, $title, $content) 
{
   $sysblock = new SysBlock();
   echo $sysblock->showBlock($type, $title, $content, true);
}

/**
 * @return string html <img /> tag 
 * @param integer $pwidth  width of image
 * @param integer $pheight height of image
 * @desc Generates an image tag with a background of spacer graphics
 */
function pixel($pwidth=1, $pheight=1) {
    $return = "<img src='".THEME_IMAGE_URL."/pixel.gif' width='$pwidth' height='$pheight' />";
    return $return;
}

/**
 * @return string html for <td></td> 
 * @param integer $tdwidth The width of the cell
 * @param char $tdalign
 * @param string $background
 * @param integer $pwidth
 * @param integer $pheight
 * @desc Generated a table cell tag for graphics frame display
 */
function tdx(
    $tdwidth, 
    $tdalign='', 
    $background='', 
    $pwidth=false, 
    $pheight=1) 
{
    if ( $tdwidth == '' ) {
        if ( $pwidth !== false ) {
            $tdwidth = "width='$tdwidth' ";
        }
    } else {
        $tdwidth = "width='$tdwidth' ";
    }
       
    $align = array('l'=>'left', 'c'=>'center', 'r'=>'right');
    if ( !$tdalign == '' ){
        $tdalign = "align='".$align['$tdalign']."' ";
    }
   
    if ( !$background == '' ){
        $background = "background='".THEME_IMAGE_URL."/".$background.".gif'";
    }
    $pixel = '';
    if ( !$pwidth === false ) {
        $pixel = pixel($pwidth, $pheight);
    }
        
    $return  = "<td class='theme' $tdwidth $tdalign $background>";
    $return .= $pixel;
    $return .= "</td>";
    return $return;

}

function tdt(
    $tab,
    $tdwidth, 
    $tdalign='', 
    $image,
    $background='', 
    $iwidth, 
    $iheight) 
{
    $return = "
        <td align='$tdalign'>
            <img src='".THEME_IMAGE_URL."/$tab/$image.gif' 
                width='$iwidth' height='$iheight' />
        </td>";
    return $return;
}

/**
 * @return string html for the table row 
 * @param string $frame the prefix for the frame elements
 * @param string $edge 't' = top, 'b' = bottom
 * @param integer $width the corner element width
 * @param integer $height the corner element height
 * @desc Generates a 3 column row block for frame top or bottom
 */
function trx($frame, $edge, $width, $height)
{

    return "<tr class='theme' >
		".tdx($width, '', $frame."/".$edge.'.l', $height, $width)."
        ".tdx('', '', $frame."/".$edge.'.c', $height, $width)."
        ".tdx($width, '', $frame."/".$edge.'.r', $height, $width)."
	  </tr>";
}

/**
 * @return string html for frame display
 * @param string $frame the folde name for the frame graphics
 * @param integer $fwidth the width of the frame
 * @param integer $height the height of the corern segments
 * @param integer $width the width of the corner segments
 * @param string $content the html content to be displayed
 * @param string $background the backgroung image 
 * @desc Generates a 2-level nested table showing $content in a graphics frame
*/
function frameExt($frame, $fwidth, $height, $width, $content, $background='') 
{
    if ( $background == '' ) {
        $background = $frame."/back";
    }

    return "
    <table class='theme' cellspacing='0' >
	    <tr>
		    <td align='center'>
			    <table class='theme' style='width:$fwidth;' cellspacing='0' >
				    ".trx($frame, 't', $height, $width)."
				    <tr>
					    ".tdx('', '', $frame.'/l.c', $height, $width)."
					    <td align='center'  background='".THEME_IMAGE_URL."/".$background.".gif'>$content</td>
					    ".tdx('', '', $frame.'/r.c', $height, $width)."
				    ".trx($frame, 'b', $height, $width)."
			    </table>
		    </td>
	    </tr>
    </table>";
}
 
/**
 * @return string html for navBar
 * @param string $spacer spaces out the text links
 * @desc Generates a simple text navBar from the data in language global.php 
*/
function tabMenu($spacer='&nbsp;:&nbsp;') 
{
    global $navBar;
    
    $return = '<span>';
    foreach ( $navBar as $tab ) {
        $return .= "<a href='$tab[Link]'>$tab[Name]</a>$spacer";
    }
    $pos = strripos($spacer, $return);
    $return = substr($return, 0, $pos);
    $return = $return."</span>";
    return $return;
}

/**
 * @return integer if found or boolean false
 * @param string $needle
 * @param string $haystack
 * @desc findds the position of the last instance of $needle in $hatstack
 * strripos is supported in PHP5 this is a workaround for PHP4
 */
function strripos($needle, $haystack) 
{
     return strlen($haystack) - strlen($needle) 
            - strpos(strrev($haystack), strrev($needle));
}

/**
 * The following functions are deprecated and reatained for compatibility
 * Use function themeblock($type, $title, $content) 
 * where type is _SYS_CENTERBLOCK_CENTER etc.
 */

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a full-width center block
*/
function themecenterblock_center($title='', $content) 
{
   themeblock(SYS_CENTERBLOCK_CENTER, $title, $content);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a half-width center block
*/
function themecenterblock_right($title='', $content) 
{
   themeblock(SYS_CENTERBLOCK_RIGHT, $title, $content);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a half-width center block
*/
function themecenterblock_left($title='', $content) 
{
   themeblock(SYS_CENTERBLOCK_LEFT, $title, $content);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a right hand column block
*/
function themesideblock_right($title='', $content) 
{
   themeblock(SYS_SIDEBLOCK_RIGHT, $title, $content);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a left hand column block
*/
function themesideblock_left($title='', $content) 
{
   themeblock(SYS_SIDEBLOCK_LEFT, $title, $content);
}
