<?php
/**
 * Theme Name: fiblue (v1.2)
 * By Pnooka 
 */
define("SYS_THEME", "fiblue");

/**
 * Modify these variables to set the templates 
 * for the standard blocks for this theme. 
 * If all the blocks are the same 
 * you can set all the variables to the same template file. 
 */
$blockLayout[sideblockleft]     = 'sidebox_left.html';
$blockLayout[sideblockright]    = 'sidebox_right.html';
$blockLayout[centerblockleft]   = 'centerblock_left.html';
$blockLayout[centerblockright]  = 'centerblock_right.html';
$blockLayout[centerblockcenter] = 'centerblock_center.html';
$blockLayout[absolutetop]       = 'top.html';
$blockLayout[absolutebottom]    = 'bottom.html';

/**
 * @return void
 * @param unknown $show_rblock
 * @desc Enter description here...
*/
function themeheader($show_rblock=0)
{
    global $sysConfig, $sysUser, $meta;
    
    echo "
        <script type='text/javascript' 
            src='".SYS_ROOT_URL."/themes/".SYS_THEME."/language/".$sysConfig['language']."/date.js' >
        </script>";

    echo "</head><body onload='startclock();'>";
    openWaitBox();
    makeTopBlocks();
    echo "<table width='100%' border='0' cellspacing='0' cellpadding='0'>
            <tr>
                <td width='193'><a href='".SYS_ROOT_URL."'>
                    <img src='".SYS_ROOT_URL."/themes/".SYS_THEME."/images/logo.gif'
                        border='0' width='193' height='80' alt='".$meta['slogan']."' /></a></td>
                <td colspan='2' class='headb'>
                    <div align='center'>".showBannerHere()."</div></td>
            </tr>
            <tr>
                <td width='193' class='myclock' align='center'></td><td align='center' class='menu'>
                    <a href='"._LI_HOMES."'>"._TH_HOME."</a>&nbsp;&nbsp;
                    <a href='"._LI_ACCNT."'>"._TH_ACCOUNT."</a>&nbsp;&nbsp;
                    <a href='"._LI_DOWNL."'>"._TH_DOWNLOADS."</a>&nbsp;&nbsp;
                    <a href='"._LI_LINKS."'>"._TH_LINKS."</a>&nbsp;&nbsp;
                    <a href='"._LI_LINKF."'>"._TH_FORUM."</a>&nbsp;&nbsp;
                    <a href='"._LI_SECTI."'>"._TH_SECTIONS."</a>&nbsp;&nbsp;
                    <a href='"._LI_FAQMO."'>"._TH_FAQ."</a>
                </td>
                <td width='193' class='myclock' align='center'><div id='myclock'></div></td>
            </tr>
        </table>
        <table width='100%' border='0' align='center' cellpadding='3' cellspacing='0'>
            <tr>
                <td id='leftblocks' align='left'>".makeSidebar('left')."<br /></td>
                <td align='center' width='100%'>";
}

/**
 * @return void
 * @param unknown $show_rblock
 * @param unknown $footer
 * @desc Enter description here...
*/
function themefooter($show_rblock=false, $footer='')
{
    echo "
        <br /> </td>";
    if ( $show_rblock ) { 
        echo " <td id='rightblocks' align='right'>".makeSidebar('right')."></td>";
    } else { 
        echo "<td width='1' id='rightblocks' style='display:none;'>&nbsp;</td>"; 
    } 
    echo "  </tr>
            <tr>
                <td colspan='3' class='footer'>$footer</td>
            </tr>
        </table>";
}

/**
 * @return string
 * @param digit $type
 * @param string $title
 * @param string $content
 * @desc Makes a call to SysBlock class to create a themed block
*/
function themeblock($type, $title, $content) 
{
   $sysblock = new SysBlock();
   echo $sysblock->showBlock($type, $title, $content, true);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a full-width center block
*/
function themecenterblock_center($title='', $content) 
{
   themeblock(SYS_CENTERBLOCK_CENTER, $title, $content);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a half-width center block
*/
function themecenterblock_right($title='', $content) 
{
   themeblock(SYS_CENTERBLOCK_RIGHT, $title, $content);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a half-width center block
*/
function themecenterblock_left($title='', $content) 
{
   themeblock(SYS_CENTERBLOCK_LEFT, $title, $content);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a right hand column block
*/
function themesideblock_right($title='', $content) 
{
   themeblock(SYS_SIDEBLOCK_RIGHT, $title, $content);
}

/**
 * @return string
 * @param string $title
 * @param string $content
 * @desc Returns formatted html to display a left hand column block
*/
function themesideblock_left($title='', $content) 
{
   $type = SYS_SIDEBLOCK_LEFT;
   themeblock($type, $title, $content);
}

/**
 * @return void
 * @param unknown $poster
 * @param unknown $time
 * @param unknown $title
 * @param unknown $counter
 * @param unknown $thetext
 * @param unknown $timglink
 * @param unknown $adminlink
 * @param unknown $morelink
 * @desc Enter description here...
*/
function themenews (
    $poster,
    $time,
    $title,
    $counter,
    $thetext,
    $timglink,
    $adminlink,
    $morelink=''
    )
{
    echo "
    <table width='100%' border='0' cellpadding='0' cellspacing='0'>
        <tr class='bg1'>
            <td class='indextitle'>$title</td>
        </tr>
        <tr>
            <td class='indextable2'>
                <span class='postedby'>"._TH_POSTEDBY." ".$poster." "._TH_ON." ".$time." (".$counter." "._TH_READS.")
                </span>
                <div class='indextext'>$timglink $thetext</div>
            </td>
        </tr>
        <tr>
            <td class='more' align='right'>$adminlink $morelink</td>
    </tr></table><br />";
}