<?php
/**
 * File: $Id: user.php,v 1.27 2005/05/10 09:14:51 greyhead Exp $
 * Ciamos: Manages personal messages
 *
 * Ciamos - Content Management System
 *
 * :TODO: add detailed description of this file
 * @package Ciamos
 * @copyright (C) 2004 Ciamos Development Team.
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.ciamos.com
 *
 * @subpackage Ciamos_core
 * @link link to information for the subpackage
 * @author The Xoops Project (@link http://www.xoops.org)
 */

$sysOption['pagetype'] = 'user';
$sysOption['page_style'] = 8;

include_once('./mainfile.php');

if ( !$sys_request['op'] && $sysUser) {
        header("Location: userinfo.php?uid=".$sysUser->getVar("uid")."");
        exit();
}
include_once(SYS_ROOT_PATH."/include/header.php");
$sysOption['show_rblock'] = false;

/**
 * Main user login switch
 */

switch( $sys_request['op'] ) {

    case "logout":
        logoutUser();
        break;

    case "login":
        if ( !headers_sent() ) {
            header("Expires: Sat, 18 Aug 2002 05:30:00 GMT");
            header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
            header("Cache-Control: no-store, no-cache, max-age=1, s-maxage=1, must-revalidate, post-check=0, pre-check=0");
        }
        loginUser($sys_request['uname'], $sys_request['pass']);
        break;

    case "actv":
        activateUser($sys_request['id'], $sys_request['key']);
        break;

    case "delete":
        deleteUser($sys_request['ok']);
        break;

    default:
        main();
}

/**
 * @return void
 * @desc Enter description here...
 */
function main()
{
    global $sysUser, $sys_request, $sysConfig;

    if ( $sysUser ) {
        header("Location: userinfo.php?uid=".$sysUser->getVar("uid")."");
        exit();
    } else {        
        include_once(SYS_ROOT_PATH."/class/sysformloader.php");
        $value = "";
        if ( isset($sys_request[$sysConfig['cookie_name']]) && empty($sysConfig['cache_time']) ) {
            $value =  $sys_request[$sysConfig['cookie_name']];
        }
        $form1 = new SysThemeForm(_USERLOGIN, 'userLogin', 'user.php');
        $form1_array = array();
        
        $form1_array[] = new SysFormText(_NICKNAME, 'uname', 21, 30, $value);
        $form1_array[] = new SysFormPassword(_PASSWORD, 'pass');
        $form1_array[] = new SysFormButtonTray();
        $form1_array[] = new SysFormHidden('op', 'login');
        $form1_array[] = new SysFormLabel(_US_NOTREGISTERED, '');
        
        $form2 = new SysThemeForm(_US_LOSTPASSWORD, 'lostPass', 'lostpass.php');
        $form2_array = array();
        
        $form2_array[] = new SysFormLabel(_US_NOPROBLEM, '', true);
        $form2_array[] = new SysFormText(_US_YOUREMAIL, 'email', 26, 60);
        $form2_array[] = new SysFormRadio('', 'actkey', 1, array(_US_ACTKEY, _PASSWORD));
        $form2_array[] = new SysFormButtonTray();
        $form2_array[] = new SysFormHidden('op', 'mailpasswd');
        /**
         * Write page
         */
        include_once("include/header.php");
        $form1->display($form1_array, true);
        $form2->display($form2_array, true);
        include_once("include/footer.php");
    }
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function logoutUser()
{
    global $sysUser;

    if ( $sysUser ) {
        $sysUser->logoutUser();
    }
    redirectHeader("index.php", 1, _US_LOGGEDOUT."<br />"._US_THANKYOUFORVISIT."<br />");
    exit();
}

/**
* Description
*
* @param type $var description
* @return type description
*/
function loginUser($uname, $pass)
{
    global $sysHandler, $sysSecurity;

    $uname = trim($uname);
    $pass  = trim($pass);
    if ( !isset($uname) || !isset($pass) || $uname == "" || $pass == "" ) {
        $sysHandler['security']->showSecurityERR("user.php",1,_US_INCORRECTLOGIN);
    }
    $user = SysUser::loginUser($uname, $pass);
    if ( $user !== false ) {
        if ( !$user->getVar('level') ) {
            redirectHeader("index.php", 5, _US_NOACTTPADM);
            exit();
        }
        include_once(SYS_ROOT_PATH.'/class/sessions.class.php');
        $session = new SysUserSession();
        $session->setUid($user->getVar('uid'));
        $session->setUname($user->getVar('uname'));
        $session->setPass($user->getVar('pass'));
        if ( !$session->store() ) {
            redirectHeader("index.php", 1, _NOTUPDATED);
            exit();
        }
        $user->updateLastLogin();
        $url = (_HTTP_REFERER != "") ? _HTTP_REFERER : 'index.php';
        /**
         * If caching probs persist, turn this hack on
         */
        $url .= preg_match('#\&#', $url) ? '&'.time() : '?'.time();
        redirectHeader($url, 1, sprintf(_US_LOGGINGU, $user->getVar('uname')));
        exit();
    } else {
        $ab_time  = date("Y_m_d-H_i_s");
        $content  = "\n-----\n"._REMOTE_ADDR." tried to login and failed |";
        $content .= "".$date." Username: ".$uname." | Clear password: ".$pass."";
        $filename = SYS_ROOT_PATH."/cache/login.php";
        $file_size = filesize($filename);
        if ( $file_size == 0 ) {
            $phptext = "
                <"."?php
                // Nobody can see this from web browser
                echo \"You cannot view this file directly\";
                exit();
                ?".">";
            if ( $file = fopen($filename, "w") ) {
                fwrite($file, $phptext);
                fclose($file);
            }
        }
        if ( $file = fopen($filename, "a+") ) {
            fwrite($file, $content);
            fclose($file);
        }
        $sysHandler['security']->showSecurityERR("user.php",1,_US_INCORRECTLOGIN);
    }
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function activateUser($id, $key)
{
    global $db;

    if ( empty($id) || !is_numeric($id) ) {
        redirectHeader("index.php", 1, "");
        exit();
    }
    $thisuser = new SysUser($id);
    if ( $thisuser->actkey() != $key ) {
        redirectHeader("index.php", 5, _US_ACTKEYNOT);
        exit();
    } elseif ( $thisuser->isActive() ) {
        redirectHeader("user.php", 5, _US_ACONTACT);
        exit();
    } elseif ( $thisuser->activate() ) {
        redirectHeader("user.php", 5, _US_ACTLOGIN);
        exit();
    } else {
        redirectHeader("index.php", 5, "Activation failed!");
        exit();
    }
}

/**
 * Description
 *
 * @param type $var description
 * @return type description
 */
function deleteUser($ok = false)
{
    global $sys_request, $sysUser, $sysConfig, $sysHandler, $sysSecurity;

    if ( !$sysUser || !$sysConfig['self_delete'] ) {
        $sysHandler['security']->showSecurityERR("index.php", 2, _NOACTION);
    } elseif ( $ok == true ) {
        if ( !$sysUser->isAdmin() ) {
            // $sysUser->delete();
            redirectHeader("index.php", 3, _US_BEENDELED);
            exit();
        } else {
            redirectHeader("index.php", 5, _NOACTION);
            exit();
        }
    } else {
        include_once("include/header.php");
        echo "<h4>"._US_SURETODEL."</h4>"._US_REMOVEINFO."<br />
            <table><tr>
            <td>".myTextForm("user.php?op=delete&amp;ok=1", _YES)."</td>
            <td>".myTextForm("user.php", _NO)."</td>
            </tr></table>";
        include_once("include/footer.php");
        exit();
    }
}
?>
