<?php
/**
 * File: $Id: userinfo.php,v 1.32 2005/05/17 14:27:49 alphalogic Exp $
 *
 * Ciamos - Content Management System
 * :TODO: add detailed description of this file
 *
 * @package Ciamos
 * @copyright (C) 2005 Ciamos Development Team.
 * @link http://www.ciamos.com
 *
 * @subpackage Ciamos_core
 * @link link to information for the subpackage
 * @author The Xoops Project (@link http://www.xoops.org)
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 *
 */

$sysOption['pagetype'] = 'user';
$sysOption['page_style'] = 8;

include_once("./mainfile.php");
include_once(SYS_ROOT_PATH."/class/sysformloader.php");
$module_template -> setTemplate(SYS_THEME_PATH.'/templates/userinfo.html');
$uid = intval($sys_request['uid']);

if ( empty($uid) ) {
    redirectHeader("index.php", 3, _US_SELECTNG);
    exit();
}

if ( $sysUser && $uid == $sysUser->getVar("uid") ) {
    /**
     * I'm looking at my own profile
     */
    $thisUser =& $sysUser;
    $form_title = "<div class='modname'>"._US_THISISYOURPAGE."</div>";
} else {
    /**
     * I'm looking at another user's profile
     */
    $thisUser = new SysUser($uid);
    $form_title = "<div class='modname'>".sprintf(_US_PROFILEFOR, $thisUser->getVar("uname"))."</div>";
}
include_once("include/header.php");
if ( !$thisUser->isActive() ) {
    echo sprintf(_US_INACTIVE, $uid);
} else {
    $form = new SysThemeForm($form_title, 'userInfo', 'noAction');
    $form_array = array();
    if ( $thisUser->getVar("user_avatar") ) {
        $form_array[] = new SysFormLabel(_AVATAR, "<img src='images/avatar/".$thisUser->getVar("user_avatar")."' alt='' />");
    }
    if ( $sysUser && ($thisUser->getVar('name') != '') ) {
        $form_array[] = new SysFormLabel(_REALNAME, $thisUser->getVar("name"));
    }
    $form_array[] = new SysFormLabel(_US_MEMBERSINCE, formatTimestamp($thisUser->getVar("user_regdate"),"s"));
    $userrank = $thisUser->rank();
    $rank_image = "";
    if ( $userrank['image'] ) {
        $rank_image = "<br /><img src='".SYS_ROOT_URL."/images/ranks/".$userrank['image']."' alt='' /><br />";
    }
    $form_array[] = new SysFormLabel(_RANK, $userrank['title'].$rank_image);
    $form_array[] = new SysFormLabel(_US_POSTS, $thisUser->getVar("posts"));
    $date = $thisUser->getVar("last_login");
    if ( !empty($date) ) {
        $form_array[] = new SysFormLabel(_US_LASTLOGIN, formatTimestamp($date,"m"));
    }
    if ( $thisUser->getVar("user_sig") ) {
        $form_array[] = new SysFormLabel(_SIGNATURE, $myts->makeTareaData4Show($thisUser->getVar("user_sig", "N"), 0, 1, 1));
    }
    if ( $thisUser->getVar("url") != "" ) {
        $form_array[] = new SysFormLabel(_US_WEBSITE, "<a href='".$thisUser->getVar("url", "E")."' target='_blank'>"
        ."<img src=".$sys_image['www']." alt='".sprintf(_VISITWEBSITE, $thisUser->getVar("uname"))."'/></a>");
    }
    if ( $sysUser ) {
        if ( $sysUser->getVar("uid") == $thisUser->getVar("uid") || $thisUser->getVar("user_viewemail") ) {
            $form_array[] = new SysFormLabel(_EMAIL, "<a href='mailto:".$thisUser->getVar("email", "E")."'>"
            ."<img src='".$sys_image['email']."' alt='".sprintf(_SENDEMAILTO, $thisUser->getVar("uname"))."' /></a>");
        }
        $form_array[] = new SysFormLabel(_PM, "<a href='".SYS_MOD_URL."/pms/pmlite.php?send=1&to_userid=".$thisUser->getVar("uid")."'>"
        ."<img src='".$sys_image['pm']."' alt='".sprintf(_SENDPMTO, $thisUser->getVar("uname"))."' />");
        if ( $thisUser->getVar("user_icq") ) {
            $form_array[] = new SysFormLabel(_ICQ, $thisUser->getVar("user_icq"));
        }
        if ( $thisUser->getVar("user_aim") ) {
            $form_array[] = new SysFormLabel(_AIM, $thisUser->getVar("user_aim"));
        }
        if ( $thisUser->getVar("user_yim") ) {
            $form_array[] = new SysFormLabel(_YIM, $thisUser->getVar("user_yim"));
        }
        if ( $thisUser->getVar("user_msnm") ) {
            $form_array[] = new SysFormLabel(_MSNM, $thisUser->getVar("user_msnm"));
        }
    }
    if ( $thisUser->getVar("user_from") ) {
        $form_array[] = new SysFormLabel(_LOCATION, $thisUser->getVar("user_from"));
    }
    if ( $thisUser->getVar("user_occ") ) {
        $form_array[] = new SysFormLabel(_OCCUPATION, $thisUser->getVar("user_occ"));
    }
    if ( $thisUser->getVar("user_interest") ) {
        $form_array[] = new SysFormLabel(_INTEREST, $thisUser->getVar("user_interest"));
    }
    if ( $thisUser->getVar("bio") ) {
        $form_array[] = new SysFormLabel(_US_EXTRAINFO, $myts->makeTareaData4Show($thisUser->getVar("bio", "N"), 0, 1, 1));
    }
    
    if ( $sysUser && $uid == $sysUser->getVar("uid") ) {
        $button_array[] = new SysFormButton('', 'editprofile', _US_EDITPROFILE, 'button', "onclick=\"location='edituser.php'\"");
        $button_array[] = new SysFormButton('', 'inbox', _INBOX, 'button', "onclick=\"location='".SYS_MOD_FOLDER."/pms/'\"");
        if ( $sysConfig['avatar_allow_upload'] == true ) {
            $button_array[] = new SysFormButton('', 'avatar', _US_UPLOADMYAVATAR, 'button', "onclick=\"location='edituser.php?op=avatarform'\"");
        }
        $button_array[] = new SysFormButton('', 'logout', _LOGOUT, 'button', "onclick=\"location='user.php?op=logout'\"");
        if ( $sysConfig['self_delete'] ) {
            $button_array[] = new SysFormButton('', 'delete', _US_DELACCOUNT, 'button', "onclick=\"location='user.php?op=delete'\"");
        }
        $form_array[] = new SysFormElementTray(_ACTION, '&nbsp;', $button_array);
    }
    
    $module_template -> setOutputVar('form_user', $form->display($form_array, true, false));
}

$mids   =& SysModule::getHasSearchModulesList(false);
/**
 * Step through modules with Search functions
 */
foreach ( $mids as $mid ) {
    $module  = new SysModule($mid);
    $results = array();
    $results = $module->search("", "", 5, 0, $thisUser->getVar("uid"));
    $count   = count($results);

    if ( is_array($results) && $count) {
        $form_title = $module->name();

        $form = new SysThemeForm($form_title, 'showall'.$mid, 'search.php');
        $form_array = array();

        for ( $i = 0; $i < $count; $i++ ) {
            if ( isset($results[$i]['image']) && $results[$i]['image'] ) {
                $output = "<img src='".SYS_MOD_URL."/".$module->dirname()."/".$results[$i]['image']."' alt='".$module->name()."' />&nbsp;";
            } else {
                $output = "<img src='images/icons/posticon.gif' alt='".$module->name()."' />&nbsp;";
            }
            $output .= "<strong><a href='".SYS_MOD_URL."/".$module->dirname()."/".$results[$i]['link']."'>".$myts->makeTboxData4Show($results[$i]['title'])."</a></strong>";
            if ( $results[$i]['time'] ) {
                $output .= "<br /> (". formatTimestamp($results[$i]['time']).")";
            }
            $form_array[] = new SysFormLabel('', $output);
        }
        /**
         * If there are more than 5 results offer 'Show all results'
         */
        if ( $count >= 5 ) {
            $form_array[] = new SysFormHidden('mid', $mid);
            $form_array[] = new SysFormHidden('action', showall);
            $form_array[] = new SysFormHidden('andor', $andor);
            $form_array[] = new SysFormHidden('uid', $uid);
            $form_array[] = new SysFormLabel('', "<a onclick='sysGetElementById(\"showall".$mid."\").submit();'>"._US_SHOWALL."</a>");
        }
        $module_template -> setOutputVar('form_user_modules',$form->display($form_array, true, false));
    }
}
include_once('include/footer.php');
?>
